# clojure-eval

This package aims to implement Clojure evaluation support for the [CodeMirror](https://codemirror.net/) code editor.

[What do we mean by evaluation support?](https://calva.io/eval-tips/)

## API Reference
<dl>
<dt>
  <code><strong><a href="#">clojure</a></strong>() → <a href="https://codemirror.net/docs/ref#language.LanguageSupport">LanguageSupport</a></code></dt>

<dd><p>Clojure language support.</p>
</dd>
<dt>
  <code><strong><a href="#">clojureLanguage</a></strong>: <a href="https://codemirror.net/docs/ref#language.LezerLanguage">LRLanguage</a></code></dt>

<dd><p>A language provider based on the <a href="https://github.com/nextjournal/lezer-clojure">Lezer Clojure
parser</a>, extended with
highlighting and indentation information.</p>
</dd>
</dl>

## Development

```
yarn install
```

Run demo locally

```
yarn dev
```

Build dist

```
yarn prepare
```

## Credits

https://nextjournal.github.io/lang-clojure