import "./cljs_env.js";
goog.provide('sci.impl.evaluator');

sci.impl.evaluator.macros = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Symbol(null,"fn","fn",465265323,null),"null",new cljs.core.Symbol(null,"do","do",1686842252,null),"null",new cljs.core.Symbol(null,"defn","defn",-126010802,null),"null",new cljs.core.Symbol(null,"syntax-quote","syntax-quote",407366680,null),"null",new cljs.core.Symbol(null,"def","def",597100991,null),"null"], null), null);
/**
 * The and macro from clojure.core. Note: and is unrolled in the analyzer, this is a fallback.
 */
sci.impl.evaluator.eval_and = (function sci$impl$evaluator$eval_and(ctx,bindings,args){
var args__$1 = cljs.core.seq(args);
var args__$2 = args__$1;
while(true){
if(args__$2){
var x = cljs.core.first(args__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,x) : sci.impl.evaluator.eval.call(null,ctx,bindings,x));
if(cljs.core.truth_(v)){
var xs = cljs.core.next(args__$2);
if(xs){
var G__58278 = xs;
args__$2 = G__58278;
continue;
} else {
return v;
}
} else {
return v;
}
} else {
return true;
}
break;
}
});
/**
 * The or macro from clojure.core. Note: or is unrolled in the analyzer, this is a fallback.
 */
sci.impl.evaluator.eval_or = (function sci$impl$evaluator$eval_or(ctx,bindings,args){
var args__$1 = cljs.core.seq(args);
var args__$2 = args__$1;
while(true){
if(args__$2){
var x = cljs.core.first(args__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,x) : sci.impl.evaluator.eval.call(null,ctx,bindings,x));
if(cljs.core.truth_(v)){
return v;
} else {
var xs = cljs.core.next(args__$2);
if(xs){
var G__58280 = xs;
args__$2 = G__58280;
continue;
} else {
return v;
}
}
} else {
return null;
}
break;
}
});
/**
 * The let macro from clojure.core
 */
sci.impl.evaluator.eval_let = (function sci$impl$evaluator$eval_let(ctx,bindings,let_bindings,exprs){
var vec__57182 = (function (){var ctx__$1 = ctx;
var bindings__$1 = bindings;
var let_bindings__$1 = let_bindings;
while(true){
var let_name = cljs.core.first(let_bindings__$1);
var let_bindings__$2 = cljs.core.rest(let_bindings__$1);
var let_val = cljs.core.first(let_bindings__$2);
var rest_let_bindings = cljs.core.next(let_bindings__$2);
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx__$1,bindings__$1,let_val) : sci.impl.evaluator.eval.call(null,ctx__$1,bindings__$1,let_val));
var bindings__$2 = cljs.core._assoc(bindings__$1,let_name,v);
if(cljs.core.not(rest_let_bindings)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [ctx__$1,bindings__$2], null);
} else {
var G__58283 = ctx__$1;
var G__58284 = bindings__$2;
var G__58285 = rest_let_bindings;
ctx__$1 = G__58283;
bindings__$1 = G__58284;
let_bindings__$1 = G__58285;
continue;
}
break;
}
})();
var ctx__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57182,(0),null);
var bindings__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57182,(1),null);
if(cljs.core.truth_(exprs)){
var exprs__$1 = exprs;
while(true){
var e = cljs.core.first(exprs__$1);
var ret = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx__$1,bindings__$1,e) : sci.impl.evaluator.eval.call(null,ctx__$1,bindings__$1,e));
var nexprs = cljs.core.next(exprs__$1);
if(nexprs){
var G__58286 = nexprs;
exprs__$1 = G__58286;
continue;
} else {
return ret;
}
break;
}
} else {
return null;
}
});
sci.impl.evaluator.handle_meta = (function sci$impl$evaluator$handle_meta(ctx,bindings,m){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2((function (){var temp__5751__auto__ = cljs.core.meta(m);
if(cljs.core.truth_(temp__5751__auto__)){
var mm = temp__5751__auto__;
if(cljs.core.truth_((cljs.core.truth_(mm)?mm.get(new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978)):null))){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,m) : sci.impl.evaluator.eval.call(null,ctx,bindings,m));
} else {
return m;
}
} else {
return m;
}
})(),new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978));
});
sci.impl.evaluator.eval_map = (function sci$impl$evaluator$eval_map(ctx,bindings,expr){
var temp__5751__auto__ = cljs.core.meta(expr);
if(cljs.core.truth_(temp__5751__auto__)){
var m = temp__5751__auto__;
if(cljs.core.truth_((function (){var G__57241 = new cljs.core.Keyword(null,"eval","eval",-1103567905);
var G__57242 = new cljs.core.Keyword("sci.impl","op","sci.impl/op",950953978).cljs$core$IFn$_invoke$arity$1(m);
return (sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(G__57241,G__57242) : sci.impl.utils.kw_identical_QMARK_.call(null,G__57241,G__57242));
})())){
return cljs.core.with_meta(cljs.core.zipmap(cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__57239_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__57239_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__57239_SHARP_));
}),cljs.core.keys(expr)),cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__57240_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__57240_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__57240_SHARP_));
}),cljs.core.vals(expr))),sci.impl.evaluator.handle_meta(ctx,bindings,m));
} else {
return expr;
}
} else {
return expr;
}
});
sci.impl.evaluator.eval_def = (function sci$impl$evaluator$eval_def(ctx,bindings,var_name,init,m){
var init__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,init) : sci.impl.evaluator.eval.call(null,ctx,bindings,init));
var m__$1 = (function (){var or__4223__auto__ = m;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.meta(var_name);
}
})();
var m__$2 = sci.impl.evaluator.eval_map(ctx,bindings,m__$1);
var cnn = sci.impl.vars.getName(new cljs.core.Keyword(null,"ns","ns",441598760).cljs$core$IFn$_invoke$arity$1(m__$2));
var assoc_in_env = (function (env){
var the_current_ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(env,new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469)),cnn);
var prev = cljs.core.get.cljs$core$IFn$_invoke$arity$2(the_current_ns,var_name);
var prev__$1 = (((!(sci.impl.vars.var_QMARK_(prev))))?sci.impl.vars.__GT_SciVar(prev,cljs.core.symbol.cljs$core$IFn$_invoke$arity$2(cljs.core.str.cljs$core$IFn$_invoke$arity$1(cnn),cljs.core.str.cljs$core$IFn$_invoke$arity$1(var_name)),cljs.core.meta(prev),false):prev);
var v = (cljs.core.truth_((sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword("sci.impl","var.unbound","sci.impl/var.unbound",-1824207647),init__$1) : sci.impl.utils.kw_identical_QMARK_.call(null,new cljs.core.Keyword("sci.impl","var.unbound","sci.impl/var.unbound",-1824207647),init__$1)))?(function (){var G__57243 = prev__$1;
cljs.core.alter_meta_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__57243,cljs.core.merge,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([m__$2], 0));

return G__57243;
})():(function (){
sci.impl.vars.bindRoot(prev__$1,init__$1);

cljs.core.alter_meta_BANG_.cljs$core$IFn$_invoke$arity$variadic(prev__$1,cljs.core.merge,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([m__$2], 0));

return prev__$1;
})()
);
var the_current_ns__$1 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(the_current_ns,var_name,v);
return cljs.core.assoc_in(env,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn], null),the_current_ns__$1);
});
var env = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"env","env",-1815813235).cljs$core$IFn$_invoke$arity$1(ctx),assoc_in_env);
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$2(env,new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469)),cnn),var_name);
});
sci.impl.evaluator.eval_case = (function sci$impl$evaluator$eval_case(var_args){
var G__57245 = arguments.length;
switch (G__57245) {
case 4:
return sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$4 = (function (ctx,bindings,case_map,case_val){
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_val) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_val));
var temp__5751__auto__ = cljs.core.find(case_map,v);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__57253 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57253,(0),null);
var found = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57253,(1),null);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,found) : sci.impl.evaluator.eval.call(null,ctx,bindings,found));
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('')));
}
}));

(sci.impl.evaluator.eval_case.cljs$core$IFn$_invoke$arity$5 = (function (ctx,bindings,case_map,case_val,case_default){
var v = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_val) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_val));
var temp__5751__auto__ = cljs.core.find(case_map,v);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__57257 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57257,(0),null);
var found = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57257,(1),null);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,found) : sci.impl.evaluator.eval.call(null,ctx,bindings,found));
} else {
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,case_default) : sci.impl.evaluator.eval.call(null,ctx,bindings,case_default));
}
}));

(sci.impl.evaluator.eval_case.cljs$lang$maxFixedArity = 5);

sci.impl.evaluator.eval_try = (function sci$impl$evaluator$eval_try(ctx,bindings,body,catches,finally$){
try{var _STAR_in_try_STAR__orig_val__57297 = sci.impl.utils._STAR_in_try_STAR_;
var _STAR_in_try_STAR__temp_val__57298 = true;
(sci.impl.utils._STAR_in_try_STAR_ = _STAR_in_try_STAR__temp_val__57298);

try{return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,body) : sci.impl.evaluator.eval.call(null,ctx,bindings,body));
}finally {(sci.impl.utils._STAR_in_try_STAR_ = _STAR_in_try_STAR__orig_val__57297);
}}catch (e57263){if((e57263 instanceof Error)){
var e = e57263;
var temp__5751__auto__ = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (_,c){
var clazz = new cljs.core.Keyword(null,"class","class",-2030961996).cljs$core$IFn$_invoke$arity$1(c);
if(cljs.core.truth_((function (){var or__4223__auto__ = (sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2 ? sci.impl.utils.kw_identical_QMARK_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"default","default",-1987822328),clazz) : sci.impl.utils.kw_identical_QMARK_.call(null,new cljs.core.Keyword(null,"default","default",-1987822328),clazz));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
if((clazz instanceof sci.impl.types.EvalFn)){
var c__4254__auto__ = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,clazz) : sci.impl.evaluator.eval.call(null,ctx,bindings,clazz));
var x__4255__auto__ = e;
return (x__4255__auto__ instanceof c__4254__auto__);
} else {
return (e instanceof clazz);
}
}
})())){
return cljs.core.reduced(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("sci.impl.evaluator","try-result","sci.impl.evaluator/try-result",-1394897780),(function (){var G__57264 = ctx;
var G__57265 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(bindings,new cljs.core.Keyword(null,"binding","binding",539932593).cljs$core$IFn$_invoke$arity$1(c),e);
var G__57266 = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(c);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57264,G__57265,G__57266) : sci.impl.evaluator.eval.call(null,G__57264,G__57265,G__57266));
})()], null));
} else {
return null;
}
}),null,catches);
if(cljs.core.truth_(temp__5751__auto__)){
var vec__57294 = temp__5751__auto__;
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57294,(0),null);
var r = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57294,(1),null);
return r;
} else {
return sci.impl.utils.rethrow_with_location_of_node.cljs$core$IFn$_invoke$arity$4(ctx,bindings,e,body);
}
} else {
throw e57263;

}
}finally {(sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,finally$) : sci.impl.evaluator.eval.call(null,ctx,bindings,finally$));
}});
sci.impl.evaluator.eval_static_method_invocation = (function sci$impl$evaluator$eval_static_method_invocation(ctx,bindings,expr){
return sci.impl.interop.invoke_static_method(cljs.core.first(expr),cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__57299_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__57299_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__57299_SHARP_));
}),cljs.core.rest(expr)));
});
sci.impl.evaluator.eval_instance_method_invocation = (function sci$impl$evaluator$eval_instance_method_invocation(ctx,bindings,instance_expr,method_str,args){
var instance_meta = cljs.core.meta(instance_expr);
var tag_class = new cljs.core.Keyword(null,"tag-class","tag-class",714967874).cljs$core$IFn$_invoke$arity$1(instance_meta);
var instance_expr_STAR_ = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,instance_expr) : sci.impl.evaluator.eval.call(null,ctx,bindings,instance_expr));
if(cljs.core.truth_((function (){var and__4221__auto__ = cljs.core.map_QMARK_(instance_expr_STAR_);
if(and__4221__auto__){
return new cljs.core.Keyword("sci.impl","record","sci.impl/record",-1939193950).cljs$core$IFn$_invoke$arity$1(cljs.core.meta(instance_expr_STAR_));
} else {
return and__4221__auto__;
}
})())){
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(instance_expr_STAR_,cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(method_str,(1))));
} else {
var instance_class = (function (){var or__4223__auto__ = tag_class;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.type(instance_expr_STAR_);
}
})();
var instance_class_name = instance_class.name;
var instance_class_symbol = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(instance_class_name);
var class__GT_opts = new cljs.core.Keyword(null,"class->opts","class->opts",2061906477).cljs$core$IFn$_invoke$arity$1(ctx);
var allowed_QMARK_ = (function (){var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(class__GT_opts,new cljs.core.Keyword(null,"allow","allow",-1857325745));
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(class__GT_opts,instance_class_symbol);
}
})();
var target_class = (cljs.core.truth_(allowed_QMARK_)?instance_class:(function (){var temp__5753__auto__ = new cljs.core.Keyword(null,"public-class","public-class",1127293019).cljs$core$IFn$_invoke$arity$1(ctx);
if(cljs.core.truth_(temp__5753__auto__)){
var f = temp__5753__auto__;
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(instance_expr_STAR_) : f.call(null,instance_expr_STAR_));
} else {
return null;
}
})());
if(cljs.core.truth_(target_class)){
} else {
sci.impl.utils.throw_error_with_location.cljs$core$IFn$_invoke$arity$2(["Method ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(method_str)," on ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(instance_class)," not allowed!"].join(''),instance_expr);
}

var args__$1 = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__57305_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__57305_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__57305_SHARP_));
}),args);
return sci.impl.interop.invoke_instance_method(instance_expr_STAR_,target_class,method_str,args__$1);
}
});
sci.impl.evaluator.eval_resolve = (function sci$impl$evaluator$eval_resolve(var_args){
var G__57308 = arguments.length;
switch (G__57308) {
case 3:
return sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$3 = (function (ctx,bindings,sym){
var sym__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,sym) : sci.impl.evaluator.eval.call(null,ctx,bindings,sym));
return cljs.core.second((function (){var fexpr__57309 = cljs.core.deref(sci.impl.utils.lookup);
return (fexpr__57309.cljs$core$IFn$_invoke$arity$3 ? fexpr__57309.cljs$core$IFn$_invoke$arity$3(ctx,sym__$1,false) : fexpr__57309.call(null,ctx,sym__$1,false));
})());
}));

(sci.impl.evaluator.eval_resolve.cljs$core$IFn$_invoke$arity$4 = (function (ctx,bindings,env,sym){
if(cljs.core.contains_QMARK_(env,sym)){
return null;
} else {
var sym__$1 = (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,sym) : sci.impl.evaluator.eval.call(null,ctx,bindings,sym));
return cljs.core.second((function (){var fexpr__57310 = cljs.core.deref(sci.impl.utils.lookup);
return (fexpr__57310.cljs$core$IFn$_invoke$arity$3 ? fexpr__57310.cljs$core$IFn$_invoke$arity$3(ctx,sym__$1,false) : fexpr__57310.call(null,ctx,sym__$1,false));
})());
}
}));

(sci.impl.evaluator.eval_resolve.cljs$lang$maxFixedArity = 4);

cljs.core.vreset_BANG_(sci.impl.utils.eval_resolve_state,sci.impl.evaluator.eval_resolve);
sci.impl.evaluator.eval_import = (function sci$impl$evaluator$eval_import(var_args){
var args__4835__auto__ = [];
var len__4829__auto___58503 = arguments.length;
var i__4830__auto___58504 = (0);
while(true){
if((i__4830__auto___58504 < len__4829__auto___58503)){
args__4835__auto__.push((arguments[i__4830__auto___58504]));

var G__58505 = (i__4830__auto___58504 + (1));
i__4830__auto___58504 = G__58505;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((1) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((1)),(0),null)):null);
return sci.impl.evaluator.eval_import.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4836__auto__);
});

(sci.impl.evaluator.eval_import.cljs$core$IFn$_invoke$arity$variadic = (function (ctx,import_symbols_or_lists){
var specs = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__57311_SHARP_){
if(((cljs.core.seq_QMARK_(p1__57311_SHARP_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.first(p1__57311_SHARP_))))){
return cljs.core.second(p1__57311_SHARP_);
} else {
return p1__57311_SHARP_;
}
}),import_symbols_or_lists);
var env = new cljs.core.Keyword(null,"env","env",-1815813235).cljs$core$IFn$_invoke$arity$1(ctx);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (_,spec){
var vec__57314 = (((spec instanceof cljs.core.Symbol))?(function (){var s = cljs.core.str.cljs$core$IFn$_invoke$arity$1(spec);
var last_dot = clojure.string.last_index_of.cljs$core$IFn$_invoke$arity$2(s,".");
var package_PLUS_class_name = (cljs.core.truth_(last_dot)?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$3(s,(0),last_dot)),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$3(s,(last_dot + (1)),((s).length)))], null)], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [spec], null)], null));
return package_PLUS_class_name;
})():(function (){var p = cljs.core.first(spec);
var cs = cljs.core.rest(spec);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cs], null);
})());
var package$ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57314,(0),null);
var classes = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__57314,(1),null);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (___$1,class$){
var fq_class_name = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1((cljs.core.truth_(package$)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(package$),".",cljs.core.str.cljs$core$IFn$_invoke$arity$1(class$)].join(''):class$));
var temp__5751__auto__ = sci.impl.interop.resolve_class(ctx,fq_class_name);
if(cljs.core.truth_(temp__5751__auto__)){
var clazz = temp__5751__auto__;
var cnn = sci.impl.vars.current_ns_name();
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(env,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn,new cljs.core.Keyword(null,"imports","imports",-1249933394),class$], null),fq_class_name);

return clazz;
} else {
var temp__5751__auto____$1 = sci.impl.records.resolve_record_or_protocol_class.cljs$core$IFn$_invoke$arity$3(ctx,package$,class$);
if(cljs.core.truth_(temp__5751__auto____$1)){
var rec = temp__5751__auto____$1;
var cnn = sci.impl.vars.current_ns_name();
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(env,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespaces","namespaces",-1444157469),cnn,class$], null),rec);

return rec;
} else {
throw (new Error(["Unable to resolve classname: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fq_class_name)].join('')));
}
}
}),null,classes);
}),null,specs);
}));

(sci.impl.evaluator.eval_import.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(sci.impl.evaluator.eval_import.cljs$lang$applyTo = (function (seq57312){
var G__57313 = cljs.core.first(seq57312);
var seq57312__$1 = cljs.core.next(seq57312);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__57313,seq57312__$1);
}));

/**
 * Note: various arities of do have already been unrolled in the analyzer.
 */
sci.impl.evaluator.eval_do = (function sci$impl$evaluator$eval_do(ctx,bindings,exprs){
var exprs__$1 = cljs.core.seq(exprs);
var exprs__$2 = exprs__$1;
while(true){
if(exprs__$2){
var ret = (function (){var G__57317 = ctx;
var G__57318 = bindings;
var G__57319 = cljs.core.first(exprs__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57317,G__57318,G__57319) : sci.impl.evaluator.eval.call(null,G__57317,G__57318,G__57319));
})();
var temp__5751__auto__ = cljs.core.next(exprs__$2);
if(temp__5751__auto__){
var exprs__$3 = temp__5751__auto__;
var G__58607 = exprs__$3;
exprs__$2 = G__58607;
continue;
} else {
return ret;
}
} else {
return null;
}
break;
}
});
cljs.core.vreset_BANG_(sci.impl.utils.eval_do_STAR_,sci.impl.evaluator.eval_do);
sci.impl.evaluator.fn_call = (function sci$impl$evaluator$fn_call(ctx,bindings,f,args){
var G__57514 = cljs.core.count(args);
switch (G__57514) {
case (0):
return (f.cljs$core$IFn$_invoke$arity$0 ? f.cljs$core$IFn$_invoke$arity$0() : f.call(null));

break;
case (1):
var arg57324 = (function (){var G__57515 = ctx;
var G__57516 = bindings;
var G__57517 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57515,G__57516,G__57517) : sci.impl.evaluator.eval.call(null,G__57515,G__57516,G__57517));
})();
var args__$1 = cljs.core.rest(args);
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(arg57324) : f.call(null,arg57324));

break;
case (2):
var arg57325 = (function (){var G__57518 = ctx;
var G__57519 = bindings;
var G__57520 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57518,G__57519,G__57520) : sci.impl.evaluator.eval.call(null,G__57518,G__57519,G__57520));
})();
var args__$1 = cljs.core.rest(args);
var arg57326 = (function (){var G__57521 = ctx;
var G__57522 = bindings;
var G__57523 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57521,G__57522,G__57523) : sci.impl.evaluator.eval.call(null,G__57521,G__57522,G__57523));
})();
var args__$2 = cljs.core.rest(args__$1);
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(arg57325,arg57326) : f.call(null,arg57325,arg57326));

break;
case (3):
var arg57327 = (function (){var G__57524 = ctx;
var G__57525 = bindings;
var G__57526 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57524,G__57525,G__57526) : sci.impl.evaluator.eval.call(null,G__57524,G__57525,G__57526));
})();
var args__$1 = cljs.core.rest(args);
var arg57328 = (function (){var G__57527 = ctx;
var G__57528 = bindings;
var G__57529 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57527,G__57528,G__57529) : sci.impl.evaluator.eval.call(null,G__57527,G__57528,G__57529));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57329 = (function (){var G__57530 = ctx;
var G__57531 = bindings;
var G__57532 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57530,G__57531,G__57532) : sci.impl.evaluator.eval.call(null,G__57530,G__57531,G__57532));
})();
var args__$3 = cljs.core.rest(args__$2);
return (f.cljs$core$IFn$_invoke$arity$3 ? f.cljs$core$IFn$_invoke$arity$3(arg57327,arg57328,arg57329) : f.call(null,arg57327,arg57328,arg57329));

break;
case (4):
var arg57330 = (function (){var G__57533 = ctx;
var G__57534 = bindings;
var G__57535 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57533,G__57534,G__57535) : sci.impl.evaluator.eval.call(null,G__57533,G__57534,G__57535));
})();
var args__$1 = cljs.core.rest(args);
var arg57331 = (function (){var G__57536 = ctx;
var G__57537 = bindings;
var G__57538 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57536,G__57537,G__57538) : sci.impl.evaluator.eval.call(null,G__57536,G__57537,G__57538));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57332 = (function (){var G__57539 = ctx;
var G__57540 = bindings;
var G__57541 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57539,G__57540,G__57541) : sci.impl.evaluator.eval.call(null,G__57539,G__57540,G__57541));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57333 = (function (){var G__57549 = ctx;
var G__57550 = bindings;
var G__57551 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57549,G__57550,G__57551) : sci.impl.evaluator.eval.call(null,G__57549,G__57550,G__57551));
})();
var args__$4 = cljs.core.rest(args__$3);
return (f.cljs$core$IFn$_invoke$arity$4 ? f.cljs$core$IFn$_invoke$arity$4(arg57330,arg57331,arg57332,arg57333) : f.call(null,arg57330,arg57331,arg57332,arg57333));

break;
case (5):
var arg57334 = (function (){var G__57552 = ctx;
var G__57553 = bindings;
var G__57554 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57552,G__57553,G__57554) : sci.impl.evaluator.eval.call(null,G__57552,G__57553,G__57554));
})();
var args__$1 = cljs.core.rest(args);
var arg57335 = (function (){var G__57555 = ctx;
var G__57556 = bindings;
var G__57557 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57555,G__57556,G__57557) : sci.impl.evaluator.eval.call(null,G__57555,G__57556,G__57557));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57336 = (function (){var G__57558 = ctx;
var G__57559 = bindings;
var G__57560 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57558,G__57559,G__57560) : sci.impl.evaluator.eval.call(null,G__57558,G__57559,G__57560));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57337 = (function (){var G__57561 = ctx;
var G__57562 = bindings;
var G__57563 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57561,G__57562,G__57563) : sci.impl.evaluator.eval.call(null,G__57561,G__57562,G__57563));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57338 = (function (){var G__57564 = ctx;
var G__57565 = bindings;
var G__57566 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57564,G__57565,G__57566) : sci.impl.evaluator.eval.call(null,G__57564,G__57565,G__57566));
})();
var args__$5 = cljs.core.rest(args__$4);
return (f.cljs$core$IFn$_invoke$arity$5 ? f.cljs$core$IFn$_invoke$arity$5(arg57334,arg57335,arg57336,arg57337,arg57338) : f.call(null,arg57334,arg57335,arg57336,arg57337,arg57338));

break;
case (6):
var arg57339 = (function (){var G__57567 = ctx;
var G__57568 = bindings;
var G__57569 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57567,G__57568,G__57569) : sci.impl.evaluator.eval.call(null,G__57567,G__57568,G__57569));
})();
var args__$1 = cljs.core.rest(args);
var arg57340 = (function (){var G__57570 = ctx;
var G__57571 = bindings;
var G__57572 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57570,G__57571,G__57572) : sci.impl.evaluator.eval.call(null,G__57570,G__57571,G__57572));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57341 = (function (){var G__57573 = ctx;
var G__57574 = bindings;
var G__57575 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57573,G__57574,G__57575) : sci.impl.evaluator.eval.call(null,G__57573,G__57574,G__57575));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57342 = (function (){var G__57576 = ctx;
var G__57577 = bindings;
var G__57578 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57576,G__57577,G__57578) : sci.impl.evaluator.eval.call(null,G__57576,G__57577,G__57578));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57343 = (function (){var G__57579 = ctx;
var G__57580 = bindings;
var G__57581 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57579,G__57580,G__57581) : sci.impl.evaluator.eval.call(null,G__57579,G__57580,G__57581));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57344 = (function (){var G__57584 = ctx;
var G__57585 = bindings;
var G__57586 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57584,G__57585,G__57586) : sci.impl.evaluator.eval.call(null,G__57584,G__57585,G__57586));
})();
var args__$6 = cljs.core.rest(args__$5);
return (f.cljs$core$IFn$_invoke$arity$6 ? f.cljs$core$IFn$_invoke$arity$6(arg57339,arg57340,arg57341,arg57342,arg57343,arg57344) : f.call(null,arg57339,arg57340,arg57341,arg57342,arg57343,arg57344));

break;
case (7):
var arg57345 = (function (){var G__57587 = ctx;
var G__57588 = bindings;
var G__57589 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57587,G__57588,G__57589) : sci.impl.evaluator.eval.call(null,G__57587,G__57588,G__57589));
})();
var args__$1 = cljs.core.rest(args);
var arg57346 = (function (){var G__57590 = ctx;
var G__57591 = bindings;
var G__57592 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57590,G__57591,G__57592) : sci.impl.evaluator.eval.call(null,G__57590,G__57591,G__57592));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57347 = (function (){var G__57593 = ctx;
var G__57594 = bindings;
var G__57595 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57593,G__57594,G__57595) : sci.impl.evaluator.eval.call(null,G__57593,G__57594,G__57595));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57348 = (function (){var G__57596 = ctx;
var G__57597 = bindings;
var G__57598 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57596,G__57597,G__57598) : sci.impl.evaluator.eval.call(null,G__57596,G__57597,G__57598));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57349 = (function (){var G__57599 = ctx;
var G__57600 = bindings;
var G__57601 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57599,G__57600,G__57601) : sci.impl.evaluator.eval.call(null,G__57599,G__57600,G__57601));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57350 = (function (){var G__57602 = ctx;
var G__57603 = bindings;
var G__57604 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57602,G__57603,G__57604) : sci.impl.evaluator.eval.call(null,G__57602,G__57603,G__57604));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57351 = (function (){var G__57605 = ctx;
var G__57606 = bindings;
var G__57607 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57605,G__57606,G__57607) : sci.impl.evaluator.eval.call(null,G__57605,G__57606,G__57607));
})();
var args__$7 = cljs.core.rest(args__$6);
return (f.cljs$core$IFn$_invoke$arity$7 ? f.cljs$core$IFn$_invoke$arity$7(arg57345,arg57346,arg57347,arg57348,arg57349,arg57350,arg57351) : f.call(null,arg57345,arg57346,arg57347,arg57348,arg57349,arg57350,arg57351));

break;
case (8):
var arg57352 = (function (){var G__57626 = ctx;
var G__57627 = bindings;
var G__57628 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57626,G__57627,G__57628) : sci.impl.evaluator.eval.call(null,G__57626,G__57627,G__57628));
})();
var args__$1 = cljs.core.rest(args);
var arg57353 = (function (){var G__57629 = ctx;
var G__57630 = bindings;
var G__57631 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57629,G__57630,G__57631) : sci.impl.evaluator.eval.call(null,G__57629,G__57630,G__57631));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57354 = (function (){var G__57632 = ctx;
var G__57633 = bindings;
var G__57634 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57632,G__57633,G__57634) : sci.impl.evaluator.eval.call(null,G__57632,G__57633,G__57634));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57355 = (function (){var G__57635 = ctx;
var G__57636 = bindings;
var G__57637 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57635,G__57636,G__57637) : sci.impl.evaluator.eval.call(null,G__57635,G__57636,G__57637));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57356 = (function (){var G__57638 = ctx;
var G__57639 = bindings;
var G__57640 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57638,G__57639,G__57640) : sci.impl.evaluator.eval.call(null,G__57638,G__57639,G__57640));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57357 = (function (){var G__57641 = ctx;
var G__57642 = bindings;
var G__57643 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57641,G__57642,G__57643) : sci.impl.evaluator.eval.call(null,G__57641,G__57642,G__57643));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57358 = (function (){var G__57644 = ctx;
var G__57645 = bindings;
var G__57646 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57644,G__57645,G__57646) : sci.impl.evaluator.eval.call(null,G__57644,G__57645,G__57646));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57359 = (function (){var G__57647 = ctx;
var G__57648 = bindings;
var G__57649 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57647,G__57648,G__57649) : sci.impl.evaluator.eval.call(null,G__57647,G__57648,G__57649));
})();
var args__$8 = cljs.core.rest(args__$7);
return (f.cljs$core$IFn$_invoke$arity$8 ? f.cljs$core$IFn$_invoke$arity$8(arg57352,arg57353,arg57354,arg57355,arg57356,arg57357,arg57358,arg57359) : f.call(null,arg57352,arg57353,arg57354,arg57355,arg57356,arg57357,arg57358,arg57359));

break;
case (9):
var arg57360 = (function (){var G__57650 = ctx;
var G__57651 = bindings;
var G__57652 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57650,G__57651,G__57652) : sci.impl.evaluator.eval.call(null,G__57650,G__57651,G__57652));
})();
var args__$1 = cljs.core.rest(args);
var arg57361 = (function (){var G__57653 = ctx;
var G__57654 = bindings;
var G__57655 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57653,G__57654,G__57655) : sci.impl.evaluator.eval.call(null,G__57653,G__57654,G__57655));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57362 = (function (){var G__57656 = ctx;
var G__57657 = bindings;
var G__57658 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57656,G__57657,G__57658) : sci.impl.evaluator.eval.call(null,G__57656,G__57657,G__57658));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57363 = (function (){var G__57659 = ctx;
var G__57660 = bindings;
var G__57661 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57659,G__57660,G__57661) : sci.impl.evaluator.eval.call(null,G__57659,G__57660,G__57661));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57364 = (function (){var G__57662 = ctx;
var G__57663 = bindings;
var G__57664 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57662,G__57663,G__57664) : sci.impl.evaluator.eval.call(null,G__57662,G__57663,G__57664));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57365 = (function (){var G__57665 = ctx;
var G__57666 = bindings;
var G__57667 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57665,G__57666,G__57667) : sci.impl.evaluator.eval.call(null,G__57665,G__57666,G__57667));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57366 = (function (){var G__57668 = ctx;
var G__57669 = bindings;
var G__57670 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57668,G__57669,G__57670) : sci.impl.evaluator.eval.call(null,G__57668,G__57669,G__57670));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57367 = (function (){var G__57671 = ctx;
var G__57672 = bindings;
var G__57673 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57671,G__57672,G__57673) : sci.impl.evaluator.eval.call(null,G__57671,G__57672,G__57673));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57368 = (function (){var G__57674 = ctx;
var G__57675 = bindings;
var G__57676 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57674,G__57675,G__57676) : sci.impl.evaluator.eval.call(null,G__57674,G__57675,G__57676));
})();
var args__$9 = cljs.core.rest(args__$8);
return (f.cljs$core$IFn$_invoke$arity$9 ? f.cljs$core$IFn$_invoke$arity$9(arg57360,arg57361,arg57362,arg57363,arg57364,arg57365,arg57366,arg57367,arg57368) : f.call(null,arg57360,arg57361,arg57362,arg57363,arg57364,arg57365,arg57366,arg57367,arg57368));

break;
case (10):
var arg57369 = (function (){var G__57677 = ctx;
var G__57678 = bindings;
var G__57679 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57677,G__57678,G__57679) : sci.impl.evaluator.eval.call(null,G__57677,G__57678,G__57679));
})();
var args__$1 = cljs.core.rest(args);
var arg57370 = (function (){var G__57680 = ctx;
var G__57681 = bindings;
var G__57682 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57680,G__57681,G__57682) : sci.impl.evaluator.eval.call(null,G__57680,G__57681,G__57682));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57371 = (function (){var G__57683 = ctx;
var G__57684 = bindings;
var G__57685 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57683,G__57684,G__57685) : sci.impl.evaluator.eval.call(null,G__57683,G__57684,G__57685));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57372 = (function (){var G__57686 = ctx;
var G__57687 = bindings;
var G__57688 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57686,G__57687,G__57688) : sci.impl.evaluator.eval.call(null,G__57686,G__57687,G__57688));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57373 = (function (){var G__57689 = ctx;
var G__57690 = bindings;
var G__57691 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57689,G__57690,G__57691) : sci.impl.evaluator.eval.call(null,G__57689,G__57690,G__57691));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57374 = (function (){var G__57692 = ctx;
var G__57693 = bindings;
var G__57694 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57692,G__57693,G__57694) : sci.impl.evaluator.eval.call(null,G__57692,G__57693,G__57694));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57375 = (function (){var G__57695 = ctx;
var G__57696 = bindings;
var G__57697 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57695,G__57696,G__57697) : sci.impl.evaluator.eval.call(null,G__57695,G__57696,G__57697));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57376 = (function (){var G__57698 = ctx;
var G__57699 = bindings;
var G__57700 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57698,G__57699,G__57700) : sci.impl.evaluator.eval.call(null,G__57698,G__57699,G__57700));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57377 = (function (){var G__57701 = ctx;
var G__57702 = bindings;
var G__57703 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57701,G__57702,G__57703) : sci.impl.evaluator.eval.call(null,G__57701,G__57702,G__57703));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57378 = (function (){var G__57704 = ctx;
var G__57705 = bindings;
var G__57706 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57704,G__57705,G__57706) : sci.impl.evaluator.eval.call(null,G__57704,G__57705,G__57706));
})();
var args__$10 = cljs.core.rest(args__$9);
return (f.cljs$core$IFn$_invoke$arity$10 ? f.cljs$core$IFn$_invoke$arity$10(arg57369,arg57370,arg57371,arg57372,arg57373,arg57374,arg57375,arg57376,arg57377,arg57378) : f.call(null,arg57369,arg57370,arg57371,arg57372,arg57373,arg57374,arg57375,arg57376,arg57377,arg57378));

break;
case (11):
var arg57379 = (function (){var G__57707 = ctx;
var G__57708 = bindings;
var G__57709 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57707,G__57708,G__57709) : sci.impl.evaluator.eval.call(null,G__57707,G__57708,G__57709));
})();
var args__$1 = cljs.core.rest(args);
var arg57380 = (function (){var G__57710 = ctx;
var G__57711 = bindings;
var G__57712 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57710,G__57711,G__57712) : sci.impl.evaluator.eval.call(null,G__57710,G__57711,G__57712));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57381 = (function (){var G__57713 = ctx;
var G__57714 = bindings;
var G__57715 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57713,G__57714,G__57715) : sci.impl.evaluator.eval.call(null,G__57713,G__57714,G__57715));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57382 = (function (){var G__57716 = ctx;
var G__57717 = bindings;
var G__57718 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57716,G__57717,G__57718) : sci.impl.evaluator.eval.call(null,G__57716,G__57717,G__57718));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57383 = (function (){var G__57719 = ctx;
var G__57720 = bindings;
var G__57721 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57719,G__57720,G__57721) : sci.impl.evaluator.eval.call(null,G__57719,G__57720,G__57721));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57384 = (function (){var G__57722 = ctx;
var G__57723 = bindings;
var G__57724 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57722,G__57723,G__57724) : sci.impl.evaluator.eval.call(null,G__57722,G__57723,G__57724));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57385 = (function (){var G__57725 = ctx;
var G__57726 = bindings;
var G__57727 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57725,G__57726,G__57727) : sci.impl.evaluator.eval.call(null,G__57725,G__57726,G__57727));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57386 = (function (){var G__57728 = ctx;
var G__57729 = bindings;
var G__57730 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57728,G__57729,G__57730) : sci.impl.evaluator.eval.call(null,G__57728,G__57729,G__57730));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57387 = (function (){var G__57731 = ctx;
var G__57732 = bindings;
var G__57733 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57731,G__57732,G__57733) : sci.impl.evaluator.eval.call(null,G__57731,G__57732,G__57733));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57388 = (function (){var G__57734 = ctx;
var G__57735 = bindings;
var G__57736 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57734,G__57735,G__57736) : sci.impl.evaluator.eval.call(null,G__57734,G__57735,G__57736));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57389 = (function (){var G__57737 = ctx;
var G__57738 = bindings;
var G__57739 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57737,G__57738,G__57739) : sci.impl.evaluator.eval.call(null,G__57737,G__57738,G__57739));
})();
var args__$11 = cljs.core.rest(args__$10);
return (f.cljs$core$IFn$_invoke$arity$11 ? f.cljs$core$IFn$_invoke$arity$11(arg57379,arg57380,arg57381,arg57382,arg57383,arg57384,arg57385,arg57386,arg57387,arg57388,arg57389) : f.call(null,arg57379,arg57380,arg57381,arg57382,arg57383,arg57384,arg57385,arg57386,arg57387,arg57388,arg57389));

break;
case (12):
var arg57390 = (function (){var G__57740 = ctx;
var G__57741 = bindings;
var G__57742 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57740,G__57741,G__57742) : sci.impl.evaluator.eval.call(null,G__57740,G__57741,G__57742));
})();
var args__$1 = cljs.core.rest(args);
var arg57391 = (function (){var G__57743 = ctx;
var G__57744 = bindings;
var G__57745 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57743,G__57744,G__57745) : sci.impl.evaluator.eval.call(null,G__57743,G__57744,G__57745));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57392 = (function (){var G__57746 = ctx;
var G__57747 = bindings;
var G__57748 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57746,G__57747,G__57748) : sci.impl.evaluator.eval.call(null,G__57746,G__57747,G__57748));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57393 = (function (){var G__57749 = ctx;
var G__57750 = bindings;
var G__57751 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57749,G__57750,G__57751) : sci.impl.evaluator.eval.call(null,G__57749,G__57750,G__57751));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57394 = (function (){var G__57752 = ctx;
var G__57753 = bindings;
var G__57754 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57752,G__57753,G__57754) : sci.impl.evaluator.eval.call(null,G__57752,G__57753,G__57754));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57395 = (function (){var G__57755 = ctx;
var G__57756 = bindings;
var G__57757 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57755,G__57756,G__57757) : sci.impl.evaluator.eval.call(null,G__57755,G__57756,G__57757));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57396 = (function (){var G__57758 = ctx;
var G__57759 = bindings;
var G__57760 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57758,G__57759,G__57760) : sci.impl.evaluator.eval.call(null,G__57758,G__57759,G__57760));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57397 = (function (){var G__57761 = ctx;
var G__57762 = bindings;
var G__57763 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57761,G__57762,G__57763) : sci.impl.evaluator.eval.call(null,G__57761,G__57762,G__57763));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57398 = (function (){var G__57764 = ctx;
var G__57765 = bindings;
var G__57766 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57764,G__57765,G__57766) : sci.impl.evaluator.eval.call(null,G__57764,G__57765,G__57766));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57399 = (function (){var G__57767 = ctx;
var G__57768 = bindings;
var G__57769 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57767,G__57768,G__57769) : sci.impl.evaluator.eval.call(null,G__57767,G__57768,G__57769));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57400 = (function (){var G__57770 = ctx;
var G__57771 = bindings;
var G__57772 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57770,G__57771,G__57772) : sci.impl.evaluator.eval.call(null,G__57770,G__57771,G__57772));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57401 = (function (){var G__57773 = ctx;
var G__57774 = bindings;
var G__57775 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57773,G__57774,G__57775) : sci.impl.evaluator.eval.call(null,G__57773,G__57774,G__57775));
})();
var args__$12 = cljs.core.rest(args__$11);
return (f.cljs$core$IFn$_invoke$arity$12 ? f.cljs$core$IFn$_invoke$arity$12(arg57390,arg57391,arg57392,arg57393,arg57394,arg57395,arg57396,arg57397,arg57398,arg57399,arg57400,arg57401) : f.call(null,arg57390,arg57391,arg57392,arg57393,arg57394,arg57395,arg57396,arg57397,arg57398,arg57399,arg57400,arg57401));

break;
case (13):
var arg57402 = (function (){var G__57776 = ctx;
var G__57777 = bindings;
var G__57778 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57776,G__57777,G__57778) : sci.impl.evaluator.eval.call(null,G__57776,G__57777,G__57778));
})();
var args__$1 = cljs.core.rest(args);
var arg57403 = (function (){var G__57779 = ctx;
var G__57780 = bindings;
var G__57781 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57779,G__57780,G__57781) : sci.impl.evaluator.eval.call(null,G__57779,G__57780,G__57781));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57404 = (function (){var G__57782 = ctx;
var G__57783 = bindings;
var G__57784 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57782,G__57783,G__57784) : sci.impl.evaluator.eval.call(null,G__57782,G__57783,G__57784));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57405 = (function (){var G__57785 = ctx;
var G__57786 = bindings;
var G__57787 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57785,G__57786,G__57787) : sci.impl.evaluator.eval.call(null,G__57785,G__57786,G__57787));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57406 = (function (){var G__57788 = ctx;
var G__57789 = bindings;
var G__57790 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57788,G__57789,G__57790) : sci.impl.evaluator.eval.call(null,G__57788,G__57789,G__57790));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57407 = (function (){var G__57791 = ctx;
var G__57792 = bindings;
var G__57793 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57791,G__57792,G__57793) : sci.impl.evaluator.eval.call(null,G__57791,G__57792,G__57793));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57408 = (function (){var G__57794 = ctx;
var G__57795 = bindings;
var G__57796 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57794,G__57795,G__57796) : sci.impl.evaluator.eval.call(null,G__57794,G__57795,G__57796));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57409 = (function (){var G__57797 = ctx;
var G__57798 = bindings;
var G__57799 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57797,G__57798,G__57799) : sci.impl.evaluator.eval.call(null,G__57797,G__57798,G__57799));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57410 = (function (){var G__57800 = ctx;
var G__57801 = bindings;
var G__57802 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57800,G__57801,G__57802) : sci.impl.evaluator.eval.call(null,G__57800,G__57801,G__57802));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57411 = (function (){var G__57803 = ctx;
var G__57804 = bindings;
var G__57805 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57803,G__57804,G__57805) : sci.impl.evaluator.eval.call(null,G__57803,G__57804,G__57805));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57412 = (function (){var G__57806 = ctx;
var G__57807 = bindings;
var G__57808 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57806,G__57807,G__57808) : sci.impl.evaluator.eval.call(null,G__57806,G__57807,G__57808));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57413 = (function (){var G__57809 = ctx;
var G__57810 = bindings;
var G__57811 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57809,G__57810,G__57811) : sci.impl.evaluator.eval.call(null,G__57809,G__57810,G__57811));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57414 = (function (){var G__57812 = ctx;
var G__57813 = bindings;
var G__57814 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57812,G__57813,G__57814) : sci.impl.evaluator.eval.call(null,G__57812,G__57813,G__57814));
})();
var args__$13 = cljs.core.rest(args__$12);
return (f.cljs$core$IFn$_invoke$arity$13 ? f.cljs$core$IFn$_invoke$arity$13(arg57402,arg57403,arg57404,arg57405,arg57406,arg57407,arg57408,arg57409,arg57410,arg57411,arg57412,arg57413,arg57414) : f.call(null,arg57402,arg57403,arg57404,arg57405,arg57406,arg57407,arg57408,arg57409,arg57410,arg57411,arg57412,arg57413,arg57414));

break;
case (14):
var arg57415 = (function (){var G__57815 = ctx;
var G__57816 = bindings;
var G__57817 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57815,G__57816,G__57817) : sci.impl.evaluator.eval.call(null,G__57815,G__57816,G__57817));
})();
var args__$1 = cljs.core.rest(args);
var arg57416 = (function (){var G__57818 = ctx;
var G__57819 = bindings;
var G__57820 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57818,G__57819,G__57820) : sci.impl.evaluator.eval.call(null,G__57818,G__57819,G__57820));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57417 = (function (){var G__57821 = ctx;
var G__57822 = bindings;
var G__57823 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57821,G__57822,G__57823) : sci.impl.evaluator.eval.call(null,G__57821,G__57822,G__57823));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57418 = (function (){var G__57824 = ctx;
var G__57825 = bindings;
var G__57826 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57824,G__57825,G__57826) : sci.impl.evaluator.eval.call(null,G__57824,G__57825,G__57826));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57419 = (function (){var G__57827 = ctx;
var G__57828 = bindings;
var G__57829 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57827,G__57828,G__57829) : sci.impl.evaluator.eval.call(null,G__57827,G__57828,G__57829));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57420 = (function (){var G__57830 = ctx;
var G__57831 = bindings;
var G__57832 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57830,G__57831,G__57832) : sci.impl.evaluator.eval.call(null,G__57830,G__57831,G__57832));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57421 = (function (){var G__57833 = ctx;
var G__57834 = bindings;
var G__57835 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57833,G__57834,G__57835) : sci.impl.evaluator.eval.call(null,G__57833,G__57834,G__57835));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57422 = (function (){var G__57836 = ctx;
var G__57837 = bindings;
var G__57838 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57836,G__57837,G__57838) : sci.impl.evaluator.eval.call(null,G__57836,G__57837,G__57838));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57423 = (function (){var G__57839 = ctx;
var G__57840 = bindings;
var G__57841 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57839,G__57840,G__57841) : sci.impl.evaluator.eval.call(null,G__57839,G__57840,G__57841));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57424 = (function (){var G__57842 = ctx;
var G__57843 = bindings;
var G__57844 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57842,G__57843,G__57844) : sci.impl.evaluator.eval.call(null,G__57842,G__57843,G__57844));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57425 = (function (){var G__57845 = ctx;
var G__57846 = bindings;
var G__57847 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57845,G__57846,G__57847) : sci.impl.evaluator.eval.call(null,G__57845,G__57846,G__57847));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57426 = (function (){var G__57848 = ctx;
var G__57849 = bindings;
var G__57850 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57848,G__57849,G__57850) : sci.impl.evaluator.eval.call(null,G__57848,G__57849,G__57850));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57427 = (function (){var G__57851 = ctx;
var G__57852 = bindings;
var G__57853 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57851,G__57852,G__57853) : sci.impl.evaluator.eval.call(null,G__57851,G__57852,G__57853));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57428 = (function (){var G__57971 = ctx;
var G__57972 = bindings;
var G__57973 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57971,G__57972,G__57973) : sci.impl.evaluator.eval.call(null,G__57971,G__57972,G__57973));
})();
var args__$14 = cljs.core.rest(args__$13);
return (f.cljs$core$IFn$_invoke$arity$14 ? f.cljs$core$IFn$_invoke$arity$14(arg57415,arg57416,arg57417,arg57418,arg57419,arg57420,arg57421,arg57422,arg57423,arg57424,arg57425,arg57426,arg57427,arg57428) : f.call(null,arg57415,arg57416,arg57417,arg57418,arg57419,arg57420,arg57421,arg57422,arg57423,arg57424,arg57425,arg57426,arg57427,arg57428));

break;
case (15):
var arg57429 = (function (){var G__57974 = ctx;
var G__57975 = bindings;
var G__57976 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57974,G__57975,G__57976) : sci.impl.evaluator.eval.call(null,G__57974,G__57975,G__57976));
})();
var args__$1 = cljs.core.rest(args);
var arg57430 = (function (){var G__57977 = ctx;
var G__57978 = bindings;
var G__57979 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57977,G__57978,G__57979) : sci.impl.evaluator.eval.call(null,G__57977,G__57978,G__57979));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57431 = (function (){var G__57980 = ctx;
var G__57981 = bindings;
var G__57982 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57980,G__57981,G__57982) : sci.impl.evaluator.eval.call(null,G__57980,G__57981,G__57982));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57432 = (function (){var G__57983 = ctx;
var G__57984 = bindings;
var G__57985 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57983,G__57984,G__57985) : sci.impl.evaluator.eval.call(null,G__57983,G__57984,G__57985));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57433 = (function (){var G__57986 = ctx;
var G__57987 = bindings;
var G__57988 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57986,G__57987,G__57988) : sci.impl.evaluator.eval.call(null,G__57986,G__57987,G__57988));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57434 = (function (){var G__57989 = ctx;
var G__57990 = bindings;
var G__57991 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57989,G__57990,G__57991) : sci.impl.evaluator.eval.call(null,G__57989,G__57990,G__57991));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57435 = (function (){var G__57992 = ctx;
var G__57993 = bindings;
var G__57994 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57992,G__57993,G__57994) : sci.impl.evaluator.eval.call(null,G__57992,G__57993,G__57994));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57436 = (function (){var G__57995 = ctx;
var G__57996 = bindings;
var G__57997 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57995,G__57996,G__57997) : sci.impl.evaluator.eval.call(null,G__57995,G__57996,G__57997));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57437 = (function (){var G__57998 = ctx;
var G__57999 = bindings;
var G__58000 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__57998,G__57999,G__58000) : sci.impl.evaluator.eval.call(null,G__57998,G__57999,G__58000));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57438 = (function (){var G__58001 = ctx;
var G__58002 = bindings;
var G__58003 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58001,G__58002,G__58003) : sci.impl.evaluator.eval.call(null,G__58001,G__58002,G__58003));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57439 = (function (){var G__58004 = ctx;
var G__58005 = bindings;
var G__58006 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58004,G__58005,G__58006) : sci.impl.evaluator.eval.call(null,G__58004,G__58005,G__58006));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57440 = (function (){var G__58007 = ctx;
var G__58008 = bindings;
var G__58009 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58007,G__58008,G__58009) : sci.impl.evaluator.eval.call(null,G__58007,G__58008,G__58009));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57441 = (function (){var G__58010 = ctx;
var G__58011 = bindings;
var G__58012 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58010,G__58011,G__58012) : sci.impl.evaluator.eval.call(null,G__58010,G__58011,G__58012));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57442 = (function (){var G__58013 = ctx;
var G__58014 = bindings;
var G__58015 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58013,G__58014,G__58015) : sci.impl.evaluator.eval.call(null,G__58013,G__58014,G__58015));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg57443 = (function (){var G__58016 = ctx;
var G__58017 = bindings;
var G__58018 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58016,G__58017,G__58018) : sci.impl.evaluator.eval.call(null,G__58016,G__58017,G__58018));
})();
var args__$15 = cljs.core.rest(args__$14);
return (f.cljs$core$IFn$_invoke$arity$15 ? f.cljs$core$IFn$_invoke$arity$15(arg57429,arg57430,arg57431,arg57432,arg57433,arg57434,arg57435,arg57436,arg57437,arg57438,arg57439,arg57440,arg57441,arg57442,arg57443) : f.call(null,arg57429,arg57430,arg57431,arg57432,arg57433,arg57434,arg57435,arg57436,arg57437,arg57438,arg57439,arg57440,arg57441,arg57442,arg57443));

break;
case (16):
var arg57444 = (function (){var G__58019 = ctx;
var G__58020 = bindings;
var G__58021 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58019,G__58020,G__58021) : sci.impl.evaluator.eval.call(null,G__58019,G__58020,G__58021));
})();
var args__$1 = cljs.core.rest(args);
var arg57445 = (function (){var G__58023 = ctx;
var G__58024 = bindings;
var G__58025 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58023,G__58024,G__58025) : sci.impl.evaluator.eval.call(null,G__58023,G__58024,G__58025));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57446 = (function (){var G__58027 = ctx;
var G__58028 = bindings;
var G__58029 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58027,G__58028,G__58029) : sci.impl.evaluator.eval.call(null,G__58027,G__58028,G__58029));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57447 = (function (){var G__58030 = ctx;
var G__58031 = bindings;
var G__58032 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58030,G__58031,G__58032) : sci.impl.evaluator.eval.call(null,G__58030,G__58031,G__58032));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57448 = (function (){var G__58033 = ctx;
var G__58034 = bindings;
var G__58035 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58033,G__58034,G__58035) : sci.impl.evaluator.eval.call(null,G__58033,G__58034,G__58035));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57449 = (function (){var G__58036 = ctx;
var G__58037 = bindings;
var G__58038 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58036,G__58037,G__58038) : sci.impl.evaluator.eval.call(null,G__58036,G__58037,G__58038));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57450 = (function (){var G__58039 = ctx;
var G__58040 = bindings;
var G__58041 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58039,G__58040,G__58041) : sci.impl.evaluator.eval.call(null,G__58039,G__58040,G__58041));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57451 = (function (){var G__58042 = ctx;
var G__58043 = bindings;
var G__58044 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58042,G__58043,G__58044) : sci.impl.evaluator.eval.call(null,G__58042,G__58043,G__58044));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57452 = (function (){var G__58045 = ctx;
var G__58046 = bindings;
var G__58047 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58045,G__58046,G__58047) : sci.impl.evaluator.eval.call(null,G__58045,G__58046,G__58047));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57453 = (function (){var G__58048 = ctx;
var G__58049 = bindings;
var G__58050 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58048,G__58049,G__58050) : sci.impl.evaluator.eval.call(null,G__58048,G__58049,G__58050));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57454 = (function (){var G__58051 = ctx;
var G__58052 = bindings;
var G__58053 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58051,G__58052,G__58053) : sci.impl.evaluator.eval.call(null,G__58051,G__58052,G__58053));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57455 = (function (){var G__58056 = ctx;
var G__58057 = bindings;
var G__58058 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58056,G__58057,G__58058) : sci.impl.evaluator.eval.call(null,G__58056,G__58057,G__58058));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57456 = (function (){var G__58060 = ctx;
var G__58061 = bindings;
var G__58062 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58060,G__58061,G__58062) : sci.impl.evaluator.eval.call(null,G__58060,G__58061,G__58062));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57457 = (function (){var G__58063 = ctx;
var G__58064 = bindings;
var G__58065 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58063,G__58064,G__58065) : sci.impl.evaluator.eval.call(null,G__58063,G__58064,G__58065));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg57458 = (function (){var G__58066 = ctx;
var G__58067 = bindings;
var G__58068 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58066,G__58067,G__58068) : sci.impl.evaluator.eval.call(null,G__58066,G__58067,G__58068));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg57459 = (function (){var G__58069 = ctx;
var G__58070 = bindings;
var G__58071 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58069,G__58070,G__58071) : sci.impl.evaluator.eval.call(null,G__58069,G__58070,G__58071));
})();
var args__$16 = cljs.core.rest(args__$15);
return (f.cljs$core$IFn$_invoke$arity$16 ? f.cljs$core$IFn$_invoke$arity$16(arg57444,arg57445,arg57446,arg57447,arg57448,arg57449,arg57450,arg57451,arg57452,arg57453,arg57454,arg57455,arg57456,arg57457,arg57458,arg57459) : f.call(null,arg57444,arg57445,arg57446,arg57447,arg57448,arg57449,arg57450,arg57451,arg57452,arg57453,arg57454,arg57455,arg57456,arg57457,arg57458,arg57459));

break;
case (17):
var arg57460 = (function (){var G__58077 = ctx;
var G__58078 = bindings;
var G__58079 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58077,G__58078,G__58079) : sci.impl.evaluator.eval.call(null,G__58077,G__58078,G__58079));
})();
var args__$1 = cljs.core.rest(args);
var arg57461 = (function (){var G__58080 = ctx;
var G__58081 = bindings;
var G__58082 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58080,G__58081,G__58082) : sci.impl.evaluator.eval.call(null,G__58080,G__58081,G__58082));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57462 = (function (){var G__58083 = ctx;
var G__58084 = bindings;
var G__58085 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58083,G__58084,G__58085) : sci.impl.evaluator.eval.call(null,G__58083,G__58084,G__58085));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57463 = (function (){var G__58086 = ctx;
var G__58087 = bindings;
var G__58088 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58086,G__58087,G__58088) : sci.impl.evaluator.eval.call(null,G__58086,G__58087,G__58088));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57464 = (function (){var G__58089 = ctx;
var G__58090 = bindings;
var G__58091 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58089,G__58090,G__58091) : sci.impl.evaluator.eval.call(null,G__58089,G__58090,G__58091));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57465 = (function (){var G__58092 = ctx;
var G__58093 = bindings;
var G__58094 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58092,G__58093,G__58094) : sci.impl.evaluator.eval.call(null,G__58092,G__58093,G__58094));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57466 = (function (){var G__58095 = ctx;
var G__58096 = bindings;
var G__58097 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58095,G__58096,G__58097) : sci.impl.evaluator.eval.call(null,G__58095,G__58096,G__58097));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57467 = (function (){var G__58098 = ctx;
var G__58099 = bindings;
var G__58100 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58098,G__58099,G__58100) : sci.impl.evaluator.eval.call(null,G__58098,G__58099,G__58100));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57468 = (function (){var G__58101 = ctx;
var G__58102 = bindings;
var G__58103 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58101,G__58102,G__58103) : sci.impl.evaluator.eval.call(null,G__58101,G__58102,G__58103));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57469 = (function (){var G__58104 = ctx;
var G__58105 = bindings;
var G__58106 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58104,G__58105,G__58106) : sci.impl.evaluator.eval.call(null,G__58104,G__58105,G__58106));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57470 = (function (){var G__58107 = ctx;
var G__58108 = bindings;
var G__58109 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58107,G__58108,G__58109) : sci.impl.evaluator.eval.call(null,G__58107,G__58108,G__58109));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57471 = (function (){var G__58110 = ctx;
var G__58111 = bindings;
var G__58112 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58110,G__58111,G__58112) : sci.impl.evaluator.eval.call(null,G__58110,G__58111,G__58112));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57472 = (function (){var G__58113 = ctx;
var G__58114 = bindings;
var G__58115 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58113,G__58114,G__58115) : sci.impl.evaluator.eval.call(null,G__58113,G__58114,G__58115));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57473 = (function (){var G__58116 = ctx;
var G__58117 = bindings;
var G__58118 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58116,G__58117,G__58118) : sci.impl.evaluator.eval.call(null,G__58116,G__58117,G__58118));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg57474 = (function (){var G__58119 = ctx;
var G__58120 = bindings;
var G__58121 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58119,G__58120,G__58121) : sci.impl.evaluator.eval.call(null,G__58119,G__58120,G__58121));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg57475 = (function (){var G__58122 = ctx;
var G__58123 = bindings;
var G__58124 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58122,G__58123,G__58124) : sci.impl.evaluator.eval.call(null,G__58122,G__58123,G__58124));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg57476 = (function (){var G__58125 = ctx;
var G__58126 = bindings;
var G__58127 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58125,G__58126,G__58127) : sci.impl.evaluator.eval.call(null,G__58125,G__58126,G__58127));
})();
var args__$17 = cljs.core.rest(args__$16);
return (f.cljs$core$IFn$_invoke$arity$17 ? f.cljs$core$IFn$_invoke$arity$17(arg57460,arg57461,arg57462,arg57463,arg57464,arg57465,arg57466,arg57467,arg57468,arg57469,arg57470,arg57471,arg57472,arg57473,arg57474,arg57475,arg57476) : f.call(null,arg57460,arg57461,arg57462,arg57463,arg57464,arg57465,arg57466,arg57467,arg57468,arg57469,arg57470,arg57471,arg57472,arg57473,arg57474,arg57475,arg57476));

break;
case (18):
var arg57477 = (function (){var G__58129 = ctx;
var G__58131 = bindings;
var G__58132 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58129,G__58131,G__58132) : sci.impl.evaluator.eval.call(null,G__58129,G__58131,G__58132));
})();
var args__$1 = cljs.core.rest(args);
var arg57478 = (function (){var G__58133 = ctx;
var G__58134 = bindings;
var G__58135 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58133,G__58134,G__58135) : sci.impl.evaluator.eval.call(null,G__58133,G__58134,G__58135));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57479 = (function (){var G__58136 = ctx;
var G__58137 = bindings;
var G__58138 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58136,G__58137,G__58138) : sci.impl.evaluator.eval.call(null,G__58136,G__58137,G__58138));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57480 = (function (){var G__58139 = ctx;
var G__58140 = bindings;
var G__58141 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58139,G__58140,G__58141) : sci.impl.evaluator.eval.call(null,G__58139,G__58140,G__58141));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57481 = (function (){var G__58142 = ctx;
var G__58143 = bindings;
var G__58144 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58142,G__58143,G__58144) : sci.impl.evaluator.eval.call(null,G__58142,G__58143,G__58144));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57482 = (function (){var G__58145 = ctx;
var G__58146 = bindings;
var G__58147 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58145,G__58146,G__58147) : sci.impl.evaluator.eval.call(null,G__58145,G__58146,G__58147));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57483 = (function (){var G__58148 = ctx;
var G__58149 = bindings;
var G__58150 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58148,G__58149,G__58150) : sci.impl.evaluator.eval.call(null,G__58148,G__58149,G__58150));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57484 = (function (){var G__58151 = ctx;
var G__58152 = bindings;
var G__58153 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58151,G__58152,G__58153) : sci.impl.evaluator.eval.call(null,G__58151,G__58152,G__58153));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57485 = (function (){var G__58154 = ctx;
var G__58155 = bindings;
var G__58156 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58154,G__58155,G__58156) : sci.impl.evaluator.eval.call(null,G__58154,G__58155,G__58156));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57486 = (function (){var G__58157 = ctx;
var G__58158 = bindings;
var G__58159 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58157,G__58158,G__58159) : sci.impl.evaluator.eval.call(null,G__58157,G__58158,G__58159));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57487 = (function (){var G__58160 = ctx;
var G__58161 = bindings;
var G__58162 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58160,G__58161,G__58162) : sci.impl.evaluator.eval.call(null,G__58160,G__58161,G__58162));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57488 = (function (){var G__58163 = ctx;
var G__58164 = bindings;
var G__58165 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58163,G__58164,G__58165) : sci.impl.evaluator.eval.call(null,G__58163,G__58164,G__58165));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57489 = (function (){var G__58166 = ctx;
var G__58167 = bindings;
var G__58168 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58166,G__58167,G__58168) : sci.impl.evaluator.eval.call(null,G__58166,G__58167,G__58168));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57490 = (function (){var G__58169 = ctx;
var G__58170 = bindings;
var G__58171 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58169,G__58170,G__58171) : sci.impl.evaluator.eval.call(null,G__58169,G__58170,G__58171));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg57491 = (function (){var G__58172 = ctx;
var G__58173 = bindings;
var G__58174 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58172,G__58173,G__58174) : sci.impl.evaluator.eval.call(null,G__58172,G__58173,G__58174));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg57492 = (function (){var G__58175 = ctx;
var G__58176 = bindings;
var G__58177 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58175,G__58176,G__58177) : sci.impl.evaluator.eval.call(null,G__58175,G__58176,G__58177));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg57493 = (function (){var G__58178 = ctx;
var G__58179 = bindings;
var G__58180 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58178,G__58179,G__58180) : sci.impl.evaluator.eval.call(null,G__58178,G__58179,G__58180));
})();
var args__$17 = cljs.core.rest(args__$16);
var arg57494 = (function (){var G__58181 = ctx;
var G__58182 = bindings;
var G__58183 = cljs.core.first(args__$17);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58181,G__58182,G__58183) : sci.impl.evaluator.eval.call(null,G__58181,G__58182,G__58183));
})();
var args__$18 = cljs.core.rest(args__$17);
return (f.cljs$core$IFn$_invoke$arity$18 ? f.cljs$core$IFn$_invoke$arity$18(arg57477,arg57478,arg57479,arg57480,arg57481,arg57482,arg57483,arg57484,arg57485,arg57486,arg57487,arg57488,arg57489,arg57490,arg57491,arg57492,arg57493,arg57494) : f.call(null,arg57477,arg57478,arg57479,arg57480,arg57481,arg57482,arg57483,arg57484,arg57485,arg57486,arg57487,arg57488,arg57489,arg57490,arg57491,arg57492,arg57493,arg57494));

break;
case (19):
var arg57495 = (function (){var G__58184 = ctx;
var G__58185 = bindings;
var G__58186 = cljs.core.first(args);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58184,G__58185,G__58186) : sci.impl.evaluator.eval.call(null,G__58184,G__58185,G__58186));
})();
var args__$1 = cljs.core.rest(args);
var arg57496 = (function (){var G__58187 = ctx;
var G__58188 = bindings;
var G__58189 = cljs.core.first(args__$1);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58187,G__58188,G__58189) : sci.impl.evaluator.eval.call(null,G__58187,G__58188,G__58189));
})();
var args__$2 = cljs.core.rest(args__$1);
var arg57497 = (function (){var G__58190 = ctx;
var G__58191 = bindings;
var G__58192 = cljs.core.first(args__$2);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58190,G__58191,G__58192) : sci.impl.evaluator.eval.call(null,G__58190,G__58191,G__58192));
})();
var args__$3 = cljs.core.rest(args__$2);
var arg57498 = (function (){var G__58193 = ctx;
var G__58194 = bindings;
var G__58195 = cljs.core.first(args__$3);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58193,G__58194,G__58195) : sci.impl.evaluator.eval.call(null,G__58193,G__58194,G__58195));
})();
var args__$4 = cljs.core.rest(args__$3);
var arg57499 = (function (){var G__58196 = ctx;
var G__58197 = bindings;
var G__58198 = cljs.core.first(args__$4);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58196,G__58197,G__58198) : sci.impl.evaluator.eval.call(null,G__58196,G__58197,G__58198));
})();
var args__$5 = cljs.core.rest(args__$4);
var arg57500 = (function (){var G__58199 = ctx;
var G__58200 = bindings;
var G__58201 = cljs.core.first(args__$5);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58199,G__58200,G__58201) : sci.impl.evaluator.eval.call(null,G__58199,G__58200,G__58201));
})();
var args__$6 = cljs.core.rest(args__$5);
var arg57501 = (function (){var G__58202 = ctx;
var G__58203 = bindings;
var G__58204 = cljs.core.first(args__$6);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58202,G__58203,G__58204) : sci.impl.evaluator.eval.call(null,G__58202,G__58203,G__58204));
})();
var args__$7 = cljs.core.rest(args__$6);
var arg57502 = (function (){var G__58205 = ctx;
var G__58206 = bindings;
var G__58207 = cljs.core.first(args__$7);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58205,G__58206,G__58207) : sci.impl.evaluator.eval.call(null,G__58205,G__58206,G__58207));
})();
var args__$8 = cljs.core.rest(args__$7);
var arg57503 = (function (){var G__58208 = ctx;
var G__58209 = bindings;
var G__58210 = cljs.core.first(args__$8);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58208,G__58209,G__58210) : sci.impl.evaluator.eval.call(null,G__58208,G__58209,G__58210));
})();
var args__$9 = cljs.core.rest(args__$8);
var arg57504 = (function (){var G__58211 = ctx;
var G__58212 = bindings;
var G__58213 = cljs.core.first(args__$9);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58211,G__58212,G__58213) : sci.impl.evaluator.eval.call(null,G__58211,G__58212,G__58213));
})();
var args__$10 = cljs.core.rest(args__$9);
var arg57505 = (function (){var G__58238 = ctx;
var G__58239 = bindings;
var G__58240 = cljs.core.first(args__$10);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58238,G__58239,G__58240) : sci.impl.evaluator.eval.call(null,G__58238,G__58239,G__58240));
})();
var args__$11 = cljs.core.rest(args__$10);
var arg57506 = (function (){var G__58241 = ctx;
var G__58242 = bindings;
var G__58243 = cljs.core.first(args__$11);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58241,G__58242,G__58243) : sci.impl.evaluator.eval.call(null,G__58241,G__58242,G__58243));
})();
var args__$12 = cljs.core.rest(args__$11);
var arg57507 = (function (){var G__58244 = ctx;
var G__58245 = bindings;
var G__58246 = cljs.core.first(args__$12);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58244,G__58245,G__58246) : sci.impl.evaluator.eval.call(null,G__58244,G__58245,G__58246));
})();
var args__$13 = cljs.core.rest(args__$12);
var arg57508 = (function (){var G__58247 = ctx;
var G__58248 = bindings;
var G__58249 = cljs.core.first(args__$13);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58247,G__58248,G__58249) : sci.impl.evaluator.eval.call(null,G__58247,G__58248,G__58249));
})();
var args__$14 = cljs.core.rest(args__$13);
var arg57509 = (function (){var G__58250 = ctx;
var G__58251 = bindings;
var G__58252 = cljs.core.first(args__$14);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58250,G__58251,G__58252) : sci.impl.evaluator.eval.call(null,G__58250,G__58251,G__58252));
})();
var args__$15 = cljs.core.rest(args__$14);
var arg57510 = (function (){var G__58253 = ctx;
var G__58254 = bindings;
var G__58255 = cljs.core.first(args__$15);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58253,G__58254,G__58255) : sci.impl.evaluator.eval.call(null,G__58253,G__58254,G__58255));
})();
var args__$16 = cljs.core.rest(args__$15);
var arg57511 = (function (){var G__58256 = ctx;
var G__58257 = bindings;
var G__58258 = cljs.core.first(args__$16);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58256,G__58257,G__58258) : sci.impl.evaluator.eval.call(null,G__58256,G__58257,G__58258));
})();
var args__$17 = cljs.core.rest(args__$16);
var arg57512 = (function (){var G__58259 = ctx;
var G__58260 = bindings;
var G__58261 = cljs.core.first(args__$17);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58259,G__58260,G__58261) : sci.impl.evaluator.eval.call(null,G__58259,G__58260,G__58261));
})();
var args__$18 = cljs.core.rest(args__$17);
var arg57513 = (function (){var G__58262 = ctx;
var G__58263 = bindings;
var G__58264 = cljs.core.first(args__$18);
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(G__58262,G__58263,G__58264) : sci.impl.evaluator.eval.call(null,G__58262,G__58263,G__58264));
})();
var args__$19 = cljs.core.rest(args__$18);
return (f.cljs$core$IFn$_invoke$arity$19 ? f.cljs$core$IFn$_invoke$arity$19(arg57495,arg57496,arg57497,arg57498,arg57499,arg57500,arg57501,arg57502,arg57503,arg57504,arg57505,arg57506,arg57507,arg57508,arg57509,arg57510,arg57511,arg57512,arg57513) : f.call(null,arg57495,arg57496,arg57497,arg57498,arg57499,arg57500,arg57501,arg57502,arg57503,arg57504,arg57505,arg57506,arg57507,arg57508,arg57509,arg57510,arg57511,arg57512,arg57513));

break;
default:
var args__$1 = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (p1__56969_SHARP_){
return (sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3 ? sci.impl.evaluator.eval.cljs$core$IFn$_invoke$arity$3(ctx,bindings,p1__56969_SHARP_) : sci.impl.evaluator.eval.call(null,ctx,bindings,p1__56969_SHARP_));
}),args);
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,args__$1);

}
});
sci.impl.evaluator.eval = (function sci$impl$evaluator$eval(ctx,bindings,expr){
try{if((expr instanceof sci.impl.types.EvalFn)){
var f = expr.f;
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(ctx,bindings) : f.call(null,ctx,bindings));
} else {
if((expr instanceof sci.impl.types.EvalVar)){
var v = expr.v;
return cljs.core._deref(v);
} else {
if((((expr == null))?false:(((!((expr == null))))?(((((expr.cljs$lang$protocol_mask$partition0$ & (1024))) || ((cljs.core.PROTOCOL_SENTINEL === expr.cljs$core$IMap$))))?true:(((!expr.cljs$lang$protocol_mask$partition0$))?cljs.core.native_satisfies_QMARK_(cljs.core.IMap,expr):false)):cljs.core.native_satisfies_QMARK_(cljs.core.IMap,expr)))){
return sci.impl.evaluator.eval_map(ctx,bindings,expr);
} else {
return expr;

}
}
}
}catch (e58265){if((e58265 instanceof Error)){
var e = e58265;
return sci.impl.utils.rethrow_with_location_of_node.cljs$core$IFn$_invoke$arity$4(ctx,bindings,e,expr);
} else {
throw e58265;

}
}});
cljs.core.vreset_BANG_(sci.impl.utils.eval_STAR_,sci.impl.evaluator.eval);

//# sourceMappingURL=sci.impl.evaluator.js.map
