import "./cljs_env.js";
goog.provide('sci.impl.fns');
sci.impl.fns.throw_arity = (function sci$impl$fns$throw_arity(ctx,nsm,fn_name,macro_QMARK_,args){
if(cljs.core.truth_(new cljs.core.Keyword(null,"disable-arity-checks","disable-arity-checks",1131364206).cljs$core$IFn$_invoke$arity$1(ctx))){
return null;
} else {
throw (new Error((function (){var actual_count = (cljs.core.truth_(macro_QMARK_)?(cljs.core.count(args) - (2)):cljs.core.count(args));
return ["Wrong number of args (",cljs.core.str.cljs$core$IFn$_invoke$arity$1(actual_count),") passed to: ",[cljs.core.str.cljs$core$IFn$_invoke$arity$1(nsm),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_name)].join('')].join('');
})()));
}
});

/**
* @constructor
 * @implements {sci.impl.types.IBox}
*/
sci.impl.fns.Recur = (function (val){
this.val = val;
});
(sci.impl.fns.Recur.prototype.sci$impl$types$IBox$ = cljs.core.PROTOCOL_SENTINEL);

(sci.impl.fns.Recur.prototype.sci$impl$types$IBox$getVal$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.val;
}));

(sci.impl.fns.Recur.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"val","val",1769233139,null)], null);
}));

(sci.impl.fns.Recur.cljs$lang$type = true);

(sci.impl.fns.Recur.cljs$lang$ctorStr = "sci.impl.fns/Recur");

(sci.impl.fns.Recur.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"sci.impl.fns/Recur");
}));

/**
 * Positional factory function for sci.impl.fns/Recur.
 */
sci.impl.fns.__GT_Recur = (function sci$impl$fns$__GT_Recur(val){
return (new sci.impl.fns.Recur(val));
});

sci.impl.fns.fun = (function sci$impl$fns$fun(ctx,bindings,fn_body,fn_name,macro_QMARK_){
var bindings_fn = new cljs.core.Keyword(null,"bindings-fn","bindings-fn",300799951).cljs$core$IFn$_invoke$arity$1(fn_body);
var bindings__$1 = (bindings_fn.cljs$core$IFn$_invoke$arity$1 ? bindings_fn.cljs$core$IFn$_invoke$arity$1(bindings) : bindings_fn.call(null,bindings));
var fixed_arity = new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body);
var var_arg_name = new cljs.core.Keyword(null,"var-arg-name","var-arg-name",-1100024887).cljs$core$IFn$_invoke$arity$1(fn_body);
var params = new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(fn_body);
var body = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(fn_body);
var nsm = sci.impl.vars.current_ns_name();
var disable_arity_checks_QMARK_ = ctx.get(new cljs.core.Keyword(null,"disable-arity-checks","disable-arity-checks",1131364206));
var f = ((cljs.core.not(var_arg_name))?(function (){var G__58932 = (fixed_arity | (0));
switch (G__58932) {
case (0):
return (function sci$impl$fns$fun_$_arity_0(){
while(true){
var ret = sci.impl.evaluator.eval(ctx,bindings__$1,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
continue;
} else {
return ret;
}
break;
}
});

break;
case (1):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__58935 = cljs.core._nth(params,(0));
return (function sci$impl$fns$fun_$_arity_1(G__58934){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__58935,G__58934);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__59995 = cljs.core._nth(recur_val,(0));
G__58934 = G__59995;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__58938 = cljs.core._nth(params,(0));
return (function sci$impl$fns$fun_$_arity_1(G__58937){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((1),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__58938,G__58937);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__59998 = cljs.core._nth(recur_val,(0));
G__58937 = G__59998;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (2):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__58942 = cljs.core._nth(params,(0));
var G__58943 = cljs.core._nth(params,(1));
return (function sci$impl$fns$fun_$_arity_2(G__58940,G__58941){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__58942,G__58940);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58943,G__58941);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$3,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60000 = cljs.core._nth(recur_val,(0));
var G__60001 = cljs.core._nth(recur_val,(1));
G__58940 = G__60000;
G__58941 = G__60001;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__58951 = cljs.core._nth(params,(0));
var G__58952 = cljs.core._nth(params,(1));
return (function sci$impl$fns$fun_$_arity_2(G__58949,G__58950){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__58951,G__58949);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58952,G__58950);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$3,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60002 = cljs.core._nth(recur_val,(0));
var G__60003 = cljs.core._nth(recur_val,(1));
G__58949 = G__60002;
G__58950 = G__60003;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (3):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__58957 = cljs.core._nth(params,(0));
var G__58958 = cljs.core._nth(params,(1));
var G__58959 = cljs.core._nth(params,(2));
return (function sci$impl$fns$fun_$_arity_3(G__58954,G__58955,G__58956){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__58957,G__58954);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58958,G__58955);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__58959,G__58956);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$4,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60004 = cljs.core._nth(recur_val,(0));
var G__60005 = cljs.core._nth(recur_val,(1));
var G__60006 = cljs.core._nth(recur_val,(2));
G__58954 = G__60004;
G__58955 = G__60005;
G__58956 = G__60006;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__58965 = cljs.core._nth(params,(0));
var G__58966 = cljs.core._nth(params,(1));
var G__58967 = cljs.core._nth(params,(2));
return (function sci$impl$fns$fun_$_arity_3(G__58962,G__58963,G__58964){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__58965,G__58962);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58966,G__58963);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__58967,G__58964);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$4,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60007 = cljs.core._nth(recur_val,(0));
var G__60008 = cljs.core._nth(recur_val,(1));
var G__60009 = cljs.core._nth(recur_val,(2));
G__58962 = G__60007;
G__58963 = G__60008;
G__58964 = G__60009;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (4):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__58972 = cljs.core._nth(params,(0));
var G__58973 = cljs.core._nth(params,(1));
var G__58974 = cljs.core._nth(params,(2));
var G__58975 = cljs.core._nth(params,(3));
return (function sci$impl$fns$fun_$_arity_4(G__58968,G__58969,G__58970,G__58971){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__58972,G__58968);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58973,G__58969);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__58974,G__58970);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__58975,G__58971);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$5,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60010 = cljs.core._nth(recur_val,(0));
var G__60011 = cljs.core._nth(recur_val,(1));
var G__60012 = cljs.core._nth(recur_val,(2));
var G__60013 = cljs.core._nth(recur_val,(3));
G__58968 = G__60010;
G__58969 = G__60011;
G__58970 = G__60012;
G__58971 = G__60013;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__58993 = cljs.core._nth(params,(0));
var G__58994 = cljs.core._nth(params,(1));
var G__58995 = cljs.core._nth(params,(2));
var G__58996 = cljs.core._nth(params,(3));
return (function sci$impl$fns$fun_$_arity_4(G__58989,G__58990,G__58991,G__58992){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((4),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__58993,G__58989);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__58994,G__58990);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__58995,G__58991);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__58996,G__58992);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$5,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60015 = cljs.core._nth(recur_val,(0));
var G__60016 = cljs.core._nth(recur_val,(1));
var G__60017 = cljs.core._nth(recur_val,(2));
var G__60018 = cljs.core._nth(recur_val,(3));
G__58989 = G__60015;
G__58990 = G__60016;
G__58991 = G__60017;
G__58992 = G__60018;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (5):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59006 = cljs.core._nth(params,(0));
var G__59007 = cljs.core._nth(params,(1));
var G__59008 = cljs.core._nth(params,(2));
var G__59009 = cljs.core._nth(params,(3));
var G__59010 = cljs.core._nth(params,(4));
return (function sci$impl$fns$fun_$_arity_5(G__59001,G__59002,G__59003,G__59004,G__59005){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59006,G__59001);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59007,G__59002);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59008,G__59003);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59009,G__59004);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59010,G__59005);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$6,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60019 = cljs.core._nth(recur_val,(0));
var G__60020 = cljs.core._nth(recur_val,(1));
var G__60021 = cljs.core._nth(recur_val,(2));
var G__60022 = cljs.core._nth(recur_val,(3));
var G__60023 = cljs.core._nth(recur_val,(4));
G__59001 = G__60019;
G__59002 = G__60020;
G__59003 = G__60021;
G__59004 = G__60022;
G__59005 = G__60023;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59018 = cljs.core._nth(params,(0));
var G__59019 = cljs.core._nth(params,(1));
var G__59020 = cljs.core._nth(params,(2));
var G__59021 = cljs.core._nth(params,(3));
var G__59022 = cljs.core._nth(params,(4));
return (function sci$impl$fns$fun_$_arity_5(G__59013,G__59014,G__59015,G__59016,G__59017){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((5),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59018,G__59013);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59019,G__59014);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59020,G__59015);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59021,G__59016);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59022,G__59017);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$6,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60026 = cljs.core._nth(recur_val,(0));
var G__60028 = cljs.core._nth(recur_val,(1));
var G__60029 = cljs.core._nth(recur_val,(2));
var G__60030 = cljs.core._nth(recur_val,(3));
var G__60031 = cljs.core._nth(recur_val,(4));
G__59013 = G__60026;
G__59014 = G__60028;
G__59015 = G__60029;
G__59016 = G__60030;
G__59017 = G__60031;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (6):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59035 = cljs.core._nth(params,(0));
var G__59036 = cljs.core._nth(params,(1));
var G__59037 = cljs.core._nth(params,(2));
var G__59038 = cljs.core._nth(params,(3));
var G__59039 = cljs.core._nth(params,(4));
var G__59040 = cljs.core._nth(params,(5));
return (function sci$impl$fns$fun_$_arity_6(G__59029,G__59030,G__59031,G__59032,G__59033,G__59034){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59035,G__59029);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59036,G__59030);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59037,G__59031);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59038,G__59032);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59039,G__59033);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59040,G__59034);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$7,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60080 = cljs.core._nth(recur_val,(0));
var G__60081 = cljs.core._nth(recur_val,(1));
var G__60082 = cljs.core._nth(recur_val,(2));
var G__60083 = cljs.core._nth(recur_val,(3));
var G__60084 = cljs.core._nth(recur_val,(4));
var G__60085 = cljs.core._nth(recur_val,(5));
G__59029 = G__60080;
G__59030 = G__60081;
G__59031 = G__60082;
G__59032 = G__60083;
G__59033 = G__60084;
G__59034 = G__60085;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59047 = cljs.core._nth(params,(0));
var G__59048 = cljs.core._nth(params,(1));
var G__59049 = cljs.core._nth(params,(2));
var G__59050 = cljs.core._nth(params,(3));
var G__59051 = cljs.core._nth(params,(4));
var G__59052 = cljs.core._nth(params,(5));
return (function sci$impl$fns$fun_$_arity_6(G__59041,G__59042,G__59043,G__59044,G__59045,G__59046){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((6),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59047,G__59041);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59048,G__59042);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59049,G__59043);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59050,G__59044);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59051,G__59045);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59052,G__59046);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$7,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60089 = cljs.core._nth(recur_val,(0));
var G__60090 = cljs.core._nth(recur_val,(1));
var G__60091 = cljs.core._nth(recur_val,(2));
var G__60092 = cljs.core._nth(recur_val,(3));
var G__60093 = cljs.core._nth(recur_val,(4));
var G__60094 = cljs.core._nth(recur_val,(5));
G__59041 = G__60089;
G__59042 = G__60090;
G__59043 = G__60091;
G__59044 = G__60092;
G__59045 = G__60093;
G__59046 = G__60094;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (7):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59061 = cljs.core._nth(params,(0));
var G__59062 = cljs.core._nth(params,(1));
var G__59063 = cljs.core._nth(params,(2));
var G__59064 = cljs.core._nth(params,(3));
var G__59065 = cljs.core._nth(params,(4));
var G__59066 = cljs.core._nth(params,(5));
var G__59067 = cljs.core._nth(params,(6));
return (function sci$impl$fns$fun_$_arity_7(G__59054,G__59055,G__59056,G__59057,G__59058,G__59059,G__59060){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59061,G__59054);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59062,G__59055);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59063,G__59056);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59064,G__59057);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59065,G__59058);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59066,G__59059);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59067,G__59060);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$8,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60096 = cljs.core._nth(recur_val,(0));
var G__60097 = cljs.core._nth(recur_val,(1));
var G__60098 = cljs.core._nth(recur_val,(2));
var G__60099 = cljs.core._nth(recur_val,(3));
var G__60100 = cljs.core._nth(recur_val,(4));
var G__60101 = cljs.core._nth(recur_val,(5));
var G__60102 = cljs.core._nth(recur_val,(6));
G__59054 = G__60096;
G__59055 = G__60097;
G__59056 = G__60098;
G__59057 = G__60099;
G__59058 = G__60100;
G__59059 = G__60101;
G__59060 = G__60102;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59076 = cljs.core._nth(params,(0));
var G__59077 = cljs.core._nth(params,(1));
var G__59078 = cljs.core._nth(params,(2));
var G__59079 = cljs.core._nth(params,(3));
var G__59080 = cljs.core._nth(params,(4));
var G__59081 = cljs.core._nth(params,(5));
var G__59082 = cljs.core._nth(params,(6));
return (function sci$impl$fns$fun_$_arity_7(G__59069,G__59070,G__59071,G__59072,G__59073,G__59074,G__59075){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((7),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59076,G__59069);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59077,G__59070);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59078,G__59071);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59079,G__59072);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59080,G__59073);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59081,G__59074);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59082,G__59075);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$8,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60105 = cljs.core._nth(recur_val,(0));
var G__60106 = cljs.core._nth(recur_val,(1));
var G__60107 = cljs.core._nth(recur_val,(2));
var G__60108 = cljs.core._nth(recur_val,(3));
var G__60109 = cljs.core._nth(recur_val,(4));
var G__60110 = cljs.core._nth(recur_val,(5));
var G__60111 = cljs.core._nth(recur_val,(6));
G__59069 = G__60105;
G__59070 = G__60106;
G__59071 = G__60107;
G__59072 = G__60108;
G__59073 = G__60109;
G__59074 = G__60110;
G__59075 = G__60111;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (8):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59091 = cljs.core._nth(params,(0));
var G__59092 = cljs.core._nth(params,(1));
var G__59093 = cljs.core._nth(params,(2));
var G__59094 = cljs.core._nth(params,(3));
var G__59095 = cljs.core._nth(params,(4));
var G__59096 = cljs.core._nth(params,(5));
var G__59097 = cljs.core._nth(params,(6));
var G__59098 = cljs.core._nth(params,(7));
return (function sci$impl$fns$fun_$_arity_8(G__59083,G__59084,G__59085,G__59086,G__59087,G__59088,G__59089,G__59090){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59091,G__59083);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59092,G__59084);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59093,G__59085);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59094,G__59086);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59095,G__59087);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59096,G__59088);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59097,G__59089);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59098,G__59090);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$9,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60117 = cljs.core._nth(recur_val,(0));
var G__60118 = cljs.core._nth(recur_val,(1));
var G__60119 = cljs.core._nth(recur_val,(2));
var G__60120 = cljs.core._nth(recur_val,(3));
var G__60121 = cljs.core._nth(recur_val,(4));
var G__60122 = cljs.core._nth(recur_val,(5));
var G__60123 = cljs.core._nth(recur_val,(6));
var G__60124 = cljs.core._nth(recur_val,(7));
G__59083 = G__60117;
G__59084 = G__60118;
G__59085 = G__60119;
G__59086 = G__60120;
G__59087 = G__60121;
G__59088 = G__60122;
G__59089 = G__60123;
G__59090 = G__60124;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59107 = cljs.core._nth(params,(0));
var G__59108 = cljs.core._nth(params,(1));
var G__59109 = cljs.core._nth(params,(2));
var G__59110 = cljs.core._nth(params,(3));
var G__59111 = cljs.core._nth(params,(4));
var G__59112 = cljs.core._nth(params,(5));
var G__59113 = cljs.core._nth(params,(6));
var G__59114 = cljs.core._nth(params,(7));
return (function sci$impl$fns$fun_$_arity_8(G__59099,G__59100,G__59101,G__59102,G__59103,G__59104,G__59105,G__59106){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((8),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59107,G__59099);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59108,G__59100);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59109,G__59101);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59110,G__59102);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59111,G__59103);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59112,G__59104);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59113,G__59105);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59114,G__59106);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$9,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60139 = cljs.core._nth(recur_val,(0));
var G__60140 = cljs.core._nth(recur_val,(1));
var G__60141 = cljs.core._nth(recur_val,(2));
var G__60142 = cljs.core._nth(recur_val,(3));
var G__60143 = cljs.core._nth(recur_val,(4));
var G__60144 = cljs.core._nth(recur_val,(5));
var G__60145 = cljs.core._nth(recur_val,(6));
var G__60146 = cljs.core._nth(recur_val,(7));
G__59099 = G__60139;
G__59100 = G__60140;
G__59101 = G__60141;
G__59102 = G__60142;
G__59103 = G__60143;
G__59104 = G__60144;
G__59105 = G__60145;
G__59106 = G__60146;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (9):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59124 = cljs.core._nth(params,(0));
var G__59125 = cljs.core._nth(params,(1));
var G__59126 = cljs.core._nth(params,(2));
var G__59127 = cljs.core._nth(params,(3));
var G__59128 = cljs.core._nth(params,(4));
var G__59129 = cljs.core._nth(params,(5));
var G__59130 = cljs.core._nth(params,(6));
var G__59131 = cljs.core._nth(params,(7));
var G__59132 = cljs.core._nth(params,(8));
return (function sci$impl$fns$fun_$_arity_9(G__59115,G__59116,G__59117,G__59118,G__59119,G__59120,G__59121,G__59122,G__59123){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59124,G__59115);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59125,G__59116);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59126,G__59117);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59127,G__59118);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59128,G__59119);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59129,G__59120);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59130,G__59121);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59131,G__59122);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59132,G__59123);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$10,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60147 = cljs.core._nth(recur_val,(0));
var G__60148 = cljs.core._nth(recur_val,(1));
var G__60149 = cljs.core._nth(recur_val,(2));
var G__60150 = cljs.core._nth(recur_val,(3));
var G__60151 = cljs.core._nth(recur_val,(4));
var G__60152 = cljs.core._nth(recur_val,(5));
var G__60153 = cljs.core._nth(recur_val,(6));
var G__60154 = cljs.core._nth(recur_val,(7));
var G__60155 = cljs.core._nth(recur_val,(8));
G__59115 = G__60147;
G__59116 = G__60148;
G__59117 = G__60149;
G__59118 = G__60150;
G__59119 = G__60151;
G__59120 = G__60152;
G__59121 = G__60153;
G__59122 = G__60154;
G__59123 = G__60155;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59142 = cljs.core._nth(params,(0));
var G__59143 = cljs.core._nth(params,(1));
var G__59144 = cljs.core._nth(params,(2));
var G__59145 = cljs.core._nth(params,(3));
var G__59146 = cljs.core._nth(params,(4));
var G__59147 = cljs.core._nth(params,(5));
var G__59148 = cljs.core._nth(params,(6));
var G__59149 = cljs.core._nth(params,(7));
var G__59150 = cljs.core._nth(params,(8));
return (function sci$impl$fns$fun_$_arity_9(G__59133,G__59134,G__59135,G__59136,G__59137,G__59138,G__59139,G__59140,G__59141){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((9),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59142,G__59133);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59143,G__59134);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59144,G__59135);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59145,G__59136);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59146,G__59137);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59147,G__59138);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59148,G__59139);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59149,G__59140);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59150,G__59141);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$10,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60157 = cljs.core._nth(recur_val,(0));
var G__60158 = cljs.core._nth(recur_val,(1));
var G__60159 = cljs.core._nth(recur_val,(2));
var G__60160 = cljs.core._nth(recur_val,(3));
var G__60161 = cljs.core._nth(recur_val,(4));
var G__60162 = cljs.core._nth(recur_val,(5));
var G__60163 = cljs.core._nth(recur_val,(6));
var G__60164 = cljs.core._nth(recur_val,(7));
var G__60165 = cljs.core._nth(recur_val,(8));
G__59133 = G__60157;
G__59134 = G__60158;
G__59135 = G__60159;
G__59136 = G__60160;
G__59137 = G__60161;
G__59138 = G__60162;
G__59139 = G__60163;
G__59140 = G__60164;
G__59141 = G__60165;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (10):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59167 = cljs.core._nth(params,(0));
var G__59168 = cljs.core._nth(params,(1));
var G__59169 = cljs.core._nth(params,(2));
var G__59170 = cljs.core._nth(params,(3));
var G__59171 = cljs.core._nth(params,(4));
var G__59172 = cljs.core._nth(params,(5));
var G__59173 = cljs.core._nth(params,(6));
var G__59174 = cljs.core._nth(params,(7));
var G__59175 = cljs.core._nth(params,(8));
var G__59176 = cljs.core._nth(params,(9));
return (function sci$impl$fns$fun_$_arity_10(G__59156,G__59157,G__59158,G__59159,G__59160,G__59161,G__59162,G__59163,G__59164,G__59165){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59167,G__59156);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59168,G__59157);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59169,G__59158);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59170,G__59159);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59171,G__59160);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59172,G__59161);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59173,G__59162);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59174,G__59163);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59175,G__59164);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59176,G__59165);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$11,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60172 = cljs.core._nth(recur_val,(0));
var G__60173 = cljs.core._nth(recur_val,(1));
var G__60174 = cljs.core._nth(recur_val,(2));
var G__60175 = cljs.core._nth(recur_val,(3));
var G__60176 = cljs.core._nth(recur_val,(4));
var G__60177 = cljs.core._nth(recur_val,(5));
var G__60178 = cljs.core._nth(recur_val,(6));
var G__60179 = cljs.core._nth(recur_val,(7));
var G__60180 = cljs.core._nth(recur_val,(8));
var G__60181 = cljs.core._nth(recur_val,(9));
G__59156 = G__60172;
G__59157 = G__60173;
G__59158 = G__60174;
G__59159 = G__60175;
G__59160 = G__60176;
G__59161 = G__60177;
G__59162 = G__60178;
G__59163 = G__60179;
G__59164 = G__60180;
G__59165 = G__60181;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59193 = cljs.core._nth(params,(0));
var G__59194 = cljs.core._nth(params,(1));
var G__59195 = cljs.core._nth(params,(2));
var G__59196 = cljs.core._nth(params,(3));
var G__59197 = cljs.core._nth(params,(4));
var G__59198 = cljs.core._nth(params,(5));
var G__59199 = cljs.core._nth(params,(6));
var G__59200 = cljs.core._nth(params,(7));
var G__59201 = cljs.core._nth(params,(8));
var G__59202 = cljs.core._nth(params,(9));
return (function sci$impl$fns$fun_$_arity_10(G__59183,G__59184,G__59185,G__59186,G__59187,G__59188,G__59189,G__59190,G__59191,G__59192){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((10),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59193,G__59183);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59194,G__59184);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59195,G__59185);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59196,G__59186);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59197,G__59187);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59198,G__59188);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59199,G__59189);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59200,G__59190);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59201,G__59191);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59202,G__59192);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$11,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60195 = cljs.core._nth(recur_val,(0));
var G__60196 = cljs.core._nth(recur_val,(1));
var G__60197 = cljs.core._nth(recur_val,(2));
var G__60198 = cljs.core._nth(recur_val,(3));
var G__60199 = cljs.core._nth(recur_val,(4));
var G__60200 = cljs.core._nth(recur_val,(5));
var G__60201 = cljs.core._nth(recur_val,(6));
var G__60202 = cljs.core._nth(recur_val,(7));
var G__60203 = cljs.core._nth(recur_val,(8));
var G__60204 = cljs.core._nth(recur_val,(9));
G__59183 = G__60195;
G__59184 = G__60196;
G__59185 = G__60197;
G__59186 = G__60198;
G__59187 = G__60199;
G__59188 = G__60200;
G__59189 = G__60201;
G__59190 = G__60202;
G__59191 = G__60203;
G__59192 = G__60204;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (11):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59214 = cljs.core._nth(params,(0));
var G__59215 = cljs.core._nth(params,(1));
var G__59216 = cljs.core._nth(params,(2));
var G__59217 = cljs.core._nth(params,(3));
var G__59218 = cljs.core._nth(params,(4));
var G__59219 = cljs.core._nth(params,(5));
var G__59220 = cljs.core._nth(params,(6));
var G__59221 = cljs.core._nth(params,(7));
var G__59222 = cljs.core._nth(params,(8));
var G__59223 = cljs.core._nth(params,(9));
var G__59224 = cljs.core._nth(params,(10));
return (function sci$impl$fns$fun_$_arity_11(G__59203,G__59204,G__59205,G__59206,G__59207,G__59208,G__59209,G__59210,G__59211,G__59212,G__59213){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59214,G__59203);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59215,G__59204);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59216,G__59205);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59217,G__59206);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59218,G__59207);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59219,G__59208);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59220,G__59209);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59221,G__59210);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59222,G__59211);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59223,G__59212);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59224,G__59213);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$12,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60227 = cljs.core._nth(recur_val,(0));
var G__60228 = cljs.core._nth(recur_val,(1));
var G__60229 = cljs.core._nth(recur_val,(2));
var G__60230 = cljs.core._nth(recur_val,(3));
var G__60231 = cljs.core._nth(recur_val,(4));
var G__60232 = cljs.core._nth(recur_val,(5));
var G__60233 = cljs.core._nth(recur_val,(6));
var G__60234 = cljs.core._nth(recur_val,(7));
var G__60235 = cljs.core._nth(recur_val,(8));
var G__60236 = cljs.core._nth(recur_val,(9));
var G__60237 = cljs.core._nth(recur_val,(10));
G__59203 = G__60227;
G__59204 = G__60228;
G__59205 = G__60229;
G__59206 = G__60230;
G__59207 = G__60231;
G__59208 = G__60232;
G__59209 = G__60233;
G__59210 = G__60234;
G__59211 = G__60235;
G__59212 = G__60236;
G__59213 = G__60237;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59236 = cljs.core._nth(params,(0));
var G__59237 = cljs.core._nth(params,(1));
var G__59238 = cljs.core._nth(params,(2));
var G__59239 = cljs.core._nth(params,(3));
var G__59240 = cljs.core._nth(params,(4));
var G__59241 = cljs.core._nth(params,(5));
var G__59242 = cljs.core._nth(params,(6));
var G__59243 = cljs.core._nth(params,(7));
var G__59244 = cljs.core._nth(params,(8));
var G__59245 = cljs.core._nth(params,(9));
var G__59246 = cljs.core._nth(params,(10));
return (function sci$impl$fns$fun_$_arity_11(G__59225,G__59226,G__59227,G__59228,G__59229,G__59230,G__59231,G__59232,G__59233,G__59234,G__59235){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((11),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59236,G__59225);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59237,G__59226);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59238,G__59227);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59239,G__59228);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59240,G__59229);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59241,G__59230);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59242,G__59231);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59243,G__59232);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59244,G__59233);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59245,G__59234);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59246,G__59235);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$12,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60239 = cljs.core._nth(recur_val,(0));
var G__60240 = cljs.core._nth(recur_val,(1));
var G__60241 = cljs.core._nth(recur_val,(2));
var G__60242 = cljs.core._nth(recur_val,(3));
var G__60243 = cljs.core._nth(recur_val,(4));
var G__60244 = cljs.core._nth(recur_val,(5));
var G__60245 = cljs.core._nth(recur_val,(6));
var G__60246 = cljs.core._nth(recur_val,(7));
var G__60247 = cljs.core._nth(recur_val,(8));
var G__60248 = cljs.core._nth(recur_val,(9));
var G__60249 = cljs.core._nth(recur_val,(10));
G__59225 = G__60239;
G__59226 = G__60240;
G__59227 = G__60241;
G__59228 = G__60242;
G__59229 = G__60243;
G__59230 = G__60244;
G__59231 = G__60245;
G__59232 = G__60246;
G__59233 = G__60247;
G__59234 = G__60248;
G__59235 = G__60249;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (12):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59259 = cljs.core._nth(params,(0));
var G__59260 = cljs.core._nth(params,(1));
var G__59261 = cljs.core._nth(params,(2));
var G__59262 = cljs.core._nth(params,(3));
var G__59263 = cljs.core._nth(params,(4));
var G__59264 = cljs.core._nth(params,(5));
var G__59265 = cljs.core._nth(params,(6));
var G__59266 = cljs.core._nth(params,(7));
var G__59267 = cljs.core._nth(params,(8));
var G__59268 = cljs.core._nth(params,(9));
var G__59269 = cljs.core._nth(params,(10));
var G__59270 = cljs.core._nth(params,(11));
return (function sci$impl$fns$fun_$_arity_12(G__59247,G__59248,G__59249,G__59250,G__59251,G__59252,G__59253,G__59254,G__59255,G__59256,G__59257,G__59258){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59259,G__59247);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59260,G__59248);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59261,G__59249);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59262,G__59250);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59263,G__59251);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59264,G__59252);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59265,G__59253);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59266,G__59254);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59267,G__59255);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59268,G__59256);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59269,G__59257);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59270,G__59258);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$13,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60259 = cljs.core._nth(recur_val,(0));
var G__60260 = cljs.core._nth(recur_val,(1));
var G__60261 = cljs.core._nth(recur_val,(2));
var G__60262 = cljs.core._nth(recur_val,(3));
var G__60263 = cljs.core._nth(recur_val,(4));
var G__60264 = cljs.core._nth(recur_val,(5));
var G__60265 = cljs.core._nth(recur_val,(6));
var G__60266 = cljs.core._nth(recur_val,(7));
var G__60267 = cljs.core._nth(recur_val,(8));
var G__60268 = cljs.core._nth(recur_val,(9));
var G__60269 = cljs.core._nth(recur_val,(10));
var G__60270 = cljs.core._nth(recur_val,(11));
G__59247 = G__60259;
G__59248 = G__60260;
G__59249 = G__60261;
G__59250 = G__60262;
G__59251 = G__60263;
G__59252 = G__60264;
G__59253 = G__60265;
G__59254 = G__60266;
G__59255 = G__60267;
G__59256 = G__60268;
G__59257 = G__60269;
G__59258 = G__60270;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59292 = cljs.core._nth(params,(0));
var G__59293 = cljs.core._nth(params,(1));
var G__59294 = cljs.core._nth(params,(2));
var G__59295 = cljs.core._nth(params,(3));
var G__59296 = cljs.core._nth(params,(4));
var G__59297 = cljs.core._nth(params,(5));
var G__59298 = cljs.core._nth(params,(6));
var G__59299 = cljs.core._nth(params,(7));
var G__59300 = cljs.core._nth(params,(8));
var G__59301 = cljs.core._nth(params,(9));
var G__59302 = cljs.core._nth(params,(10));
var G__59303 = cljs.core._nth(params,(11));
return (function sci$impl$fns$fun_$_arity_12(G__59280,G__59281,G__59282,G__59283,G__59284,G__59285,G__59286,G__59287,G__59288,G__59289,G__59290,G__59291){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((12),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59292,G__59280);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59293,G__59281);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59294,G__59282);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59295,G__59283);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59296,G__59284);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59297,G__59285);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59298,G__59286);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59299,G__59287);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59300,G__59288);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59301,G__59289);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59302,G__59290);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59303,G__59291);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$13,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60284 = cljs.core._nth(recur_val,(0));
var G__60285 = cljs.core._nth(recur_val,(1));
var G__60286 = cljs.core._nth(recur_val,(2));
var G__60287 = cljs.core._nth(recur_val,(3));
var G__60288 = cljs.core._nth(recur_val,(4));
var G__60289 = cljs.core._nth(recur_val,(5));
var G__60290 = cljs.core._nth(recur_val,(6));
var G__60291 = cljs.core._nth(recur_val,(7));
var G__60292 = cljs.core._nth(recur_val,(8));
var G__60293 = cljs.core._nth(recur_val,(9));
var G__60294 = cljs.core._nth(recur_val,(10));
var G__60295 = cljs.core._nth(recur_val,(11));
G__59280 = G__60284;
G__59281 = G__60285;
G__59282 = G__60286;
G__59283 = G__60287;
G__59284 = G__60288;
G__59285 = G__60289;
G__59286 = G__60290;
G__59287 = G__60291;
G__59288 = G__60292;
G__59289 = G__60293;
G__59290 = G__60294;
G__59291 = G__60295;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (13):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59330 = cljs.core._nth(params,(0));
var G__59331 = cljs.core._nth(params,(1));
var G__59332 = cljs.core._nth(params,(2));
var G__59333 = cljs.core._nth(params,(3));
var G__59334 = cljs.core._nth(params,(4));
var G__59335 = cljs.core._nth(params,(5));
var G__59336 = cljs.core._nth(params,(6));
var G__59337 = cljs.core._nth(params,(7));
var G__59338 = cljs.core._nth(params,(8));
var G__59339 = cljs.core._nth(params,(9));
var G__59340 = cljs.core._nth(params,(10));
var G__59341 = cljs.core._nth(params,(11));
var G__59342 = cljs.core._nth(params,(12));
return (function sci$impl$fns$fun_$_arity_13(G__59317,G__59318,G__59319,G__59320,G__59321,G__59322,G__59323,G__59324,G__59325,G__59326,G__59327,G__59328,G__59329){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59330,G__59317);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59331,G__59318);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59332,G__59319);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59333,G__59320);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59334,G__59321);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59335,G__59322);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59336,G__59323);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59337,G__59324);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59338,G__59325);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59339,G__59326);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59340,G__59327);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59341,G__59328);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59342,G__59329);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$14,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60307 = cljs.core._nth(recur_val,(0));
var G__60308 = cljs.core._nth(recur_val,(1));
var G__60309 = cljs.core._nth(recur_val,(2));
var G__60310 = cljs.core._nth(recur_val,(3));
var G__60311 = cljs.core._nth(recur_val,(4));
var G__60312 = cljs.core._nth(recur_val,(5));
var G__60313 = cljs.core._nth(recur_val,(6));
var G__60314 = cljs.core._nth(recur_val,(7));
var G__60315 = cljs.core._nth(recur_val,(8));
var G__60316 = cljs.core._nth(recur_val,(9));
var G__60317 = cljs.core._nth(recur_val,(10));
var G__60318 = cljs.core._nth(recur_val,(11));
var G__60319 = cljs.core._nth(recur_val,(12));
G__59317 = G__60307;
G__59318 = G__60308;
G__59319 = G__60309;
G__59320 = G__60310;
G__59321 = G__60311;
G__59322 = G__60312;
G__59323 = G__60313;
G__59324 = G__60314;
G__59325 = G__60315;
G__59326 = G__60316;
G__59327 = G__60317;
G__59328 = G__60318;
G__59329 = G__60319;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59356 = cljs.core._nth(params,(0));
var G__59357 = cljs.core._nth(params,(1));
var G__59358 = cljs.core._nth(params,(2));
var G__59359 = cljs.core._nth(params,(3));
var G__59360 = cljs.core._nth(params,(4));
var G__59361 = cljs.core._nth(params,(5));
var G__59362 = cljs.core._nth(params,(6));
var G__59363 = cljs.core._nth(params,(7));
var G__59364 = cljs.core._nth(params,(8));
var G__59365 = cljs.core._nth(params,(9));
var G__59366 = cljs.core._nth(params,(10));
var G__59367 = cljs.core._nth(params,(11));
var G__59368 = cljs.core._nth(params,(12));
return (function sci$impl$fns$fun_$_arity_13(G__59343,G__59344,G__59345,G__59346,G__59347,G__59348,G__59349,G__59350,G__59351,G__59352,G__59353,G__59354,G__59355){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((13),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59356,G__59343);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59357,G__59344);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59358,G__59345);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59359,G__59346);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59360,G__59347);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59361,G__59348);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59362,G__59349);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59363,G__59350);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59364,G__59351);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59365,G__59352);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59366,G__59353);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59367,G__59354);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59368,G__59355);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$14,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60327 = cljs.core._nth(recur_val,(0));
var G__60328 = cljs.core._nth(recur_val,(1));
var G__60329 = cljs.core._nth(recur_val,(2));
var G__60330 = cljs.core._nth(recur_val,(3));
var G__60331 = cljs.core._nth(recur_val,(4));
var G__60332 = cljs.core._nth(recur_val,(5));
var G__60333 = cljs.core._nth(recur_val,(6));
var G__60334 = cljs.core._nth(recur_val,(7));
var G__60335 = cljs.core._nth(recur_val,(8));
var G__60336 = cljs.core._nth(recur_val,(9));
var G__60337 = cljs.core._nth(recur_val,(10));
var G__60338 = cljs.core._nth(recur_val,(11));
var G__60339 = cljs.core._nth(recur_val,(12));
G__59343 = G__60327;
G__59344 = G__60328;
G__59345 = G__60329;
G__59346 = G__60330;
G__59347 = G__60331;
G__59348 = G__60332;
G__59349 = G__60333;
G__59350 = G__60334;
G__59351 = G__60335;
G__59352 = G__60336;
G__59353 = G__60337;
G__59354 = G__60338;
G__59355 = G__60339;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (14):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59384 = cljs.core._nth(params,(0));
var G__59385 = cljs.core._nth(params,(1));
var G__59386 = cljs.core._nth(params,(2));
var G__59387 = cljs.core._nth(params,(3));
var G__59388 = cljs.core._nth(params,(4));
var G__59389 = cljs.core._nth(params,(5));
var G__59390 = cljs.core._nth(params,(6));
var G__59391 = cljs.core._nth(params,(7));
var G__59392 = cljs.core._nth(params,(8));
var G__59393 = cljs.core._nth(params,(9));
var G__59394 = cljs.core._nth(params,(10));
var G__59395 = cljs.core._nth(params,(11));
var G__59396 = cljs.core._nth(params,(12));
var G__59397 = cljs.core._nth(params,(13));
var G__59398 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__59369,G__59370,G__59371,G__59372,G__59373,G__59374,G__59375,G__59376,G__59377,G__59378,G__59379,G__59380,G__59381,G__59382,G__59383){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59384,G__59369);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59385,G__59370);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59386,G__59371);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59387,G__59372);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59388,G__59373);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59389,G__59374);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59390,G__59375);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59391,G__59376);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59392,G__59377);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59393,G__59378);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59394,G__59379);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59395,G__59380);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59396,G__59381);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59397,G__59382);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59398,G__59383);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60348 = cljs.core._nth(recur_val,(0));
var G__60349 = cljs.core._nth(recur_val,(1));
var G__60350 = cljs.core._nth(recur_val,(2));
var G__60351 = cljs.core._nth(recur_val,(3));
var G__60352 = cljs.core._nth(recur_val,(4));
var G__60353 = cljs.core._nth(recur_val,(5));
var G__60354 = cljs.core._nth(recur_val,(6));
var G__60355 = cljs.core._nth(recur_val,(7));
var G__60356 = cljs.core._nth(recur_val,(8));
var G__60357 = cljs.core._nth(recur_val,(9));
var G__60358 = cljs.core._nth(recur_val,(10));
var G__60359 = cljs.core._nth(recur_val,(11));
var G__60360 = cljs.core._nth(recur_val,(12));
var G__60361 = cljs.core._nth(recur_val,(13));
var G__60362 = cljs.core._nth(recur_val,(14));
G__59369 = G__60348;
G__59370 = G__60349;
G__59371 = G__60350;
G__59372 = G__60351;
G__59373 = G__60352;
G__59374 = G__60353;
G__59375 = G__60354;
G__59376 = G__60355;
G__59377 = G__60356;
G__59378 = G__60357;
G__59379 = G__60358;
G__59380 = G__60359;
G__59381 = G__60360;
G__59382 = G__60361;
G__59383 = G__60362;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59414 = cljs.core._nth(params,(0));
var G__59415 = cljs.core._nth(params,(1));
var G__59416 = cljs.core._nth(params,(2));
var G__59417 = cljs.core._nth(params,(3));
var G__59418 = cljs.core._nth(params,(4));
var G__59419 = cljs.core._nth(params,(5));
var G__59420 = cljs.core._nth(params,(6));
var G__59421 = cljs.core._nth(params,(7));
var G__59422 = cljs.core._nth(params,(8));
var G__59423 = cljs.core._nth(params,(9));
var G__59424 = cljs.core._nth(params,(10));
var G__59425 = cljs.core._nth(params,(11));
var G__59426 = cljs.core._nth(params,(12));
var G__59427 = cljs.core._nth(params,(13));
var G__59428 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__59399,G__59400,G__59401,G__59402,G__59403,G__59404,G__59405,G__59406,G__59407,G__59408,G__59409,G__59410,G__59411,G__59412,G__59413){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((15),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59414,G__59399);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59415,G__59400);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59416,G__59401);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59417,G__59402);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59418,G__59403);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59419,G__59404);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59420,G__59405);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59421,G__59406);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59422,G__59407);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59423,G__59408);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59424,G__59409);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59425,G__59410);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59426,G__59411);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59427,G__59412);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59428,G__59413);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60367 = cljs.core._nth(recur_val,(0));
var G__60368 = cljs.core._nth(recur_val,(1));
var G__60369 = cljs.core._nth(recur_val,(2));
var G__60370 = cljs.core._nth(recur_val,(3));
var G__60371 = cljs.core._nth(recur_val,(4));
var G__60372 = cljs.core._nth(recur_val,(5));
var G__60373 = cljs.core._nth(recur_val,(6));
var G__60374 = cljs.core._nth(recur_val,(7));
var G__60375 = cljs.core._nth(recur_val,(8));
var G__60376 = cljs.core._nth(recur_val,(9));
var G__60377 = cljs.core._nth(recur_val,(10));
var G__60378 = cljs.core._nth(recur_val,(11));
var G__60379 = cljs.core._nth(recur_val,(12));
var G__60380 = cljs.core._nth(recur_val,(13));
var G__60381 = cljs.core._nth(recur_val,(14));
G__59399 = G__60367;
G__59400 = G__60368;
G__59401 = G__60369;
G__59402 = G__60370;
G__59403 = G__60371;
G__59404 = G__60372;
G__59405 = G__60373;
G__59406 = G__60374;
G__59407 = G__60375;
G__59408 = G__60376;
G__59409 = G__60377;
G__59410 = G__60378;
G__59411 = G__60379;
G__59412 = G__60380;
G__59413 = G__60381;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (15):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59444 = cljs.core._nth(params,(0));
var G__59445 = cljs.core._nth(params,(1));
var G__59446 = cljs.core._nth(params,(2));
var G__59447 = cljs.core._nth(params,(3));
var G__59448 = cljs.core._nth(params,(4));
var G__59449 = cljs.core._nth(params,(5));
var G__59450 = cljs.core._nth(params,(6));
var G__59451 = cljs.core._nth(params,(7));
var G__59452 = cljs.core._nth(params,(8));
var G__59453 = cljs.core._nth(params,(9));
var G__59454 = cljs.core._nth(params,(10));
var G__59455 = cljs.core._nth(params,(11));
var G__59456 = cljs.core._nth(params,(12));
var G__59457 = cljs.core._nth(params,(13));
var G__59458 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__59429,G__59430,G__59431,G__59432,G__59433,G__59434,G__59435,G__59436,G__59437,G__59438,G__59439,G__59440,G__59441,G__59442,G__59443){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59444,G__59429);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59445,G__59430);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59446,G__59431);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59447,G__59432);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59448,G__59433);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59449,G__59434);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59450,G__59435);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59451,G__59436);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59452,G__59437);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59453,G__59438);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59454,G__59439);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59455,G__59440);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59456,G__59441);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59457,G__59442);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59458,G__59443);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60405 = cljs.core._nth(recur_val,(0));
var G__60406 = cljs.core._nth(recur_val,(1));
var G__60407 = cljs.core._nth(recur_val,(2));
var G__60408 = cljs.core._nth(recur_val,(3));
var G__60409 = cljs.core._nth(recur_val,(4));
var G__60410 = cljs.core._nth(recur_val,(5));
var G__60411 = cljs.core._nth(recur_val,(6));
var G__60412 = cljs.core._nth(recur_val,(7));
var G__60413 = cljs.core._nth(recur_val,(8));
var G__60414 = cljs.core._nth(recur_val,(9));
var G__60415 = cljs.core._nth(recur_val,(10));
var G__60416 = cljs.core._nth(recur_val,(11));
var G__60417 = cljs.core._nth(recur_val,(12));
var G__60418 = cljs.core._nth(recur_val,(13));
var G__60419 = cljs.core._nth(recur_val,(14));
G__59429 = G__60405;
G__59430 = G__60406;
G__59431 = G__60407;
G__59432 = G__60408;
G__59433 = G__60409;
G__59434 = G__60410;
G__59435 = G__60411;
G__59436 = G__60412;
G__59437 = G__60413;
G__59438 = G__60414;
G__59439 = G__60415;
G__59440 = G__60416;
G__59441 = G__60417;
G__59442 = G__60418;
G__59443 = G__60419;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59474 = cljs.core._nth(params,(0));
var G__59475 = cljs.core._nth(params,(1));
var G__59476 = cljs.core._nth(params,(2));
var G__59477 = cljs.core._nth(params,(3));
var G__59478 = cljs.core._nth(params,(4));
var G__59479 = cljs.core._nth(params,(5));
var G__59480 = cljs.core._nth(params,(6));
var G__59481 = cljs.core._nth(params,(7));
var G__59482 = cljs.core._nth(params,(8));
var G__59483 = cljs.core._nth(params,(9));
var G__59484 = cljs.core._nth(params,(10));
var G__59485 = cljs.core._nth(params,(11));
var G__59486 = cljs.core._nth(params,(12));
var G__59487 = cljs.core._nth(params,(13));
var G__59488 = cljs.core._nth(params,(14));
return (function sci$impl$fns$fun_$_arity_15(G__59459,G__59460,G__59461,G__59462,G__59463,G__59464,G__59465,G__59466,G__59467,G__59468,G__59469,G__59470,G__59471,G__59472,G__59473){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((15),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59474,G__59459);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59475,G__59460);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59476,G__59461);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59477,G__59462);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59478,G__59463);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59479,G__59464);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59480,G__59465);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59481,G__59466);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59482,G__59467);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59483,G__59468);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59484,G__59469);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59485,G__59470);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59486,G__59471);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59487,G__59472);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59488,G__59473);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$16,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60453 = cljs.core._nth(recur_val,(0));
var G__60454 = cljs.core._nth(recur_val,(1));
var G__60455 = cljs.core._nth(recur_val,(2));
var G__60456 = cljs.core._nth(recur_val,(3));
var G__60457 = cljs.core._nth(recur_val,(4));
var G__60458 = cljs.core._nth(recur_val,(5));
var G__60459 = cljs.core._nth(recur_val,(6));
var G__60460 = cljs.core._nth(recur_val,(7));
var G__60461 = cljs.core._nth(recur_val,(8));
var G__60462 = cljs.core._nth(recur_val,(9));
var G__60463 = cljs.core._nth(recur_val,(10));
var G__60464 = cljs.core._nth(recur_val,(11));
var G__60465 = cljs.core._nth(recur_val,(12));
var G__60466 = cljs.core._nth(recur_val,(13));
var G__60467 = cljs.core._nth(recur_val,(14));
G__59459 = G__60453;
G__59460 = G__60454;
G__59461 = G__60455;
G__59462 = G__60456;
G__59463 = G__60457;
G__59464 = G__60458;
G__59465 = G__60459;
G__59466 = G__60460;
G__59467 = G__60461;
G__59468 = G__60462;
G__59469 = G__60463;
G__59470 = G__60464;
G__59471 = G__60465;
G__59472 = G__60466;
G__59473 = G__60467;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (16):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59516 = cljs.core._nth(params,(0));
var G__59517 = cljs.core._nth(params,(1));
var G__59518 = cljs.core._nth(params,(2));
var G__59519 = cljs.core._nth(params,(3));
var G__59520 = cljs.core._nth(params,(4));
var G__59521 = cljs.core._nth(params,(5));
var G__59522 = cljs.core._nth(params,(6));
var G__59523 = cljs.core._nth(params,(7));
var G__59524 = cljs.core._nth(params,(8));
var G__59525 = cljs.core._nth(params,(9));
var G__59526 = cljs.core._nth(params,(10));
var G__59527 = cljs.core._nth(params,(11));
var G__59528 = cljs.core._nth(params,(12));
var G__59529 = cljs.core._nth(params,(13));
var G__59530 = cljs.core._nth(params,(14));
var G__59531 = cljs.core._nth(params,(15));
return (function sci$impl$fns$fun_$_arity_16(G__59500,G__59501,G__59502,G__59503,G__59504,G__59505,G__59506,G__59507,G__59508,G__59509,G__59510,G__59511,G__59512,G__59513,G__59514,G__59515){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59516,G__59500);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59517,G__59501);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59518,G__59502);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59519,G__59503);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59520,G__59504);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59521,G__59505);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59522,G__59506);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59523,G__59507);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59524,G__59508);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59525,G__59509);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59526,G__59510);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59527,G__59511);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59528,G__59512);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59529,G__59513);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59530,G__59514);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59531,G__59515);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$17,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60471 = cljs.core._nth(recur_val,(0));
var G__60472 = cljs.core._nth(recur_val,(1));
var G__60473 = cljs.core._nth(recur_val,(2));
var G__60474 = cljs.core._nth(recur_val,(3));
var G__60475 = cljs.core._nth(recur_val,(4));
var G__60476 = cljs.core._nth(recur_val,(5));
var G__60477 = cljs.core._nth(recur_val,(6));
var G__60478 = cljs.core._nth(recur_val,(7));
var G__60479 = cljs.core._nth(recur_val,(8));
var G__60480 = cljs.core._nth(recur_val,(9));
var G__60481 = cljs.core._nth(recur_val,(10));
var G__60482 = cljs.core._nth(recur_val,(11));
var G__60483 = cljs.core._nth(recur_val,(12));
var G__60484 = cljs.core._nth(recur_val,(13));
var G__60485 = cljs.core._nth(recur_val,(14));
var G__60486 = cljs.core._nth(recur_val,(15));
G__59500 = G__60471;
G__59501 = G__60472;
G__59502 = G__60473;
G__59503 = G__60474;
G__59504 = G__60475;
G__59505 = G__60476;
G__59506 = G__60477;
G__59507 = G__60478;
G__59508 = G__60479;
G__59509 = G__60480;
G__59510 = G__60481;
G__59511 = G__60482;
G__59512 = G__60483;
G__59513 = G__60484;
G__59514 = G__60485;
G__59515 = G__60486;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59551 = cljs.core._nth(params,(0));
var G__59552 = cljs.core._nth(params,(1));
var G__59553 = cljs.core._nth(params,(2));
var G__59554 = cljs.core._nth(params,(3));
var G__59555 = cljs.core._nth(params,(4));
var G__59556 = cljs.core._nth(params,(5));
var G__59557 = cljs.core._nth(params,(6));
var G__59558 = cljs.core._nth(params,(7));
var G__59559 = cljs.core._nth(params,(8));
var G__59560 = cljs.core._nth(params,(9));
var G__59561 = cljs.core._nth(params,(10));
var G__59562 = cljs.core._nth(params,(11));
var G__59563 = cljs.core._nth(params,(12));
var G__59564 = cljs.core._nth(params,(13));
var G__59565 = cljs.core._nth(params,(14));
var G__59566 = cljs.core._nth(params,(15));
return (function sci$impl$fns$fun_$_arity_16(G__59535,G__59536,G__59537,G__59538,G__59539,G__59540,G__59541,G__59542,G__59543,G__59544,G__59545,G__59546,G__59547,G__59548,G__59549,G__59550){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((16),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59551,G__59535);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59552,G__59536);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59553,G__59537);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59554,G__59538);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59555,G__59539);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59556,G__59540);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59557,G__59541);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59558,G__59542);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59559,G__59543);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59560,G__59544);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59561,G__59545);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59562,G__59546);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59563,G__59547);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59564,G__59548);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59565,G__59549);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59566,G__59550);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$17,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60503 = cljs.core._nth(recur_val,(0));
var G__60504 = cljs.core._nth(recur_val,(1));
var G__60505 = cljs.core._nth(recur_val,(2));
var G__60506 = cljs.core._nth(recur_val,(3));
var G__60507 = cljs.core._nth(recur_val,(4));
var G__60508 = cljs.core._nth(recur_val,(5));
var G__60509 = cljs.core._nth(recur_val,(6));
var G__60510 = cljs.core._nth(recur_val,(7));
var G__60511 = cljs.core._nth(recur_val,(8));
var G__60512 = cljs.core._nth(recur_val,(9));
var G__60513 = cljs.core._nth(recur_val,(10));
var G__60514 = cljs.core._nth(recur_val,(11));
var G__60515 = cljs.core._nth(recur_val,(12));
var G__60516 = cljs.core._nth(recur_val,(13));
var G__60517 = cljs.core._nth(recur_val,(14));
var G__60518 = cljs.core._nth(recur_val,(15));
G__59535 = G__60503;
G__59536 = G__60504;
G__59537 = G__60505;
G__59538 = G__60506;
G__59539 = G__60507;
G__59540 = G__60508;
G__59541 = G__60509;
G__59542 = G__60510;
G__59543 = G__60511;
G__59544 = G__60512;
G__59545 = G__60513;
G__59546 = G__60514;
G__59547 = G__60515;
G__59548 = G__60516;
G__59549 = G__60517;
G__59550 = G__60518;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (17):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59584 = cljs.core._nth(params,(0));
var G__59585 = cljs.core._nth(params,(1));
var G__59586 = cljs.core._nth(params,(2));
var G__59587 = cljs.core._nth(params,(3));
var G__59588 = cljs.core._nth(params,(4));
var G__59589 = cljs.core._nth(params,(5));
var G__59590 = cljs.core._nth(params,(6));
var G__59591 = cljs.core._nth(params,(7));
var G__59592 = cljs.core._nth(params,(8));
var G__59593 = cljs.core._nth(params,(9));
var G__59594 = cljs.core._nth(params,(10));
var G__59595 = cljs.core._nth(params,(11));
var G__59596 = cljs.core._nth(params,(12));
var G__59597 = cljs.core._nth(params,(13));
var G__59598 = cljs.core._nth(params,(14));
var G__59599 = cljs.core._nth(params,(15));
var G__59600 = cljs.core._nth(params,(16));
return (function sci$impl$fns$fun_$_arity_17(G__59567,G__59568,G__59569,G__59570,G__59571,G__59572,G__59573,G__59574,G__59575,G__59576,G__59577,G__59578,G__59579,G__59580,G__59581,G__59582,G__59583){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59584,G__59567);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59585,G__59568);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59586,G__59569);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59587,G__59570);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59588,G__59571);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59589,G__59572);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59590,G__59573);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59591,G__59574);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59592,G__59575);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59593,G__59576);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59594,G__59577);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59595,G__59578);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59596,G__59579);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59597,G__59580);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59598,G__59581);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59599,G__59582);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59600,G__59583);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$18,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60520 = cljs.core._nth(recur_val,(0));
var G__60521 = cljs.core._nth(recur_val,(1));
var G__60522 = cljs.core._nth(recur_val,(2));
var G__60523 = cljs.core._nth(recur_val,(3));
var G__60524 = cljs.core._nth(recur_val,(4));
var G__60525 = cljs.core._nth(recur_val,(5));
var G__60526 = cljs.core._nth(recur_val,(6));
var G__60527 = cljs.core._nth(recur_val,(7));
var G__60528 = cljs.core._nth(recur_val,(8));
var G__60529 = cljs.core._nth(recur_val,(9));
var G__60530 = cljs.core._nth(recur_val,(10));
var G__60531 = cljs.core._nth(recur_val,(11));
var G__60532 = cljs.core._nth(recur_val,(12));
var G__60533 = cljs.core._nth(recur_val,(13));
var G__60534 = cljs.core._nth(recur_val,(14));
var G__60535 = cljs.core._nth(recur_val,(15));
var G__60536 = cljs.core._nth(recur_val,(16));
G__59567 = G__60520;
G__59568 = G__60521;
G__59569 = G__60522;
G__59570 = G__60523;
G__59571 = G__60524;
G__59572 = G__60525;
G__59573 = G__60526;
G__59574 = G__60527;
G__59575 = G__60528;
G__59576 = G__60529;
G__59577 = G__60530;
G__59578 = G__60531;
G__59579 = G__60532;
G__59580 = G__60533;
G__59581 = G__60534;
G__59582 = G__60535;
G__59583 = G__60536;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59618 = cljs.core._nth(params,(0));
var G__59619 = cljs.core._nth(params,(1));
var G__59620 = cljs.core._nth(params,(2));
var G__59621 = cljs.core._nth(params,(3));
var G__59622 = cljs.core._nth(params,(4));
var G__59623 = cljs.core._nth(params,(5));
var G__59624 = cljs.core._nth(params,(6));
var G__59625 = cljs.core._nth(params,(7));
var G__59626 = cljs.core._nth(params,(8));
var G__59627 = cljs.core._nth(params,(9));
var G__59628 = cljs.core._nth(params,(10));
var G__59629 = cljs.core._nth(params,(11));
var G__59630 = cljs.core._nth(params,(12));
var G__59631 = cljs.core._nth(params,(13));
var G__59632 = cljs.core._nth(params,(14));
var G__59633 = cljs.core._nth(params,(15));
var G__59634 = cljs.core._nth(params,(16));
return (function sci$impl$fns$fun_$_arity_17(G__59601,G__59602,G__59603,G__59604,G__59605,G__59606,G__59607,G__59608,G__59609,G__59610,G__59611,G__59612,G__59613,G__59614,G__59615,G__59616,G__59617){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((17),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59618,G__59601);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59619,G__59602);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59620,G__59603);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59621,G__59604);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59622,G__59605);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59623,G__59606);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59624,G__59607);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59625,G__59608);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59626,G__59609);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59627,G__59610);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59628,G__59611);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59629,G__59612);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59630,G__59613);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59631,G__59614);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59632,G__59615);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59633,G__59616);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59634,G__59617);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$18,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60546 = cljs.core._nth(recur_val,(0));
var G__60547 = cljs.core._nth(recur_val,(1));
var G__60548 = cljs.core._nth(recur_val,(2));
var G__60549 = cljs.core._nth(recur_val,(3));
var G__60550 = cljs.core._nth(recur_val,(4));
var G__60551 = cljs.core._nth(recur_val,(5));
var G__60552 = cljs.core._nth(recur_val,(6));
var G__60553 = cljs.core._nth(recur_val,(7));
var G__60554 = cljs.core._nth(recur_val,(8));
var G__60555 = cljs.core._nth(recur_val,(9));
var G__60556 = cljs.core._nth(recur_val,(10));
var G__60557 = cljs.core._nth(recur_val,(11));
var G__60558 = cljs.core._nth(recur_val,(12));
var G__60559 = cljs.core._nth(recur_val,(13));
var G__60560 = cljs.core._nth(recur_val,(14));
var G__60561 = cljs.core._nth(recur_val,(15));
var G__60562 = cljs.core._nth(recur_val,(16));
G__59601 = G__60546;
G__59602 = G__60547;
G__59603 = G__60548;
G__59604 = G__60549;
G__59605 = G__60550;
G__59606 = G__60551;
G__59607 = G__60552;
G__59608 = G__60553;
G__59609 = G__60554;
G__59610 = G__60555;
G__59611 = G__60556;
G__59612 = G__60557;
G__59613 = G__60558;
G__59614 = G__60559;
G__59615 = G__60560;
G__59616 = G__60561;
G__59617 = G__60562;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (18):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59653 = cljs.core._nth(params,(0));
var G__59654 = cljs.core._nth(params,(1));
var G__59655 = cljs.core._nth(params,(2));
var G__59656 = cljs.core._nth(params,(3));
var G__59657 = cljs.core._nth(params,(4));
var G__59658 = cljs.core._nth(params,(5));
var G__59659 = cljs.core._nth(params,(6));
var G__59660 = cljs.core._nth(params,(7));
var G__59661 = cljs.core._nth(params,(8));
var G__59662 = cljs.core._nth(params,(9));
var G__59663 = cljs.core._nth(params,(10));
var G__59664 = cljs.core._nth(params,(11));
var G__59665 = cljs.core._nth(params,(12));
var G__59666 = cljs.core._nth(params,(13));
var G__59667 = cljs.core._nth(params,(14));
var G__59668 = cljs.core._nth(params,(15));
var G__59669 = cljs.core._nth(params,(16));
var G__59670 = cljs.core._nth(params,(17));
return (function sci$impl$fns$fun_$_arity_18(G__59635,G__59636,G__59637,G__59638,G__59639,G__59640,G__59641,G__59642,G__59643,G__59644,G__59645,G__59646,G__59647,G__59648,G__59649,G__59650,G__59651,G__59652){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59653,G__59635);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59654,G__59636);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59655,G__59637);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59656,G__59638);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59657,G__59639);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59658,G__59640);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59659,G__59641);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59660,G__59642);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59661,G__59643);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59662,G__59644);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59663,G__59645);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59664,G__59646);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59665,G__59647);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59666,G__59648);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59667,G__59649);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59668,G__59650);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59669,G__59651);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59670,G__59652);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$19,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60566 = cljs.core._nth(recur_val,(0));
var G__60567 = cljs.core._nth(recur_val,(1));
var G__60568 = cljs.core._nth(recur_val,(2));
var G__60569 = cljs.core._nth(recur_val,(3));
var G__60570 = cljs.core._nth(recur_val,(4));
var G__60571 = cljs.core._nth(recur_val,(5));
var G__60572 = cljs.core._nth(recur_val,(6));
var G__60573 = cljs.core._nth(recur_val,(7));
var G__60574 = cljs.core._nth(recur_val,(8));
var G__60575 = cljs.core._nth(recur_val,(9));
var G__60576 = cljs.core._nth(recur_val,(10));
var G__60577 = cljs.core._nth(recur_val,(11));
var G__60578 = cljs.core._nth(recur_val,(12));
var G__60579 = cljs.core._nth(recur_val,(13));
var G__60580 = cljs.core._nth(recur_val,(14));
var G__60581 = cljs.core._nth(recur_val,(15));
var G__60582 = cljs.core._nth(recur_val,(16));
var G__60583 = cljs.core._nth(recur_val,(17));
G__59635 = G__60566;
G__59636 = G__60567;
G__59637 = G__60568;
G__59638 = G__60569;
G__59639 = G__60570;
G__59640 = G__60571;
G__59641 = G__60572;
G__59642 = G__60573;
G__59643 = G__60574;
G__59644 = G__60575;
G__59645 = G__60576;
G__59646 = G__60577;
G__59647 = G__60578;
G__59648 = G__60579;
G__59649 = G__60580;
G__59650 = G__60581;
G__59651 = G__60582;
G__59652 = G__60583;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59689 = cljs.core._nth(params,(0));
var G__59690 = cljs.core._nth(params,(1));
var G__59691 = cljs.core._nth(params,(2));
var G__59692 = cljs.core._nth(params,(3));
var G__59693 = cljs.core._nth(params,(4));
var G__59694 = cljs.core._nth(params,(5));
var G__59695 = cljs.core._nth(params,(6));
var G__59696 = cljs.core._nth(params,(7));
var G__59697 = cljs.core._nth(params,(8));
var G__59698 = cljs.core._nth(params,(9));
var G__59699 = cljs.core._nth(params,(10));
var G__59700 = cljs.core._nth(params,(11));
var G__59701 = cljs.core._nth(params,(12));
var G__59702 = cljs.core._nth(params,(13));
var G__59703 = cljs.core._nth(params,(14));
var G__59704 = cljs.core._nth(params,(15));
var G__59705 = cljs.core._nth(params,(16));
var G__59706 = cljs.core._nth(params,(17));
return (function sci$impl$fns$fun_$_arity_18(G__59671,G__59672,G__59673,G__59674,G__59675,G__59676,G__59677,G__59678,G__59679,G__59680,G__59681,G__59682,G__59683,G__59684,G__59685,G__59686,G__59687,G__59688){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((18),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59689,G__59671);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59690,G__59672);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59691,G__59673);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59692,G__59674);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59693,G__59675);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59694,G__59676);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59695,G__59677);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59696,G__59678);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59697,G__59679);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59698,G__59680);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59699,G__59681);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59700,G__59682);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59701,G__59683);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59702,G__59684);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59703,G__59685);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59704,G__59686);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59705,G__59687);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59706,G__59688);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$19,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60610 = cljs.core._nth(recur_val,(0));
var G__60611 = cljs.core._nth(recur_val,(1));
var G__60612 = cljs.core._nth(recur_val,(2));
var G__60613 = cljs.core._nth(recur_val,(3));
var G__60614 = cljs.core._nth(recur_val,(4));
var G__60615 = cljs.core._nth(recur_val,(5));
var G__60616 = cljs.core._nth(recur_val,(6));
var G__60617 = cljs.core._nth(recur_val,(7));
var G__60618 = cljs.core._nth(recur_val,(8));
var G__60619 = cljs.core._nth(recur_val,(9));
var G__60620 = cljs.core._nth(recur_val,(10));
var G__60621 = cljs.core._nth(recur_val,(11));
var G__60622 = cljs.core._nth(recur_val,(12));
var G__60623 = cljs.core._nth(recur_val,(13));
var G__60624 = cljs.core._nth(recur_val,(14));
var G__60625 = cljs.core._nth(recur_val,(15));
var G__60626 = cljs.core._nth(recur_val,(16));
var G__60627 = cljs.core._nth(recur_val,(17));
G__59671 = G__60610;
G__59672 = G__60611;
G__59673 = G__60612;
G__59674 = G__60613;
G__59675 = G__60614;
G__59676 = G__60615;
G__59677 = G__60616;
G__59678 = G__60617;
G__59679 = G__60618;
G__59680 = G__60619;
G__59681 = G__60620;
G__59682 = G__60621;
G__59683 = G__60622;
G__59684 = G__60623;
G__59685 = G__60624;
G__59686 = G__60625;
G__59687 = G__60626;
G__59688 = G__60627;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (19):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59726 = cljs.core._nth(params,(0));
var G__59727 = cljs.core._nth(params,(1));
var G__59728 = cljs.core._nth(params,(2));
var G__59729 = cljs.core._nth(params,(3));
var G__59730 = cljs.core._nth(params,(4));
var G__59731 = cljs.core._nth(params,(5));
var G__59732 = cljs.core._nth(params,(6));
var G__59733 = cljs.core._nth(params,(7));
var G__59734 = cljs.core._nth(params,(8));
var G__59735 = cljs.core._nth(params,(9));
var G__59736 = cljs.core._nth(params,(10));
var G__59737 = cljs.core._nth(params,(11));
var G__59738 = cljs.core._nth(params,(12));
var G__59739 = cljs.core._nth(params,(13));
var G__59740 = cljs.core._nth(params,(14));
var G__59741 = cljs.core._nth(params,(15));
var G__59742 = cljs.core._nth(params,(16));
var G__59743 = cljs.core._nth(params,(17));
var G__59744 = cljs.core._nth(params,(18));
return (function sci$impl$fns$fun_$_arity_19(G__59707,G__59708,G__59709,G__59710,G__59711,G__59712,G__59713,G__59714,G__59715,G__59716,G__59717,G__59718,G__59719,G__59720,G__59721,G__59722,G__59723,G__59724,G__59725){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59726,G__59707);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59727,G__59708);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59728,G__59709);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59729,G__59710);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59730,G__59711);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59731,G__59712);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59732,G__59713);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59733,G__59714);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59734,G__59715);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59735,G__59716);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59736,G__59717);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59737,G__59718);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59738,G__59719);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59739,G__59720);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59740,G__59721);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59741,G__59722);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59742,G__59723);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59743,G__59724);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__59744,G__59725);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$20,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60632 = cljs.core._nth(recur_val,(0));
var G__60633 = cljs.core._nth(recur_val,(1));
var G__60634 = cljs.core._nth(recur_val,(2));
var G__60635 = cljs.core._nth(recur_val,(3));
var G__60636 = cljs.core._nth(recur_val,(4));
var G__60637 = cljs.core._nth(recur_val,(5));
var G__60638 = cljs.core._nth(recur_val,(6));
var G__60639 = cljs.core._nth(recur_val,(7));
var G__60640 = cljs.core._nth(recur_val,(8));
var G__60641 = cljs.core._nth(recur_val,(9));
var G__60642 = cljs.core._nth(recur_val,(10));
var G__60643 = cljs.core._nth(recur_val,(11));
var G__60644 = cljs.core._nth(recur_val,(12));
var G__60645 = cljs.core._nth(recur_val,(13));
var G__60646 = cljs.core._nth(recur_val,(14));
var G__60647 = cljs.core._nth(recur_val,(15));
var G__60648 = cljs.core._nth(recur_val,(16));
var G__60649 = cljs.core._nth(recur_val,(17));
var G__60650 = cljs.core._nth(recur_val,(18));
G__59707 = G__60632;
G__59708 = G__60633;
G__59709 = G__60634;
G__59710 = G__60635;
G__59711 = G__60636;
G__59712 = G__60637;
G__59713 = G__60638;
G__59714 = G__60639;
G__59715 = G__60640;
G__59716 = G__60641;
G__59717 = G__60642;
G__59718 = G__60643;
G__59719 = G__60644;
G__59720 = G__60645;
G__59721 = G__60646;
G__59722 = G__60647;
G__59723 = G__60648;
G__59724 = G__60649;
G__59725 = G__60650;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59764 = cljs.core._nth(params,(0));
var G__59765 = cljs.core._nth(params,(1));
var G__59766 = cljs.core._nth(params,(2));
var G__59767 = cljs.core._nth(params,(3));
var G__59768 = cljs.core._nth(params,(4));
var G__59769 = cljs.core._nth(params,(5));
var G__59770 = cljs.core._nth(params,(6));
var G__59771 = cljs.core._nth(params,(7));
var G__59772 = cljs.core._nth(params,(8));
var G__59773 = cljs.core._nth(params,(9));
var G__59774 = cljs.core._nth(params,(10));
var G__59775 = cljs.core._nth(params,(11));
var G__59776 = cljs.core._nth(params,(12));
var G__59777 = cljs.core._nth(params,(13));
var G__59778 = cljs.core._nth(params,(14));
var G__59779 = cljs.core._nth(params,(15));
var G__59780 = cljs.core._nth(params,(16));
var G__59781 = cljs.core._nth(params,(17));
var G__59782 = cljs.core._nth(params,(18));
return (function sci$impl$fns$fun_$_arity_19(G__59745,G__59746,G__59747,G__59748,G__59749,G__59750,G__59751,G__59752,G__59753,G__59754,G__59755,G__59756,G__59757,G__59758,G__59759,G__59760,G__59761,G__59762,G__59763){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((19),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59764,G__59745);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59765,G__59746);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59766,G__59747);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59767,G__59748);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59768,G__59749);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59769,G__59750);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59770,G__59751);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59771,G__59752);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59772,G__59753);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59773,G__59754);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59774,G__59755);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59775,G__59756);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59776,G__59757);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59777,G__59758);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59778,G__59759);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59779,G__59760);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59780,G__59761);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59781,G__59762);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__59782,G__59763);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$20,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60651 = cljs.core._nth(recur_val,(0));
var G__60652 = cljs.core._nth(recur_val,(1));
var G__60653 = cljs.core._nth(recur_val,(2));
var G__60654 = cljs.core._nth(recur_val,(3));
var G__60655 = cljs.core._nth(recur_val,(4));
var G__60656 = cljs.core._nth(recur_val,(5));
var G__60657 = cljs.core._nth(recur_val,(6));
var G__60658 = cljs.core._nth(recur_val,(7));
var G__60659 = cljs.core._nth(recur_val,(8));
var G__60660 = cljs.core._nth(recur_val,(9));
var G__60661 = cljs.core._nth(recur_val,(10));
var G__60662 = cljs.core._nth(recur_val,(11));
var G__60663 = cljs.core._nth(recur_val,(12));
var G__60664 = cljs.core._nth(recur_val,(13));
var G__60665 = cljs.core._nth(recur_val,(14));
var G__60666 = cljs.core._nth(recur_val,(15));
var G__60667 = cljs.core._nth(recur_val,(16));
var G__60668 = cljs.core._nth(recur_val,(17));
var G__60669 = cljs.core._nth(recur_val,(18));
G__59745 = G__60651;
G__59746 = G__60652;
G__59747 = G__60653;
G__59748 = G__60654;
G__59749 = G__60655;
G__59750 = G__60656;
G__59751 = G__60657;
G__59752 = G__60658;
G__59753 = G__60659;
G__59754 = G__60660;
G__59755 = G__60661;
G__59756 = G__60662;
G__59757 = G__60663;
G__59758 = G__60664;
G__59759 = G__60665;
G__59760 = G__60666;
G__59761 = G__60667;
G__59762 = G__60668;
G__59763 = G__60669;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
case (20):
if(cljs.core.truth_(disable_arity_checks_QMARK_)){
var G__59819 = cljs.core._nth(params,(0));
var G__59820 = cljs.core._nth(params,(1));
var G__59821 = cljs.core._nth(params,(2));
var G__59822 = cljs.core._nth(params,(3));
var G__59823 = cljs.core._nth(params,(4));
var G__59824 = cljs.core._nth(params,(5));
var G__59825 = cljs.core._nth(params,(6));
var G__59826 = cljs.core._nth(params,(7));
var G__59827 = cljs.core._nth(params,(8));
var G__59828 = cljs.core._nth(params,(9));
var G__59829 = cljs.core._nth(params,(10));
var G__59830 = cljs.core._nth(params,(11));
var G__59831 = cljs.core._nth(params,(12));
var G__59832 = cljs.core._nth(params,(13));
var G__59833 = cljs.core._nth(params,(14));
var G__59834 = cljs.core._nth(params,(15));
var G__59835 = cljs.core._nth(params,(16));
var G__59836 = cljs.core._nth(params,(17));
var G__59837 = cljs.core._nth(params,(18));
var G__59838 = cljs.core._nth(params,(19));
return (function sci$impl$fns$fun_$_arity_20(G__59799,G__59800,G__59801,G__59802,G__59803,G__59804,G__59805,G__59806,G__59807,G__59808,G__59809,G__59810,G__59811,G__59812,G__59813,G__59814,G__59815,G__59816,G__59817,G__59818){
while(true){
var bindings__$2 = cljs.core._assoc(bindings__$1,G__59819,G__59799);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59820,G__59800);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59821,G__59801);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59822,G__59802);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59823,G__59803);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59824,G__59804);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59825,G__59805);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59826,G__59806);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59827,G__59807);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59828,G__59808);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59829,G__59809);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59830,G__59810);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59831,G__59811);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59832,G__59812);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59833,G__59813);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59834,G__59814);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59835,G__59815);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59836,G__59816);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__59837,G__59817);
var bindings__$21 = cljs.core._assoc(bindings__$20,G__59838,G__59818);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$21,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60670 = cljs.core._nth(recur_val,(0));
var G__60671 = cljs.core._nth(recur_val,(1));
var G__60672 = cljs.core._nth(recur_val,(2));
var G__60673 = cljs.core._nth(recur_val,(3));
var G__60674 = cljs.core._nth(recur_val,(4));
var G__60675 = cljs.core._nth(recur_val,(5));
var G__60676 = cljs.core._nth(recur_val,(6));
var G__60677 = cljs.core._nth(recur_val,(7));
var G__60678 = cljs.core._nth(recur_val,(8));
var G__60679 = cljs.core._nth(recur_val,(9));
var G__60680 = cljs.core._nth(recur_val,(10));
var G__60681 = cljs.core._nth(recur_val,(11));
var G__60682 = cljs.core._nth(recur_val,(12));
var G__60683 = cljs.core._nth(recur_val,(13));
var G__60684 = cljs.core._nth(recur_val,(14));
var G__60685 = cljs.core._nth(recur_val,(15));
var G__60686 = cljs.core._nth(recur_val,(16));
var G__60687 = cljs.core._nth(recur_val,(17));
var G__60688 = cljs.core._nth(recur_val,(18));
var G__60689 = cljs.core._nth(recur_val,(19));
G__59799 = G__60670;
G__59800 = G__60671;
G__59801 = G__60672;
G__59802 = G__60673;
G__59803 = G__60674;
G__59804 = G__60675;
G__59805 = G__60676;
G__59806 = G__60677;
G__59807 = G__60678;
G__59808 = G__60679;
G__59809 = G__60680;
G__59810 = G__60681;
G__59811 = G__60682;
G__59812 = G__60683;
G__59813 = G__60684;
G__59814 = G__60685;
G__59815 = G__60686;
G__59816 = G__60687;
G__59817 = G__60688;
G__59818 = G__60689;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
} else {
var G__59873 = cljs.core._nth(params,(0));
var G__59874 = cljs.core._nth(params,(1));
var G__59875 = cljs.core._nth(params,(2));
var G__59876 = cljs.core._nth(params,(3));
var G__59877 = cljs.core._nth(params,(4));
var G__59878 = cljs.core._nth(params,(5));
var G__59879 = cljs.core._nth(params,(6));
var G__59880 = cljs.core._nth(params,(7));
var G__59881 = cljs.core._nth(params,(8));
var G__59882 = cljs.core._nth(params,(9));
var G__59883 = cljs.core._nth(params,(10));
var G__59884 = cljs.core._nth(params,(11));
var G__59885 = cljs.core._nth(params,(12));
var G__59886 = cljs.core._nth(params,(13));
var G__59887 = cljs.core._nth(params,(14));
var G__59888 = cljs.core._nth(params,(15));
var G__59889 = cljs.core._nth(params,(16));
var G__59890 = cljs.core._nth(params,(17));
var G__59891 = cljs.core._nth(params,(18));
var G__59892 = cljs.core._nth(params,(19));
return (function sci$impl$fns$fun_$_arity_20(G__59853,G__59854,G__59855,G__59856,G__59857,G__59858,G__59859,G__59860,G__59861,G__59862,G__59863,G__59864,G__59865,G__59866,G__59867,G__59868,G__59869,G__59870,G__59871,G__59872){
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((20),arguments.length)){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,cljs.core.vals(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(arguments)));
}

var bindings__$2 = cljs.core._assoc(bindings__$1,G__59873,G__59853);
var bindings__$3 = cljs.core._assoc(bindings__$2,G__59874,G__59854);
var bindings__$4 = cljs.core._assoc(bindings__$3,G__59875,G__59855);
var bindings__$5 = cljs.core._assoc(bindings__$4,G__59876,G__59856);
var bindings__$6 = cljs.core._assoc(bindings__$5,G__59877,G__59857);
var bindings__$7 = cljs.core._assoc(bindings__$6,G__59878,G__59858);
var bindings__$8 = cljs.core._assoc(bindings__$7,G__59879,G__59859);
var bindings__$9 = cljs.core._assoc(bindings__$8,G__59880,G__59860);
var bindings__$10 = cljs.core._assoc(bindings__$9,G__59881,G__59861);
var bindings__$11 = cljs.core._assoc(bindings__$10,G__59882,G__59862);
var bindings__$12 = cljs.core._assoc(bindings__$11,G__59883,G__59863);
var bindings__$13 = cljs.core._assoc(bindings__$12,G__59884,G__59864);
var bindings__$14 = cljs.core._assoc(bindings__$13,G__59885,G__59865);
var bindings__$15 = cljs.core._assoc(bindings__$14,G__59886,G__59866);
var bindings__$16 = cljs.core._assoc(bindings__$15,G__59887,G__59867);
var bindings__$17 = cljs.core._assoc(bindings__$16,G__59888,G__59868);
var bindings__$18 = cljs.core._assoc(bindings__$17,G__59889,G__59869);
var bindings__$19 = cljs.core._assoc(bindings__$18,G__59890,G__59870);
var bindings__$20 = cljs.core._assoc(bindings__$19,G__59891,G__59871);
var bindings__$21 = cljs.core._assoc(bindings__$20,G__59892,G__59872);
var ret__58294__auto__ = sci.impl.evaluator.eval(ctx,bindings__$21,body);
var recur_QMARK___58295__auto__ = (ret__58294__auto__ instanceof sci.impl.fns.Recur);
if(recur_QMARK___58295__auto__){
var recur_val = sci.impl.types.getVal(ret__58294__auto__);
var G__60690 = cljs.core._nth(recur_val,(0));
var G__60691 = cljs.core._nth(recur_val,(1));
var G__60692 = cljs.core._nth(recur_val,(2));
var G__60693 = cljs.core._nth(recur_val,(3));
var G__60694 = cljs.core._nth(recur_val,(4));
var G__60695 = cljs.core._nth(recur_val,(5));
var G__60696 = cljs.core._nth(recur_val,(6));
var G__60697 = cljs.core._nth(recur_val,(7));
var G__60698 = cljs.core._nth(recur_val,(8));
var G__60699 = cljs.core._nth(recur_val,(9));
var G__60700 = cljs.core._nth(recur_val,(10));
var G__60701 = cljs.core._nth(recur_val,(11));
var G__60702 = cljs.core._nth(recur_val,(12));
var G__60703 = cljs.core._nth(recur_val,(13));
var G__60704 = cljs.core._nth(recur_val,(14));
var G__60705 = cljs.core._nth(recur_val,(15));
var G__60706 = cljs.core._nth(recur_val,(16));
var G__60707 = cljs.core._nth(recur_val,(17));
var G__60708 = cljs.core._nth(recur_val,(18));
var G__60709 = cljs.core._nth(recur_val,(19));
G__59853 = G__60690;
G__59854 = G__60691;
G__59855 = G__60692;
G__59856 = G__60693;
G__59857 = G__60694;
G__59858 = G__60695;
G__59859 = G__60696;
G__59860 = G__60697;
G__59861 = G__60698;
G__59862 = G__60699;
G__59863 = G__60700;
G__59864 = G__60701;
G__59865 = G__60702;
G__59866 = G__60703;
G__59867 = G__60704;
G__59868 = G__60705;
G__59869 = G__60706;
G__59870 = G__60707;
G__59871 = G__60708;
G__59872 = G__60709;
continue;
} else {
return ret__58294__auto__;
}
break;
}
});
}

break;
default:
return (function() { 
var sci$impl$fns$fun_$_varargs__delegate = function (args){
while(true){
var bindings__$2 = (function (){var args_STAR_ = cljs.core.seq(args);
var params__$1 = cljs.core.seq(params);
var ret = bindings__$1;
while(true){
if(params__$1){
var fp = cljs.core.first(params__$1);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"&","&",-2144855648,null),fp)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(ret,cljs.core.second(params__$1),args_STAR_);
} else {
if(args_STAR_){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
}

var G__60710 = cljs.core.next(args_STAR_);
var G__60711 = cljs.core.next(params__$1);
var G__60712 = cljs.core._assoc(ret,fp,cljs.core.first(args_STAR_));
args_STAR_ = G__60710;
params__$1 = G__60711;
ret = G__60712;
continue;
}
} else {
if(args_STAR_){
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
} else {
}

return ret;
}
break;
}
})();
var ret = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
var recur_val = sci.impl.types.getVal(ret);
var min_var_args_arity = (cljs.core.truth_(var_arg_name)?fixed_arity:null);
if(cljs.core.truth_(min_var_args_arity)){
var vec__59912 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(recur_val,(0),min_var_args_arity),cljs.core.subvec.cljs$core$IFn$_invoke$arity$2(recur_val,min_var_args_arity)], null);
var fixed_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59912,(0),null);
var vec__59915 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59912,(1),null);
var rest_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59915,(0),null);
var G__60713 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(fixed_args,rest_args);
args = G__60713;
continue;
} else {
var G__60714 = recur_val;
args = G__60714;
continue;
}
} else {
return ret;
}
break;
}
};
var sci$impl$fns$fun_$_varargs = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__60715__i = 0, G__60715__a = new Array(arguments.length -  0);
while (G__60715__i < G__60715__a.length) {G__60715__a[G__60715__i] = arguments[G__60715__i + 0]; ++G__60715__i;}
  args = new cljs.core.IndexedSeq(G__60715__a,0,null);
} 
return sci$impl$fns$fun_$_varargs__delegate.call(this,args);};
sci$impl$fns$fun_$_varargs.cljs$lang$maxFixedArity = 0;
sci$impl$fns$fun_$_varargs.cljs$lang$applyTo = (function (arglist__60716){
var args = cljs.core.seq(arglist__60716);
return sci$impl$fns$fun_$_varargs__delegate(args);
});
sci$impl$fns$fun_$_varargs.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$fun_$_varargs__delegate;
return sci$impl$fns$fun_$_varargs;
})()
;

}
})():(function() { 
var sci$impl$fns$fun_$_varargs__delegate = function (args){
while(true){
var bindings__$2 = (function (){var args_STAR_ = cljs.core.seq(args);
var params__$1 = cljs.core.seq(params);
var ret = bindings__$1;
while(true){
if(params__$1){
var fp = cljs.core.first(params__$1);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Symbol(null,"&","&",-2144855648,null),fp)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(ret,cljs.core.second(params__$1),args_STAR_);
} else {
if(args_STAR_){
} else {
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
}

var G__60717 = cljs.core.next(args_STAR_);
var G__60718 = cljs.core.next(params__$1);
var G__60719 = cljs.core._assoc(ret,fp,cljs.core.first(args_STAR_));
args_STAR_ = G__60717;
params__$1 = G__60718;
ret = G__60719;
continue;
}
} else {
if(args_STAR_){
sci.impl.fns.throw_arity(ctx,nsm,fn_name,macro_QMARK_,args);
} else {
}

return ret;
}
break;
}
})();
var ret = sci.impl.evaluator.eval(ctx,bindings__$2,body);
var recur_QMARK_ = (ret instanceof sci.impl.fns.Recur);
if(recur_QMARK_){
var recur_val = sci.impl.types.getVal(ret);
var min_var_args_arity = (cljs.core.truth_(var_arg_name)?fixed_arity:null);
if(cljs.core.truth_(min_var_args_arity)){
var vec__59925 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(recur_val,(0),min_var_args_arity),cljs.core.subvec.cljs$core$IFn$_invoke$arity$2(recur_val,min_var_args_arity)], null);
var fixed_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59925,(0),null);
var vec__59928 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59925,(1),null);
var rest_args = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__59928,(0),null);
var G__60720 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(fixed_args,rest_args);
args = G__60720;
continue;
} else {
var G__60721 = recur_val;
args = G__60721;
continue;
}
} else {
return ret;
}
break;
}
};
var sci$impl$fns$fun_$_varargs = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__60722__i = 0, G__60722__a = new Array(arguments.length -  0);
while (G__60722__i < G__60722__a.length) {G__60722__a[G__60722__i] = arguments[G__60722__i + 0]; ++G__60722__i;}
  args = new cljs.core.IndexedSeq(G__60722__a,0,null);
} 
return sci$impl$fns$fun_$_varargs__delegate.call(this,args);};
sci$impl$fns$fun_$_varargs.cljs$lang$maxFixedArity = 0;
sci$impl$fns$fun_$_varargs.cljs$lang$applyTo = (function (arglist__60723){
var args = cljs.core.seq(arglist__60723);
return sci$impl$fns$fun_$_varargs__delegate(args);
});
sci$impl$fns$fun_$_varargs.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$fun_$_varargs__delegate;
return sci$impl$fns$fun_$_varargs;
})()
);
return f;
});
sci.impl.fns.lookup_by_arity = (function sci$impl$fns$lookup_by_arity(arities,arity){
var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(arities,arity);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return new cljs.core.Keyword(null,"variadic","variadic",882626057).cljs$core$IFn$_invoke$arity$1(arities);
}
});
sci.impl.fns.fn_arity_map = (function sci$impl$fns$fn_arity_map(ctx,bindings,fn_name,macro_QMARK_,fn_bodies){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (arity_map,fn_body){
var f = sci.impl.fns.fun(ctx,bindings,fn_body,fn_name,macro_QMARK_);
var var_arg_QMARK_ = new cljs.core.Keyword(null,"var-arg-name","var-arg-name",-1100024887).cljs$core$IFn$_invoke$arity$1(fn_body);
var fixed_arity = new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869).cljs$core$IFn$_invoke$arity$1(fn_body);
if(cljs.core.truth_(var_arg_QMARK_)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,new cljs.core.Keyword(null,"variadic","variadic",882626057),f);
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(arity_map,fixed_arity,f);
}
}),cljs.core.PersistentArrayMap.EMPTY,fn_bodies);
});
sci.impl.fns.eval_fn = (function sci$impl$fns$eval_fn(ctx,bindings,fn_name,fn_bodies,macro_QMARK_,single_arity,self_ref_QMARK_){
var self_ref = (cljs.core.truth_(self_ref_QMARK_)?cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null):null);
var bindings__$1 = (cljs.core.truth_(self_ref_QMARK_)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(bindings,fn_name,(function() { 
var sci$impl$fns$eval_fn_$_call_self__delegate = function (args){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self_ref),args);
};
var sci$impl$fns$eval_fn_$_call_self = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__60724__i = 0, G__60724__a = new Array(arguments.length -  0);
while (G__60724__i < G__60724__a.length) {G__60724__a[G__60724__i] = arguments[G__60724__i + 0]; ++G__60724__i;}
  args = new cljs.core.IndexedSeq(G__60724__a,0,null);
} 
return sci$impl$fns$eval_fn_$_call_self__delegate.call(this,args);};
sci$impl$fns$eval_fn_$_call_self.cljs$lang$maxFixedArity = 0;
sci$impl$fns$eval_fn_$_call_self.cljs$lang$applyTo = (function (arglist__60725){
var args = cljs.core.seq(arglist__60725);
return sci$impl$fns$eval_fn_$_call_self__delegate(args);
});
sci$impl$fns$eval_fn_$_call_self.cljs$core$IFn$_invoke$arity$variadic = sci$impl$fns$eval_fn_$_call_self__delegate;
return sci$impl$fns$eval_fn_$_call_self;
})()
):bindings);
var f = (cljs.core.truth_(single_arity)?sci.impl.fns.fun(ctx,bindings__$1,single_arity,fn_name,macro_QMARK_):(function (){var arities = sci.impl.fns.fn_arity_map(ctx,bindings__$1,fn_name,macro_QMARK_,fn_bodies);
return (function() { 
var G__60726__delegate = function (args){
var arg_count = cljs.core.count(args);
var temp__5751__auto__ = sci.impl.fns.lookup_by_arity(arities,arg_count);
if(cljs.core.truth_(temp__5751__auto__)){
var f = temp__5751__auto__;
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,args);
} else {
throw (new Error((function (){var actual_count = (cljs.core.truth_(macro_QMARK_)?(arg_count - (2)):arg_count);
return ["Cannot call ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fn_name)," with ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(actual_count)," arguments"].join('');
})()));
}
};
var G__60726 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__60727__i = 0, G__60727__a = new Array(arguments.length -  0);
while (G__60727__i < G__60727__a.length) {G__60727__a[G__60727__i] = arguments[G__60727__i + 0]; ++G__60727__i;}
  args = new cljs.core.IndexedSeq(G__60727__a,0,null);
} 
return G__60726__delegate.call(this,args);};
G__60726.cljs$lang$maxFixedArity = 0;
G__60726.cljs$lang$applyTo = (function (arglist__60728){
var args = cljs.core.seq(arglist__60728);
return G__60726__delegate(args);
});
G__60726.cljs$core$IFn$_invoke$arity$variadic = G__60726__delegate;
return G__60726;
})()
;
})());
var f__$1 = (cljs.core.truth_(macro_QMARK_)?cljs.core.vary_meta.cljs$core$IFn$_invoke$arity$2(f,(function (p1__59944_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__59944_SHARP_,new cljs.core.Keyword("sci","macro","sci/macro",-868536151),macro_QMARK_);
})):f);
if(cljs.core.truth_(self_ref_QMARK_)){
cljs.core.reset_BANG_(self_ref,f__$1);
} else {
}

return f__$1;
});
cljs.core.vreset_BANG_(sci.impl.utils.eval_fn,sci.impl.fns.eval_fn);

//# sourceMappingURL=sci.impl.fns.js.map
