import "./cljs_env.js";
goog.provide('cljs.core.async');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__48014 = arguments.length;
switch (G__48014) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
}));

(cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async48017 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async48017 = (function (f,blockable,meta48018){
this.f = f;
this.blockable = blockable;
this.meta48018 = meta48018;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_48019,meta48018__$1){
var self__ = this;
var _48019__$1 = this;
return (new cljs.core.async.t_cljs$core$async48017(self__.f,self__.blockable,meta48018__$1));
}));

(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_48019){
var self__ = this;
var _48019__$1 = this;
return self__.meta48018;
}));

(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
}));

(cljs.core.async.t_cljs$core$async48017.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
}));

(cljs.core.async.t_cljs$core$async48017.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta48018","meta48018",-241351751,null)], null);
}));

(cljs.core.async.t_cljs$core$async48017.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async48017.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async48017");

(cljs.core.async.t_cljs$core$async48017.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async48017");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async48017.
 */
cljs.core.async.__GT_t_cljs$core$async48017 = (function cljs$core$async$__GT_t_cljs$core$async48017(f__$1,blockable__$1,meta48018){
return (new cljs.core.async.t_cljs$core$async48017(f__$1,blockable__$1,meta48018));
});

}

return (new cljs.core.async.t_cljs$core$async48017(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
}));

(cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2);

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__48052 = arguments.length;
switch (G__48052) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
}));

(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
}));

(cljs.core.async.chan.cljs$lang$maxFixedArity = 3);

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__48075 = arguments.length;
switch (G__48075) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
}));

(cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
}));

(cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__48085 = arguments.length;
switch (G__48085) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
}));

(cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_50357 = cljs.core.deref(ret);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_50357) : fn1.call(null,val_50357));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_50357) : fn1.call(null,val_50357));
}));
}
} else {
}

return null;
}));

(cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3);

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__48091 = arguments.length;
switch (G__48091) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5751__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5751__auto__)){
var ret = temp__5751__auto__;
return cljs.core.deref(ret);
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
}));

(cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5751__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__5751__auto__)){
var retb = temp__5751__auto__;
var ret = cljs.core.deref(retb);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run((function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
}));
}

return ret;
} else {
return true;
}
}));

(cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4);

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4706__auto___50361 = n;
var x_50362 = (0);
while(true){
if((x_50362 < n__4706__auto___50361)){
(a[x_50362] = x_50362);

var G__50363 = (x_50362 + (1));
x_50362 = G__50363;
continue;
} else {
}
break;
}

goog.array.shuffle(a);

return a;
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true);
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async48117 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async48117 = (function (flag,meta48118){
this.flag = flag;
this.meta48118 = meta48118;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_48119,meta48118__$1){
var self__ = this;
var _48119__$1 = this;
return (new cljs.core.async.t_cljs$core$async48117(self__.flag,meta48118__$1));
}));

(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_48119){
var self__ = this;
var _48119__$1 = this;
return self__.meta48118;
}));

(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref(self__.flag);
}));

(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async48117.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.flag,null);

return true;
}));

(cljs.core.async.t_cljs$core$async48117.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta48118","meta48118",1415449607,null)], null);
}));

(cljs.core.async.t_cljs$core$async48117.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async48117.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async48117");

(cljs.core.async.t_cljs$core$async48117.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async48117");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async48117.
 */
cljs.core.async.__GT_t_cljs$core$async48117 = (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async48117(flag__$1,meta48118){
return (new cljs.core.async.t_cljs$core$async48117(flag__$1,meta48118));
});

}

return (new cljs.core.async.t_cljs$core$async48117(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async48132 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async48132 = (function (flag,cb,meta48133){
this.flag = flag;
this.cb = cb;
this.meta48133 = meta48133;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_48134,meta48133__$1){
var self__ = this;
var _48134__$1 = this;
return (new cljs.core.async.t_cljs$core$async48132(self__.flag,self__.cb,meta48133__$1));
}));

(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_48134){
var self__ = this;
var _48134__$1 = this;
return self__.meta48133;
}));

(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
}));

(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async48132.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
}));

(cljs.core.async.t_cljs$core$async48132.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta48133","meta48133",-76026342,null)], null);
}));

(cljs.core.async.t_cljs$core$async48132.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async48132.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async48132");

(cljs.core.async.t_cljs$core$async48132.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async48132");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async48132.
 */
cljs.core.async.__GT_t_cljs$core$async48132 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async48132(flag__$1,cb__$1,meta48133){
return (new cljs.core.async.t_cljs$core$async48132(flag__$1,cb__$1,meta48133));
});

}

return (new cljs.core.async.t_cljs$core$async48132(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
if((cljs.core.count(ports) > (0))){
} else {
throw (new Error(["Assert failed: ","alts must have at least one channel operation","\n","(pos? (count ports))"].join('')));
}

var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__48135_SHARP_){
var G__48149 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__48135_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__48149) : fret.call(null,G__48149));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__48136_SHARP_){
var G__48150 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__48136_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__48150) : fret.call(null,G__48150));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref(vbox),(function (){var or__4223__auto__ = wport;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return port;
}
})()], null));
} else {
var G__50368 = (i + (1));
i = G__50368;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4223__auto__ = ret;
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5753__auto__ = (function (){var and__4221__auto__ = flag.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(cljs.core.truth_(and__4221__auto__)){
return flag.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__4221__auto__;
}
})();
if(cljs.core.truth_(temp__5753__auto__)){
var got = temp__5753__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4835__auto__ = [];
var len__4829__auto___50369 = arguments.length;
var i__4830__auto___50370 = (0);
while(true){
if((i__4830__auto___50370 < len__4829__auto___50369)){
args__4835__auto__.push((arguments[i__4830__auto___50370]));

var G__50371 = (i__4830__auto___50370 + (1));
i__4830__auto___50370 = G__50371;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((1) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4836__auto__);
});

(cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__48160){
var map__48162 = p__48160;
var map__48162__$1 = cljs.core.__destructure_map(map__48162);
var opts = map__48162__$1;
throw (new Error("alts! used not in (go ...) block"));
}));

(cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq48155){
var G__48156 = cljs.core.first(seq48155);
var seq48155__$1 = cljs.core.next(seq48155);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__48156,seq48155__$1);
}));

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__48172 = arguments.length;
switch (G__48172) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
}));

(cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__47915__auto___50373 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48223){
var state_val_48224 = (state_48223[(1)]);
if((state_val_48224 === (7))){
var inst_48218 = (state_48223[(2)]);
var state_48223__$1 = state_48223;
var statearr_48228_50374 = state_48223__$1;
(statearr_48228_50374[(2)] = inst_48218);

(statearr_48228_50374[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (1))){
var state_48223__$1 = state_48223;
var statearr_48229_50375 = state_48223__$1;
(statearr_48229_50375[(2)] = null);

(statearr_48229_50375[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (4))){
var inst_48192 = (state_48223[(7)]);
var inst_48192__$1 = (state_48223[(2)]);
var inst_48199 = (inst_48192__$1 == null);
var state_48223__$1 = (function (){var statearr_48230 = state_48223;
(statearr_48230[(7)] = inst_48192__$1);

return statearr_48230;
})();
if(cljs.core.truth_(inst_48199)){
var statearr_48231_50376 = state_48223__$1;
(statearr_48231_50376[(1)] = (5));

} else {
var statearr_48232_50377 = state_48223__$1;
(statearr_48232_50377[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (13))){
var state_48223__$1 = state_48223;
var statearr_48235_50378 = state_48223__$1;
(statearr_48235_50378[(2)] = null);

(statearr_48235_50378[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (6))){
var inst_48192 = (state_48223[(7)]);
var state_48223__$1 = state_48223;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48223__$1,(11),to,inst_48192);
} else {
if((state_val_48224 === (3))){
var inst_48220 = (state_48223[(2)]);
var state_48223__$1 = state_48223;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48223__$1,inst_48220);
} else {
if((state_val_48224 === (12))){
var state_48223__$1 = state_48223;
var statearr_48239_50379 = state_48223__$1;
(statearr_48239_50379[(2)] = null);

(statearr_48239_50379[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (2))){
var state_48223__$1 = state_48223;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48223__$1,(4),from);
} else {
if((state_val_48224 === (11))){
var inst_48210 = (state_48223[(2)]);
var state_48223__$1 = state_48223;
if(cljs.core.truth_(inst_48210)){
var statearr_48240_50380 = state_48223__$1;
(statearr_48240_50380[(1)] = (12));

} else {
var statearr_48241_50381 = state_48223__$1;
(statearr_48241_50381[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (9))){
var state_48223__$1 = state_48223;
var statearr_48242_50382 = state_48223__$1;
(statearr_48242_50382[(2)] = null);

(statearr_48242_50382[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (5))){
var state_48223__$1 = state_48223;
if(cljs.core.truth_(close_QMARK_)){
var statearr_48243_50383 = state_48223__$1;
(statearr_48243_50383[(1)] = (8));

} else {
var statearr_48244_50384 = state_48223__$1;
(statearr_48244_50384[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (14))){
var inst_48216 = (state_48223[(2)]);
var state_48223__$1 = state_48223;
var statearr_48247_50385 = state_48223__$1;
(statearr_48247_50385[(2)] = inst_48216);

(statearr_48247_50385[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (10))){
var inst_48206 = (state_48223[(2)]);
var state_48223__$1 = state_48223;
var statearr_48248_50386 = state_48223__$1;
(statearr_48248_50386[(2)] = inst_48206);

(statearr_48248_50386[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48224 === (8))){
var inst_48202 = cljs.core.async.close_BANG_(to);
var state_48223__$1 = state_48223;
var statearr_48249_50387 = state_48223__$1;
(statearr_48249_50387[(2)] = inst_48202);

(statearr_48249_50387[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_48256 = [null,null,null,null,null,null,null,null];
(statearr_48256[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_48256[(1)] = (1));

return statearr_48256;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_48223){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48223);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48257){var ex__47855__auto__ = e48257;
var statearr_48259_50388 = state_48223;
(statearr_48259_50388[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48223[(4)]))){
var statearr_48260_50389 = state_48223;
(statearr_48260_50389[(1)] = cljs.core.first((state_48223[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50390 = state_48223;
state_48223 = G__50390;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_48223){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_48223);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48261 = f__47916__auto__();
(statearr_48261[(6)] = c__47915__auto___50373);

return statearr_48261;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return to;
}));

(cljs.core.async.pipe.cljs$lang$maxFixedArity = 3);

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = (function (p__48266){
var vec__48267 = p__48266;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__48267,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__48267,(1),null);
var job = vec__48267;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__47915__auto___50391 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48283){
var state_val_48284 = (state_48283[(1)]);
if((state_val_48284 === (1))){
var state_48283__$1 = state_48283;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48283__$1,(2),res,v);
} else {
if((state_val_48284 === (2))){
var inst_48280 = (state_48283[(2)]);
var inst_48281 = cljs.core.async.close_BANG_(res);
var state_48283__$1 = (function (){var statearr_48286 = state_48283;
(statearr_48286[(7)] = inst_48280);

return statearr_48286;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_48283__$1,inst_48281);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_48290 = [null,null,null,null,null,null,null,null];
(statearr_48290[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__);

(statearr_48290[(1)] = (1));

return statearr_48290;
});
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1 = (function (state_48283){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48283);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48293){var ex__47855__auto__ = e48293;
var statearr_48294_50392 = state_48283;
(statearr_48294_50392[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48283[(4)]))){
var statearr_48295_50393 = state_48283;
(statearr_48295_50393[(1)] = cljs.core.first((state_48283[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50394 = state_48283;
state_48283 = G__50394;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = function(state_48283){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1.call(this,state_48283);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48299 = f__47916__auto__();
(statearr_48299[(6)] = c__47915__auto___50391);

return statearr_48299;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var async = (function (p__48303){
var vec__48304 = p__48303;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__48304,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__48304,(1),null);
var job = vec__48304;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});
var n__4706__auto___50395 = n;
var __50396 = (0);
while(true){
if((__50396 < n__4706__auto___50395)){
var G__48312_50397 = type;
var G__48312_50398__$1 = (((G__48312_50397 instanceof cljs.core.Keyword))?G__48312_50397.fqn:null);
switch (G__48312_50398__$1) {
case "compute":
var c__47915__auto___50400 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__50396,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = ((function (__50396,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function (state_48329){
var state_val_48330 = (state_48329[(1)]);
if((state_val_48330 === (1))){
var state_48329__$1 = state_48329;
var statearr_48336_50401 = state_48329__$1;
(statearr_48336_50401[(2)] = null);

(statearr_48336_50401[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48330 === (2))){
var state_48329__$1 = state_48329;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48329__$1,(4),jobs);
} else {
if((state_val_48330 === (3))){
var inst_48327 = (state_48329[(2)]);
var state_48329__$1 = state_48329;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48329__$1,inst_48327);
} else {
if((state_val_48330 === (4))){
var inst_48316 = (state_48329[(2)]);
var inst_48317 = process(inst_48316);
var state_48329__$1 = state_48329;
if(cljs.core.truth_(inst_48317)){
var statearr_48339_50402 = state_48329__$1;
(statearr_48339_50402[(1)] = (5));

} else {
var statearr_48342_50403 = state_48329__$1;
(statearr_48342_50403[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48330 === (5))){
var state_48329__$1 = state_48329;
var statearr_48345_50404 = state_48329__$1;
(statearr_48345_50404[(2)] = null);

(statearr_48345_50404[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48330 === (6))){
var state_48329__$1 = state_48329;
var statearr_48347_50405 = state_48329__$1;
(statearr_48347_50405[(2)] = null);

(statearr_48347_50405[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48330 === (7))){
var inst_48325 = (state_48329[(2)]);
var state_48329__$1 = state_48329;
var statearr_48349_50406 = state_48329__$1;
(statearr_48349_50406[(2)] = inst_48325);

(statearr_48349_50406[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__50396,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
;
return ((function (__50396,switch__47851__auto__,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_48356 = [null,null,null,null,null,null,null];
(statearr_48356[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__);

(statearr_48356[(1)] = (1));

return statearr_48356;
});
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1 = (function (state_48329){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48329);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48357){var ex__47855__auto__ = e48357;
var statearr_48358_50409 = state_48329;
(statearr_48358_50409[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48329[(4)]))){
var statearr_48359_50410 = state_48329;
(statearr_48359_50410[(1)] = cljs.core.first((state_48329[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50411 = state_48329;
state_48329 = G__50411;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = function(state_48329){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1.call(this,state_48329);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__;
})()
;})(__50396,switch__47851__auto__,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
})();
var state__47917__auto__ = (function (){var statearr_48363 = f__47916__auto__();
(statearr_48363[(6)] = c__47915__auto___50400);

return statearr_48363;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
});})(__50396,c__47915__auto___50400,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
);


break;
case "async":
var c__47915__auto___50412 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__50396,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = ((function (__50396,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function (state_48383){
var state_val_48386 = (state_48383[(1)]);
if((state_val_48386 === (1))){
var state_48383__$1 = state_48383;
var statearr_48397_50413 = state_48383__$1;
(statearr_48397_50413[(2)] = null);

(statearr_48397_50413[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48386 === (2))){
var state_48383__$1 = state_48383;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48383__$1,(4),jobs);
} else {
if((state_val_48386 === (3))){
var inst_48381 = (state_48383[(2)]);
var state_48383__$1 = state_48383;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48383__$1,inst_48381);
} else {
if((state_val_48386 === (4))){
var inst_48371 = (state_48383[(2)]);
var inst_48372 = async(inst_48371);
var state_48383__$1 = state_48383;
if(cljs.core.truth_(inst_48372)){
var statearr_48408_50414 = state_48383__$1;
(statearr_48408_50414[(1)] = (5));

} else {
var statearr_48409_50415 = state_48383__$1;
(statearr_48409_50415[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48386 === (5))){
var state_48383__$1 = state_48383;
var statearr_48414_50416 = state_48383__$1;
(statearr_48414_50416[(2)] = null);

(statearr_48414_50416[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48386 === (6))){
var state_48383__$1 = state_48383;
var statearr_48424_50417 = state_48383__$1;
(statearr_48424_50417[(2)] = null);

(statearr_48424_50417[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48386 === (7))){
var inst_48379 = (state_48383[(2)]);
var state_48383__$1 = state_48383;
var statearr_48429_50418 = state_48383__$1;
(statearr_48429_50418[(2)] = inst_48379);

(statearr_48429_50418[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__50396,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
;
return ((function (__50396,switch__47851__auto__,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_48434 = [null,null,null,null,null,null,null];
(statearr_48434[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__);

(statearr_48434[(1)] = (1));

return statearr_48434;
});
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1 = (function (state_48383){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48383);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48438){var ex__47855__auto__ = e48438;
var statearr_48439_50419 = state_48383;
(statearr_48439_50419[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48383[(4)]))){
var statearr_48444_50420 = state_48383;
(statearr_48444_50420[(1)] = cljs.core.first((state_48383[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50421 = state_48383;
state_48383 = G__50421;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = function(state_48383){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1.call(this,state_48383);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__;
})()
;})(__50396,switch__47851__auto__,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
})();
var state__47917__auto__ = (function (){var statearr_48448 = f__47916__auto__();
(statearr_48448[(6)] = c__47915__auto___50412);

return statearr_48448;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
});})(__50396,c__47915__auto___50412,G__48312_50397,G__48312_50398__$1,n__4706__auto___50395,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__48312_50398__$1)].join('')));

}

var G__50422 = (__50396 + (1));
__50396 = G__50422;
continue;
} else {
}
break;
}

var c__47915__auto___50423 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48482){
var state_val_48483 = (state_48482[(1)]);
if((state_val_48483 === (7))){
var inst_48476 = (state_48482[(2)]);
var state_48482__$1 = state_48482;
var statearr_48503_50424 = state_48482__$1;
(statearr_48503_50424[(2)] = inst_48476);

(statearr_48503_50424[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48483 === (1))){
var state_48482__$1 = state_48482;
var statearr_48506_50425 = state_48482__$1;
(statearr_48506_50425[(2)] = null);

(statearr_48506_50425[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48483 === (4))){
var inst_48458 = (state_48482[(7)]);
var inst_48458__$1 = (state_48482[(2)]);
var inst_48459 = (inst_48458__$1 == null);
var state_48482__$1 = (function (){var statearr_48518 = state_48482;
(statearr_48518[(7)] = inst_48458__$1);

return statearr_48518;
})();
if(cljs.core.truth_(inst_48459)){
var statearr_48519_50426 = state_48482__$1;
(statearr_48519_50426[(1)] = (5));

} else {
var statearr_48522_50427 = state_48482__$1;
(statearr_48522_50427[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48483 === (6))){
var inst_48458 = (state_48482[(7)]);
var inst_48463 = (state_48482[(8)]);
var inst_48463__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_48465 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_48468 = [inst_48458,inst_48463__$1];
var inst_48469 = (new cljs.core.PersistentVector(null,2,(5),inst_48465,inst_48468,null));
var state_48482__$1 = (function (){var statearr_48526 = state_48482;
(statearr_48526[(8)] = inst_48463__$1);

return statearr_48526;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48482__$1,(8),jobs,inst_48469);
} else {
if((state_val_48483 === (3))){
var inst_48478 = (state_48482[(2)]);
var state_48482__$1 = state_48482;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48482__$1,inst_48478);
} else {
if((state_val_48483 === (2))){
var state_48482__$1 = state_48482;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48482__$1,(4),from);
} else {
if((state_val_48483 === (9))){
var inst_48473 = (state_48482[(2)]);
var state_48482__$1 = (function (){var statearr_48529 = state_48482;
(statearr_48529[(9)] = inst_48473);

return statearr_48529;
})();
var statearr_48532_50428 = state_48482__$1;
(statearr_48532_50428[(2)] = null);

(statearr_48532_50428[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48483 === (5))){
var inst_48461 = cljs.core.async.close_BANG_(jobs);
var state_48482__$1 = state_48482;
var statearr_48536_50429 = state_48482__$1;
(statearr_48536_50429[(2)] = inst_48461);

(statearr_48536_50429[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48483 === (8))){
var inst_48463 = (state_48482[(8)]);
var inst_48471 = (state_48482[(2)]);
var state_48482__$1 = (function (){var statearr_48537 = state_48482;
(statearr_48537[(10)] = inst_48471);

return statearr_48537;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48482__$1,(9),results,inst_48463);
} else {
return null;
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_48541 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_48541[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__);

(statearr_48541[(1)] = (1));

return statearr_48541;
});
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1 = (function (state_48482){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48482);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48550){var ex__47855__auto__ = e48550;
var statearr_48553_50430 = state_48482;
(statearr_48553_50430[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48482[(4)]))){
var statearr_48556_50431 = state_48482;
(statearr_48556_50431[(1)] = cljs.core.first((state_48482[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50433 = state_48482;
state_48482 = G__50433;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = function(state_48482){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1.call(this,state_48482);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48560 = f__47916__auto__();
(statearr_48560[(6)] = c__47915__auto___50423);

return statearr_48560;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


var c__47915__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48604){
var state_val_48605 = (state_48604[(1)]);
if((state_val_48605 === (7))){
var inst_48597 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
var statearr_48609_50434 = state_48604__$1;
(statearr_48609_50434[(2)] = inst_48597);

(statearr_48609_50434[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (20))){
var state_48604__$1 = state_48604;
var statearr_48610_50435 = state_48604__$1;
(statearr_48610_50435[(2)] = null);

(statearr_48610_50435[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (1))){
var state_48604__$1 = state_48604;
var statearr_48614_50436 = state_48604__$1;
(statearr_48614_50436[(2)] = null);

(statearr_48614_50436[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (4))){
var inst_48563 = (state_48604[(7)]);
var inst_48563__$1 = (state_48604[(2)]);
var inst_48564 = (inst_48563__$1 == null);
var state_48604__$1 = (function (){var statearr_48615 = state_48604;
(statearr_48615[(7)] = inst_48563__$1);

return statearr_48615;
})();
if(cljs.core.truth_(inst_48564)){
var statearr_48616_50437 = state_48604__$1;
(statearr_48616_50437[(1)] = (5));

} else {
var statearr_48617_50438 = state_48604__$1;
(statearr_48617_50438[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (15))){
var inst_48576 = (state_48604[(8)]);
var state_48604__$1 = state_48604;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48604__$1,(18),to,inst_48576);
} else {
if((state_val_48605 === (21))){
var inst_48589 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
var statearr_48618_50440 = state_48604__$1;
(statearr_48618_50440[(2)] = inst_48589);

(statearr_48618_50440[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (13))){
var inst_48591 = (state_48604[(2)]);
var state_48604__$1 = (function (){var statearr_48619 = state_48604;
(statearr_48619[(9)] = inst_48591);

return statearr_48619;
})();
var statearr_48620_50442 = state_48604__$1;
(statearr_48620_50442[(2)] = null);

(statearr_48620_50442[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (6))){
var inst_48563 = (state_48604[(7)]);
var state_48604__$1 = state_48604;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48604__$1,(11),inst_48563);
} else {
if((state_val_48605 === (17))){
var inst_48584 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
if(cljs.core.truth_(inst_48584)){
var statearr_48621_50443 = state_48604__$1;
(statearr_48621_50443[(1)] = (19));

} else {
var statearr_48622_50444 = state_48604__$1;
(statearr_48622_50444[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (3))){
var inst_48599 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48604__$1,inst_48599);
} else {
if((state_val_48605 === (12))){
var inst_48573 = (state_48604[(10)]);
var state_48604__$1 = state_48604;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48604__$1,(14),inst_48573);
} else {
if((state_val_48605 === (2))){
var state_48604__$1 = state_48604;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48604__$1,(4),results);
} else {
if((state_val_48605 === (19))){
var state_48604__$1 = state_48604;
var statearr_48627_50445 = state_48604__$1;
(statearr_48627_50445[(2)] = null);

(statearr_48627_50445[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (11))){
var inst_48573 = (state_48604[(2)]);
var state_48604__$1 = (function (){var statearr_48628 = state_48604;
(statearr_48628[(10)] = inst_48573);

return statearr_48628;
})();
var statearr_48629_50446 = state_48604__$1;
(statearr_48629_50446[(2)] = null);

(statearr_48629_50446[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (9))){
var state_48604__$1 = state_48604;
var statearr_48630_50447 = state_48604__$1;
(statearr_48630_50447[(2)] = null);

(statearr_48630_50447[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (5))){
var state_48604__$1 = state_48604;
if(cljs.core.truth_(close_QMARK_)){
var statearr_48631_50449 = state_48604__$1;
(statearr_48631_50449[(1)] = (8));

} else {
var statearr_48632_50450 = state_48604__$1;
(statearr_48632_50450[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (14))){
var inst_48578 = (state_48604[(11)]);
var inst_48576 = (state_48604[(8)]);
var inst_48576__$1 = (state_48604[(2)]);
var inst_48577 = (inst_48576__$1 == null);
var inst_48578__$1 = cljs.core.not(inst_48577);
var state_48604__$1 = (function (){var statearr_48633 = state_48604;
(statearr_48633[(11)] = inst_48578__$1);

(statearr_48633[(8)] = inst_48576__$1);

return statearr_48633;
})();
if(inst_48578__$1){
var statearr_48635_50451 = state_48604__$1;
(statearr_48635_50451[(1)] = (15));

} else {
var statearr_48636_50452 = state_48604__$1;
(statearr_48636_50452[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (16))){
var inst_48578 = (state_48604[(11)]);
var state_48604__$1 = state_48604;
var statearr_48637_50453 = state_48604__$1;
(statearr_48637_50453[(2)] = inst_48578);

(statearr_48637_50453[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (10))){
var inst_48570 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
var statearr_48639_50455 = state_48604__$1;
(statearr_48639_50455[(2)] = inst_48570);

(statearr_48639_50455[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (18))){
var inst_48581 = (state_48604[(2)]);
var state_48604__$1 = state_48604;
var statearr_48640_50456 = state_48604__$1;
(statearr_48640_50456[(2)] = inst_48581);

(statearr_48640_50456[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48605 === (8))){
var inst_48567 = cljs.core.async.close_BANG_(to);
var state_48604__$1 = state_48604;
var statearr_48642_50458 = state_48604__$1;
(statearr_48642_50458[(2)] = inst_48567);

(statearr_48642_50458[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_48646 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_48646[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__);

(statearr_48646[(1)] = (1));

return statearr_48646;
});
var cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1 = (function (state_48604){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48604);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48647){var ex__47855__auto__ = e48647;
var statearr_48648_50459 = state_48604;
(statearr_48648_50459[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48604[(4)]))){
var statearr_48649_50460 = state_48604;
(statearr_48649_50460[(1)] = cljs.core.first((state_48604[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50461 = state_48604;
state_48604 = G__50461;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__ = function(state_48604){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1.call(this,state_48604);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48651 = f__47916__auto__();
(statearr_48651[(6)] = c__47915__auto__);

return statearr_48651;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));

return c__47915__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__48659 = arguments.length;
switch (G__48659) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
}));

(cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
}));

(cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5);

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__48664 = arguments.length;
switch (G__48664) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
}));

(cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
}));

(cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6);

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__48670 = arguments.length;
switch (G__48670) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
}));

(cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__47915__auto___50469 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48705){
var state_val_48706 = (state_48705[(1)]);
if((state_val_48706 === (7))){
var inst_48701 = (state_48705[(2)]);
var state_48705__$1 = state_48705;
var statearr_48711_50470 = state_48705__$1;
(statearr_48711_50470[(2)] = inst_48701);

(statearr_48711_50470[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (1))){
var state_48705__$1 = state_48705;
var statearr_48713_50471 = state_48705__$1;
(statearr_48713_50471[(2)] = null);

(statearr_48713_50471[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (4))){
var inst_48681 = (state_48705[(7)]);
var inst_48681__$1 = (state_48705[(2)]);
var inst_48682 = (inst_48681__$1 == null);
var state_48705__$1 = (function (){var statearr_48716 = state_48705;
(statearr_48716[(7)] = inst_48681__$1);

return statearr_48716;
})();
if(cljs.core.truth_(inst_48682)){
var statearr_48718_50473 = state_48705__$1;
(statearr_48718_50473[(1)] = (5));

} else {
var statearr_48719_50474 = state_48705__$1;
(statearr_48719_50474[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (13))){
var state_48705__$1 = state_48705;
var statearr_48721_50476 = state_48705__$1;
(statearr_48721_50476[(2)] = null);

(statearr_48721_50476[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (6))){
var inst_48681 = (state_48705[(7)]);
var inst_48687 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_48681) : p.call(null,inst_48681));
var state_48705__$1 = state_48705;
if(cljs.core.truth_(inst_48687)){
var statearr_48722_50477 = state_48705__$1;
(statearr_48722_50477[(1)] = (9));

} else {
var statearr_48723_50478 = state_48705__$1;
(statearr_48723_50478[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (3))){
var inst_48703 = (state_48705[(2)]);
var state_48705__$1 = state_48705;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48705__$1,inst_48703);
} else {
if((state_val_48706 === (12))){
var state_48705__$1 = state_48705;
var statearr_48738_50479 = state_48705__$1;
(statearr_48738_50479[(2)] = null);

(statearr_48738_50479[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (2))){
var state_48705__$1 = state_48705;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48705__$1,(4),ch);
} else {
if((state_val_48706 === (11))){
var inst_48681 = (state_48705[(7)]);
var inst_48691 = (state_48705[(2)]);
var state_48705__$1 = state_48705;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48705__$1,(8),inst_48691,inst_48681);
} else {
if((state_val_48706 === (9))){
var state_48705__$1 = state_48705;
var statearr_48741_50481 = state_48705__$1;
(statearr_48741_50481[(2)] = tc);

(statearr_48741_50481[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (5))){
var inst_48684 = cljs.core.async.close_BANG_(tc);
var inst_48685 = cljs.core.async.close_BANG_(fc);
var state_48705__$1 = (function (){var statearr_48743 = state_48705;
(statearr_48743[(8)] = inst_48684);

return statearr_48743;
})();
var statearr_48744_50483 = state_48705__$1;
(statearr_48744_50483[(2)] = inst_48685);

(statearr_48744_50483[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (14))){
var inst_48699 = (state_48705[(2)]);
var state_48705__$1 = state_48705;
var statearr_48746_50484 = state_48705__$1;
(statearr_48746_50484[(2)] = inst_48699);

(statearr_48746_50484[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (10))){
var state_48705__$1 = state_48705;
var statearr_48747_50485 = state_48705__$1;
(statearr_48747_50485[(2)] = fc);

(statearr_48747_50485[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48706 === (8))){
var inst_48693 = (state_48705[(2)]);
var state_48705__$1 = state_48705;
if(cljs.core.truth_(inst_48693)){
var statearr_48751_50486 = state_48705__$1;
(statearr_48751_50486[(1)] = (12));

} else {
var statearr_48752_50488 = state_48705__$1;
(statearr_48752_50488[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_48778 = [null,null,null,null,null,null,null,null,null];
(statearr_48778[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_48778[(1)] = (1));

return statearr_48778;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_48705){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48705);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48788){var ex__47855__auto__ = e48788;
var statearr_48790_50489 = state_48705;
(statearr_48790_50489[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48705[(4)]))){
var statearr_48791_50490 = state_48705;
(statearr_48791_50490[(1)] = cljs.core.first((state_48705[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50491 = state_48705;
state_48705 = G__50491;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_48705){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_48705);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48803 = f__47916__auto__();
(statearr_48803[(6)] = c__47915__auto___50469);

return statearr_48803;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
}));

(cljs.core.async.split.cljs$lang$maxFixedArity = 4);

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__47915__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48830){
var state_val_48831 = (state_48830[(1)]);
if((state_val_48831 === (7))){
var inst_48826 = (state_48830[(2)]);
var state_48830__$1 = state_48830;
var statearr_48835_50494 = state_48830__$1;
(statearr_48835_50494[(2)] = inst_48826);

(statearr_48835_50494[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (1))){
var inst_48809 = init;
var inst_48810 = inst_48809;
var state_48830__$1 = (function (){var statearr_48836 = state_48830;
(statearr_48836[(7)] = inst_48810);

return statearr_48836;
})();
var statearr_48838_50495 = state_48830__$1;
(statearr_48838_50495[(2)] = null);

(statearr_48838_50495[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (4))){
var inst_48813 = (state_48830[(8)]);
var inst_48813__$1 = (state_48830[(2)]);
var inst_48814 = (inst_48813__$1 == null);
var state_48830__$1 = (function (){var statearr_48842 = state_48830;
(statearr_48842[(8)] = inst_48813__$1);

return statearr_48842;
})();
if(cljs.core.truth_(inst_48814)){
var statearr_48845_50496 = state_48830__$1;
(statearr_48845_50496[(1)] = (5));

} else {
var statearr_48847_50497 = state_48830__$1;
(statearr_48847_50497[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (6))){
var inst_48810 = (state_48830[(7)]);
var inst_48817 = (state_48830[(9)]);
var inst_48813 = (state_48830[(8)]);
var inst_48817__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_48810,inst_48813) : f.call(null,inst_48810,inst_48813));
var inst_48818 = cljs.core.reduced_QMARK_(inst_48817__$1);
var state_48830__$1 = (function (){var statearr_48852 = state_48830;
(statearr_48852[(9)] = inst_48817__$1);

return statearr_48852;
})();
if(inst_48818){
var statearr_48854_50498 = state_48830__$1;
(statearr_48854_50498[(1)] = (8));

} else {
var statearr_48855_50499 = state_48830__$1;
(statearr_48855_50499[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (3))){
var inst_48828 = (state_48830[(2)]);
var state_48830__$1 = state_48830;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48830__$1,inst_48828);
} else {
if((state_val_48831 === (2))){
var state_48830__$1 = state_48830;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48830__$1,(4),ch);
} else {
if((state_val_48831 === (9))){
var inst_48817 = (state_48830[(9)]);
var inst_48810 = inst_48817;
var state_48830__$1 = (function (){var statearr_48856 = state_48830;
(statearr_48856[(7)] = inst_48810);

return statearr_48856;
})();
var statearr_48857_50500 = state_48830__$1;
(statearr_48857_50500[(2)] = null);

(statearr_48857_50500[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (5))){
var inst_48810 = (state_48830[(7)]);
var state_48830__$1 = state_48830;
var statearr_48858_50501 = state_48830__$1;
(statearr_48858_50501[(2)] = inst_48810);

(statearr_48858_50501[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (10))){
var inst_48824 = (state_48830[(2)]);
var state_48830__$1 = state_48830;
var statearr_48861_50502 = state_48830__$1;
(statearr_48861_50502[(2)] = inst_48824);

(statearr_48861_50502[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48831 === (8))){
var inst_48817 = (state_48830[(9)]);
var inst_48820 = cljs.core.deref(inst_48817);
var state_48830__$1 = state_48830;
var statearr_48863_50503 = state_48830__$1;
(statearr_48863_50503[(2)] = inst_48820);

(statearr_48863_50503[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$reduce_$_state_machine__47852__auto__ = null;
var cljs$core$async$reduce_$_state_machine__47852__auto____0 = (function (){
var statearr_48865 = [null,null,null,null,null,null,null,null,null,null];
(statearr_48865[(0)] = cljs$core$async$reduce_$_state_machine__47852__auto__);

(statearr_48865[(1)] = (1));

return statearr_48865;
});
var cljs$core$async$reduce_$_state_machine__47852__auto____1 = (function (state_48830){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48830);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48866){var ex__47855__auto__ = e48866;
var statearr_48869_50504 = state_48830;
(statearr_48869_50504[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48830[(4)]))){
var statearr_48870_50505 = state_48830;
(statearr_48870_50505[(1)] = cljs.core.first((state_48830[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50507 = state_48830;
state_48830 = G__50507;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__47852__auto__ = function(state_48830){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__47852__auto____1.call(this,state_48830);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__47852__auto____0;
cljs$core$async$reduce_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__47852__auto____1;
return cljs$core$async$reduce_$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48875 = f__47916__auto__();
(statearr_48875[(6)] = c__47915__auto__);

return statearr_48875;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));

return c__47915__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = (xform.cljs$core$IFn$_invoke$arity$1 ? xform.cljs$core$IFn$_invoke$arity$1(f) : xform.call(null,f));
var c__47915__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48884){
var state_val_48885 = (state_48884[(1)]);
if((state_val_48885 === (1))){
var inst_48879 = cljs.core.async.reduce(f__$1,init,ch);
var state_48884__$1 = state_48884;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_48884__$1,(2),inst_48879);
} else {
if((state_val_48885 === (2))){
var inst_48881 = (state_48884[(2)]);
var inst_48882 = (f__$1.cljs$core$IFn$_invoke$arity$1 ? f__$1.cljs$core$IFn$_invoke$arity$1(inst_48881) : f__$1.call(null,inst_48881));
var state_48884__$1 = state_48884;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48884__$1,inst_48882);
} else {
return null;
}
}
});
return (function() {
var cljs$core$async$transduce_$_state_machine__47852__auto__ = null;
var cljs$core$async$transduce_$_state_machine__47852__auto____0 = (function (){
var statearr_48889 = [null,null,null,null,null,null,null];
(statearr_48889[(0)] = cljs$core$async$transduce_$_state_machine__47852__auto__);

(statearr_48889[(1)] = (1));

return statearr_48889;
});
var cljs$core$async$transduce_$_state_machine__47852__auto____1 = (function (state_48884){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48884);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48890){var ex__47855__auto__ = e48890;
var statearr_48891_50509 = state_48884;
(statearr_48891_50509[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48884[(4)]))){
var statearr_48892_50510 = state_48884;
(statearr_48892_50510[(1)] = cljs.core.first((state_48884[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50511 = state_48884;
state_48884 = G__50511;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__47852__auto__ = function(state_48884){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__47852__auto____1.call(this,state_48884);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__47852__auto____0;
cljs$core$async$transduce_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__47852__auto____1;
return cljs$core$async$transduce_$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48894 = f__47916__auto__();
(statearr_48894[(6)] = c__47915__auto__);

return statearr_48894;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));

return c__47915__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan_BANG_ = (function cljs$core$async$onto_chan_BANG_(var_args){
var G__48896 = arguments.length;
switch (G__48896) {
case 2:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__47915__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_48923){
var state_val_48924 = (state_48923[(1)]);
if((state_val_48924 === (7))){
var inst_48905 = (state_48923[(2)]);
var state_48923__$1 = state_48923;
var statearr_48926_50513 = state_48923__$1;
(statearr_48926_50513[(2)] = inst_48905);

(statearr_48926_50513[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (1))){
var inst_48899 = cljs.core.seq(coll);
var inst_48900 = inst_48899;
var state_48923__$1 = (function (){var statearr_48928 = state_48923;
(statearr_48928[(7)] = inst_48900);

return statearr_48928;
})();
var statearr_48930_50514 = state_48923__$1;
(statearr_48930_50514[(2)] = null);

(statearr_48930_50514[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (4))){
var inst_48900 = (state_48923[(7)]);
var inst_48903 = cljs.core.first(inst_48900);
var state_48923__$1 = state_48923;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_48923__$1,(7),ch,inst_48903);
} else {
if((state_val_48924 === (13))){
var inst_48917 = (state_48923[(2)]);
var state_48923__$1 = state_48923;
var statearr_48932_50515 = state_48923__$1;
(statearr_48932_50515[(2)] = inst_48917);

(statearr_48932_50515[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (6))){
var inst_48908 = (state_48923[(2)]);
var state_48923__$1 = state_48923;
if(cljs.core.truth_(inst_48908)){
var statearr_48936_50516 = state_48923__$1;
(statearr_48936_50516[(1)] = (8));

} else {
var statearr_48937_50517 = state_48923__$1;
(statearr_48937_50517[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (3))){
var inst_48921 = (state_48923[(2)]);
var state_48923__$1 = state_48923;
return cljs.core.async.impl.ioc_helpers.return_chan(state_48923__$1,inst_48921);
} else {
if((state_val_48924 === (12))){
var state_48923__$1 = state_48923;
var statearr_48939_50518 = state_48923__$1;
(statearr_48939_50518[(2)] = null);

(statearr_48939_50518[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (2))){
var inst_48900 = (state_48923[(7)]);
var state_48923__$1 = state_48923;
if(cljs.core.truth_(inst_48900)){
var statearr_48943_50522 = state_48923__$1;
(statearr_48943_50522[(1)] = (4));

} else {
var statearr_48945_50523 = state_48923__$1;
(statearr_48945_50523[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (11))){
var inst_48914 = cljs.core.async.close_BANG_(ch);
var state_48923__$1 = state_48923;
var statearr_48946_50524 = state_48923__$1;
(statearr_48946_50524[(2)] = inst_48914);

(statearr_48946_50524[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (9))){
var state_48923__$1 = state_48923;
if(cljs.core.truth_(close_QMARK_)){
var statearr_48948_50525 = state_48923__$1;
(statearr_48948_50525[(1)] = (11));

} else {
var statearr_48949_50526 = state_48923__$1;
(statearr_48949_50526[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (5))){
var inst_48900 = (state_48923[(7)]);
var state_48923__$1 = state_48923;
var statearr_48951_50527 = state_48923__$1;
(statearr_48951_50527[(2)] = inst_48900);

(statearr_48951_50527[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (10))){
var inst_48919 = (state_48923[(2)]);
var state_48923__$1 = state_48923;
var statearr_48952_50528 = state_48923__$1;
(statearr_48952_50528[(2)] = inst_48919);

(statearr_48952_50528[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_48924 === (8))){
var inst_48900 = (state_48923[(7)]);
var inst_48910 = cljs.core.next(inst_48900);
var inst_48900__$1 = inst_48910;
var state_48923__$1 = (function (){var statearr_48954 = state_48923;
(statearr_48954[(7)] = inst_48900__$1);

return statearr_48954;
})();
var statearr_48955_50529 = state_48923__$1;
(statearr_48955_50529[(2)] = null);

(statearr_48955_50529[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_48956 = [null,null,null,null,null,null,null,null];
(statearr_48956[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_48956[(1)] = (1));

return statearr_48956;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_48923){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_48923);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e48958){var ex__47855__auto__ = e48958;
var statearr_48959_50530 = state_48923;
(statearr_48959_50530[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_48923[(4)]))){
var statearr_48960_50533 = state_48923;
(statearr_48960_50533[(1)] = cljs.core.first((state_48923[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50534 = state_48923;
state_48923 = G__50534;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_48923){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_48923);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_48961 = f__47916__auto__();
(statearr_48961[(6)] = c__47915__auto__);

return statearr_48961;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));

return c__47915__auto__;
}));

(cljs.core.async.onto_chan_BANG_.cljs$lang$maxFixedArity = 3);

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan_BANG_ = (function cljs$core$async$to_chan_BANG_(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});
/**
 * Deprecated - use onto-chan!
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__48966 = arguments.length;
switch (G__48966) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
}));

(cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
return cljs.core.async.onto_chan_BANG_.cljs$core$IFn$_invoke$arity$3(ch,coll,close_QMARK_);
}));

(cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - use to-chan!
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
return cljs.core.async.to_chan_BANG_(coll);
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

var cljs$core$async$Mux$muxch_STAR_$dyn_50540 = (function (_){
var x__4521__auto__ = (((_ == null))?null:_);
var m__4522__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4522__auto__.call(null,_));
} else {
var m__4519__auto__ = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4519__auto__.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
});
cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
return cljs$core$async$Mux$muxch_STAR_$dyn_50540(_);
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

var cljs$core$async$Mult$tap_STAR_$dyn_50542 = (function (m,ch,close_QMARK_){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4522__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__4519__auto__ = (cljs.core.async.tap_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4519__auto__.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
});
cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
return cljs$core$async$Mult$tap_STAR_$dyn_50542(m,ch,close_QMARK_);
}
});

var cljs$core$async$Mult$untap_STAR_$dyn_50543 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.untap_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
});
cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mult$untap_STAR_$dyn_50543(m,ch);
}
});

var cljs$core$async$Mult$untap_all_STAR_$dyn_50544 = (function (m){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4522__auto__.call(null,m));
} else {
var m__4519__auto__ = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4519__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
});
cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mult$untap_all_STAR_$dyn_50544(m);
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async48973 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async48973 = (function (ch,cs,meta48974){
this.ch = ch;
this.cs = cs;
this.meta48974 = meta48974;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_48975,meta48974__$1){
var self__ = this;
var _48975__$1 = this;
return (new cljs.core.async.t_cljs$core$async48973(self__.ch,self__.cs,meta48974__$1));
}));

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_48975){
var self__ = this;
var _48975__$1 = this;
return self__.meta48974;
}));

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
}));

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
}));

(cljs.core.async.t_cljs$core$async48973.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
}));

(cljs.core.async.t_cljs$core$async48973.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta48974","meta48974",153047449,null)], null);
}));

(cljs.core.async.t_cljs$core$async48973.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async48973.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async48973");

(cljs.core.async.t_cljs$core$async48973.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async48973");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async48973.
 */
cljs.core.async.__GT_t_cljs$core$async48973 = (function cljs$core$async$mult_$___GT_t_cljs$core$async48973(ch__$1,cs__$1,meta48974){
return (new cljs.core.async.t_cljs$core$async48973(ch__$1,cs__$1,meta48974));
});

}

return (new cljs.core.async.t_cljs$core$async48973(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});
var c__47915__auto___50545 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49157){
var state_val_49158 = (state_49157[(1)]);
if((state_val_49158 === (7))){
var inst_49153 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49159_50547 = state_49157__$1;
(statearr_49159_50547[(2)] = inst_49153);

(statearr_49159_50547[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (20))){
var inst_49016 = (state_49157[(7)]);
var inst_49028 = cljs.core.first(inst_49016);
var inst_49029 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49028,(0),null);
var inst_49030 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49028,(1),null);
var state_49157__$1 = (function (){var statearr_49160 = state_49157;
(statearr_49160[(8)] = inst_49029);

return statearr_49160;
})();
if(cljs.core.truth_(inst_49030)){
var statearr_49161_50549 = state_49157__$1;
(statearr_49161_50549[(1)] = (22));

} else {
var statearr_49162_50550 = state_49157__$1;
(statearr_49162_50550[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (27))){
var inst_49062 = (state_49157[(9)]);
var inst_49064 = (state_49157[(10)]);
var inst_49083 = (state_49157[(11)]);
var inst_48985 = (state_49157[(12)]);
var inst_49083__$1 = cljs.core._nth(inst_49062,inst_49064);
var inst_49084 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_49083__$1,inst_48985,done);
var state_49157__$1 = (function (){var statearr_49163 = state_49157;
(statearr_49163[(11)] = inst_49083__$1);

return statearr_49163;
})();
if(cljs.core.truth_(inst_49084)){
var statearr_49164_50551 = state_49157__$1;
(statearr_49164_50551[(1)] = (30));

} else {
var statearr_49165_50552 = state_49157__$1;
(statearr_49165_50552[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (1))){
var state_49157__$1 = state_49157;
var statearr_49166_50553 = state_49157__$1;
(statearr_49166_50553[(2)] = null);

(statearr_49166_50553[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (24))){
var inst_49016 = (state_49157[(7)]);
var inst_49035 = (state_49157[(2)]);
var inst_49036 = cljs.core.next(inst_49016);
var inst_48994 = inst_49036;
var inst_48995 = null;
var inst_48996 = (0);
var inst_48997 = (0);
var state_49157__$1 = (function (){var statearr_49168 = state_49157;
(statearr_49168[(13)] = inst_48997);

(statearr_49168[(14)] = inst_48994);

(statearr_49168[(15)] = inst_48996);

(statearr_49168[(16)] = inst_49035);

(statearr_49168[(17)] = inst_48995);

return statearr_49168;
})();
var statearr_49169_50554 = state_49157__$1;
(statearr_49169_50554[(2)] = null);

(statearr_49169_50554[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (39))){
var state_49157__$1 = state_49157;
var statearr_49173_50555 = state_49157__$1;
(statearr_49173_50555[(2)] = null);

(statearr_49173_50555[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (4))){
var inst_48985 = (state_49157[(12)]);
var inst_48985__$1 = (state_49157[(2)]);
var inst_48986 = (inst_48985__$1 == null);
var state_49157__$1 = (function (){var statearr_49174 = state_49157;
(statearr_49174[(12)] = inst_48985__$1);

return statearr_49174;
})();
if(cljs.core.truth_(inst_48986)){
var statearr_49175_50556 = state_49157__$1;
(statearr_49175_50556[(1)] = (5));

} else {
var statearr_49176_50557 = state_49157__$1;
(statearr_49176_50557[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (15))){
var inst_48997 = (state_49157[(13)]);
var inst_48994 = (state_49157[(14)]);
var inst_48996 = (state_49157[(15)]);
var inst_48995 = (state_49157[(17)]);
var inst_49012 = (state_49157[(2)]);
var inst_49013 = (inst_48997 + (1));
var tmp49170 = inst_48994;
var tmp49171 = inst_48996;
var tmp49172 = inst_48995;
var inst_48994__$1 = tmp49170;
var inst_48995__$1 = tmp49172;
var inst_48996__$1 = tmp49171;
var inst_48997__$1 = inst_49013;
var state_49157__$1 = (function (){var statearr_49178 = state_49157;
(statearr_49178[(13)] = inst_48997__$1);

(statearr_49178[(14)] = inst_48994__$1);

(statearr_49178[(18)] = inst_49012);

(statearr_49178[(15)] = inst_48996__$1);

(statearr_49178[(17)] = inst_48995__$1);

return statearr_49178;
})();
var statearr_49179_50558 = state_49157__$1;
(statearr_49179_50558[(2)] = null);

(statearr_49179_50558[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (21))){
var inst_49039 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49183_50559 = state_49157__$1;
(statearr_49183_50559[(2)] = inst_49039);

(statearr_49183_50559[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (31))){
var inst_49083 = (state_49157[(11)]);
var inst_49096 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_49083);
var state_49157__$1 = state_49157;
var statearr_49184_50560 = state_49157__$1;
(statearr_49184_50560[(2)] = inst_49096);

(statearr_49184_50560[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (32))){
var inst_49062 = (state_49157[(9)]);
var inst_49060 = (state_49157[(19)]);
var inst_49063 = (state_49157[(20)]);
var inst_49064 = (state_49157[(10)]);
var inst_49098 = (state_49157[(2)]);
var inst_49105 = (inst_49064 + (1));
var tmp49180 = inst_49062;
var tmp49181 = inst_49060;
var tmp49182 = inst_49063;
var inst_49060__$1 = tmp49181;
var inst_49062__$1 = tmp49180;
var inst_49063__$1 = tmp49182;
var inst_49064__$1 = inst_49105;
var state_49157__$1 = (function (){var statearr_49185 = state_49157;
(statearr_49185[(9)] = inst_49062__$1);

(statearr_49185[(19)] = inst_49060__$1);

(statearr_49185[(21)] = inst_49098);

(statearr_49185[(20)] = inst_49063__$1);

(statearr_49185[(10)] = inst_49064__$1);

return statearr_49185;
})();
var statearr_49188_50562 = state_49157__$1;
(statearr_49188_50562[(2)] = null);

(statearr_49188_50562[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (40))){
var inst_49123 = (state_49157[(22)]);
var inst_49127 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_49123);
var state_49157__$1 = state_49157;
var statearr_49193_50570 = state_49157__$1;
(statearr_49193_50570[(2)] = inst_49127);

(statearr_49193_50570[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (33))){
var inst_49108 = (state_49157[(23)]);
var inst_49110 = cljs.core.chunked_seq_QMARK_(inst_49108);
var state_49157__$1 = state_49157;
if(inst_49110){
var statearr_49194_50571 = state_49157__$1;
(statearr_49194_50571[(1)] = (36));

} else {
var statearr_49197_50576 = state_49157__$1;
(statearr_49197_50576[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (13))){
var inst_49006 = (state_49157[(24)]);
var inst_49009 = cljs.core.async.close_BANG_(inst_49006);
var state_49157__$1 = state_49157;
var statearr_49198_50578 = state_49157__$1;
(statearr_49198_50578[(2)] = inst_49009);

(statearr_49198_50578[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (22))){
var inst_49029 = (state_49157[(8)]);
var inst_49032 = cljs.core.async.close_BANG_(inst_49029);
var state_49157__$1 = state_49157;
var statearr_49199_50579 = state_49157__$1;
(statearr_49199_50579[(2)] = inst_49032);

(statearr_49199_50579[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (36))){
var inst_49108 = (state_49157[(23)]);
var inst_49112 = cljs.core.chunk_first(inst_49108);
var inst_49113 = cljs.core.chunk_rest(inst_49108);
var inst_49114 = cljs.core.count(inst_49112);
var inst_49060 = inst_49113;
var inst_49062 = inst_49112;
var inst_49063 = inst_49114;
var inst_49064 = (0);
var state_49157__$1 = (function (){var statearr_49205 = state_49157;
(statearr_49205[(9)] = inst_49062);

(statearr_49205[(19)] = inst_49060);

(statearr_49205[(20)] = inst_49063);

(statearr_49205[(10)] = inst_49064);

return statearr_49205;
})();
var statearr_49211_50580 = state_49157__$1;
(statearr_49211_50580[(2)] = null);

(statearr_49211_50580[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (41))){
var inst_49108 = (state_49157[(23)]);
var inst_49129 = (state_49157[(2)]);
var inst_49130 = cljs.core.next(inst_49108);
var inst_49060 = inst_49130;
var inst_49062 = null;
var inst_49063 = (0);
var inst_49064 = (0);
var state_49157__$1 = (function (){var statearr_49216 = state_49157;
(statearr_49216[(9)] = inst_49062);

(statearr_49216[(19)] = inst_49060);

(statearr_49216[(20)] = inst_49063);

(statearr_49216[(10)] = inst_49064);

(statearr_49216[(25)] = inst_49129);

return statearr_49216;
})();
var statearr_49217_50586 = state_49157__$1;
(statearr_49217_50586[(2)] = null);

(statearr_49217_50586[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (43))){
var state_49157__$1 = state_49157;
var statearr_49218_50587 = state_49157__$1;
(statearr_49218_50587[(2)] = null);

(statearr_49218_50587[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (29))){
var inst_49141 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49219_50592 = state_49157__$1;
(statearr_49219_50592[(2)] = inst_49141);

(statearr_49219_50592[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (44))){
var inst_49150 = (state_49157[(2)]);
var state_49157__$1 = (function (){var statearr_49220 = state_49157;
(statearr_49220[(26)] = inst_49150);

return statearr_49220;
})();
var statearr_49221_50593 = state_49157__$1;
(statearr_49221_50593[(2)] = null);

(statearr_49221_50593[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (6))){
var inst_49049 = (state_49157[(27)]);
var inst_49048 = cljs.core.deref(cs);
var inst_49049__$1 = cljs.core.keys(inst_49048);
var inst_49050 = cljs.core.count(inst_49049__$1);
var inst_49051 = cljs.core.reset_BANG_(dctr,inst_49050);
var inst_49059 = cljs.core.seq(inst_49049__$1);
var inst_49060 = inst_49059;
var inst_49062 = null;
var inst_49063 = (0);
var inst_49064 = (0);
var state_49157__$1 = (function (){var statearr_49224 = state_49157;
(statearr_49224[(9)] = inst_49062);

(statearr_49224[(19)] = inst_49060);

(statearr_49224[(20)] = inst_49063);

(statearr_49224[(10)] = inst_49064);

(statearr_49224[(27)] = inst_49049__$1);

(statearr_49224[(28)] = inst_49051);

return statearr_49224;
})();
var statearr_49226_50594 = state_49157__$1;
(statearr_49226_50594[(2)] = null);

(statearr_49226_50594[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (28))){
var inst_49060 = (state_49157[(19)]);
var inst_49108 = (state_49157[(23)]);
var inst_49108__$1 = cljs.core.seq(inst_49060);
var state_49157__$1 = (function (){var statearr_49227 = state_49157;
(statearr_49227[(23)] = inst_49108__$1);

return statearr_49227;
})();
if(inst_49108__$1){
var statearr_49228_50595 = state_49157__$1;
(statearr_49228_50595[(1)] = (33));

} else {
var statearr_49229_50596 = state_49157__$1;
(statearr_49229_50596[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (25))){
var inst_49063 = (state_49157[(20)]);
var inst_49064 = (state_49157[(10)]);
var inst_49074 = (inst_49064 < inst_49063);
var inst_49075 = inst_49074;
var state_49157__$1 = state_49157;
if(cljs.core.truth_(inst_49075)){
var statearr_49230_50598 = state_49157__$1;
(statearr_49230_50598[(1)] = (27));

} else {
var statearr_49231_50599 = state_49157__$1;
(statearr_49231_50599[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (34))){
var state_49157__$1 = state_49157;
var statearr_49233_50600 = state_49157__$1;
(statearr_49233_50600[(2)] = null);

(statearr_49233_50600[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (17))){
var state_49157__$1 = state_49157;
var statearr_49234_50601 = state_49157__$1;
(statearr_49234_50601[(2)] = null);

(statearr_49234_50601[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (3))){
var inst_49155 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49157__$1,inst_49155);
} else {
if((state_val_49158 === (12))){
var inst_49044 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49235_50602 = state_49157__$1;
(statearr_49235_50602[(2)] = inst_49044);

(statearr_49235_50602[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (2))){
var state_49157__$1 = state_49157;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49157__$1,(4),ch);
} else {
if((state_val_49158 === (23))){
var state_49157__$1 = state_49157;
var statearr_49236_50603 = state_49157__$1;
(statearr_49236_50603[(2)] = null);

(statearr_49236_50603[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (35))){
var inst_49136 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49237_50604 = state_49157__$1;
(statearr_49237_50604[(2)] = inst_49136);

(statearr_49237_50604[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (19))){
var inst_49016 = (state_49157[(7)]);
var inst_49020 = cljs.core.chunk_first(inst_49016);
var inst_49021 = cljs.core.chunk_rest(inst_49016);
var inst_49022 = cljs.core.count(inst_49020);
var inst_48994 = inst_49021;
var inst_48995 = inst_49020;
var inst_48996 = inst_49022;
var inst_48997 = (0);
var state_49157__$1 = (function (){var statearr_49238 = state_49157;
(statearr_49238[(13)] = inst_48997);

(statearr_49238[(14)] = inst_48994);

(statearr_49238[(15)] = inst_48996);

(statearr_49238[(17)] = inst_48995);

return statearr_49238;
})();
var statearr_49239_50605 = state_49157__$1;
(statearr_49239_50605[(2)] = null);

(statearr_49239_50605[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (11))){
var inst_49016 = (state_49157[(7)]);
var inst_48994 = (state_49157[(14)]);
var inst_49016__$1 = cljs.core.seq(inst_48994);
var state_49157__$1 = (function (){var statearr_49240 = state_49157;
(statearr_49240[(7)] = inst_49016__$1);

return statearr_49240;
})();
if(inst_49016__$1){
var statearr_49241_50606 = state_49157__$1;
(statearr_49241_50606[(1)] = (16));

} else {
var statearr_49242_50607 = state_49157__$1;
(statearr_49242_50607[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (9))){
var inst_49046 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49243_50608 = state_49157__$1;
(statearr_49243_50608[(2)] = inst_49046);

(statearr_49243_50608[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (5))){
var inst_48992 = cljs.core.deref(cs);
var inst_48993 = cljs.core.seq(inst_48992);
var inst_48994 = inst_48993;
var inst_48995 = null;
var inst_48996 = (0);
var inst_48997 = (0);
var state_49157__$1 = (function (){var statearr_49244 = state_49157;
(statearr_49244[(13)] = inst_48997);

(statearr_49244[(14)] = inst_48994);

(statearr_49244[(15)] = inst_48996);

(statearr_49244[(17)] = inst_48995);

return statearr_49244;
})();
var statearr_49245_50609 = state_49157__$1;
(statearr_49245_50609[(2)] = null);

(statearr_49245_50609[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (14))){
var state_49157__$1 = state_49157;
var statearr_49246_50610 = state_49157__$1;
(statearr_49246_50610[(2)] = null);

(statearr_49246_50610[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (45))){
var inst_49147 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49247_50611 = state_49157__$1;
(statearr_49247_50611[(2)] = inst_49147);

(statearr_49247_50611[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (26))){
var inst_49049 = (state_49157[(27)]);
var inst_49143 = (state_49157[(2)]);
var inst_49144 = cljs.core.seq(inst_49049);
var state_49157__$1 = (function (){var statearr_49248 = state_49157;
(statearr_49248[(29)] = inst_49143);

return statearr_49248;
})();
if(inst_49144){
var statearr_49249_50612 = state_49157__$1;
(statearr_49249_50612[(1)] = (42));

} else {
var statearr_49250_50613 = state_49157__$1;
(statearr_49250_50613[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (16))){
var inst_49016 = (state_49157[(7)]);
var inst_49018 = cljs.core.chunked_seq_QMARK_(inst_49016);
var state_49157__$1 = state_49157;
if(inst_49018){
var statearr_49251_50614 = state_49157__$1;
(statearr_49251_50614[(1)] = (19));

} else {
var statearr_49252_50615 = state_49157__$1;
(statearr_49252_50615[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (38))){
var inst_49133 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49253_50616 = state_49157__$1;
(statearr_49253_50616[(2)] = inst_49133);

(statearr_49253_50616[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (30))){
var state_49157__$1 = state_49157;
var statearr_49254_50617 = state_49157__$1;
(statearr_49254_50617[(2)] = null);

(statearr_49254_50617[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (10))){
var inst_48997 = (state_49157[(13)]);
var inst_48995 = (state_49157[(17)]);
var inst_49005 = cljs.core._nth(inst_48995,inst_48997);
var inst_49006 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49005,(0),null);
var inst_49007 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49005,(1),null);
var state_49157__$1 = (function (){var statearr_49255 = state_49157;
(statearr_49255[(24)] = inst_49006);

return statearr_49255;
})();
if(cljs.core.truth_(inst_49007)){
var statearr_49256_50618 = state_49157__$1;
(statearr_49256_50618[(1)] = (13));

} else {
var statearr_49257_50619 = state_49157__$1;
(statearr_49257_50619[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (18))){
var inst_49042 = (state_49157[(2)]);
var state_49157__$1 = state_49157;
var statearr_49258_50620 = state_49157__$1;
(statearr_49258_50620[(2)] = inst_49042);

(statearr_49258_50620[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (42))){
var state_49157__$1 = state_49157;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49157__$1,(45),dchan);
} else {
if((state_val_49158 === (37))){
var inst_48985 = (state_49157[(12)]);
var inst_49108 = (state_49157[(23)]);
var inst_49123 = (state_49157[(22)]);
var inst_49123__$1 = cljs.core.first(inst_49108);
var inst_49124 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_49123__$1,inst_48985,done);
var state_49157__$1 = (function (){var statearr_49259 = state_49157;
(statearr_49259[(22)] = inst_49123__$1);

return statearr_49259;
})();
if(cljs.core.truth_(inst_49124)){
var statearr_49260_50621 = state_49157__$1;
(statearr_49260_50621[(1)] = (39));

} else {
var statearr_49261_50622 = state_49157__$1;
(statearr_49261_50622[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49158 === (8))){
var inst_48997 = (state_49157[(13)]);
var inst_48996 = (state_49157[(15)]);
var inst_48999 = (inst_48997 < inst_48996);
var inst_49000 = inst_48999;
var state_49157__$1 = state_49157;
if(cljs.core.truth_(inst_49000)){
var statearr_49262_50623 = state_49157__$1;
(statearr_49262_50623[(1)] = (10));

} else {
var statearr_49263_50624 = state_49157__$1;
(statearr_49263_50624[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mult_$_state_machine__47852__auto__ = null;
var cljs$core$async$mult_$_state_machine__47852__auto____0 = (function (){
var statearr_49264 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_49264[(0)] = cljs$core$async$mult_$_state_machine__47852__auto__);

(statearr_49264[(1)] = (1));

return statearr_49264;
});
var cljs$core$async$mult_$_state_machine__47852__auto____1 = (function (state_49157){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49157);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49265){var ex__47855__auto__ = e49265;
var statearr_49266_50625 = state_49157;
(statearr_49266_50625[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49157[(4)]))){
var statearr_49267_50626 = state_49157;
(statearr_49267_50626[(1)] = cljs.core.first((state_49157[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50627 = state_49157;
state_49157 = G__50627;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__47852__auto__ = function(state_49157){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__47852__auto____1.call(this,state_49157);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__47852__auto____0;
cljs$core$async$mult_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__47852__auto____1;
return cljs$core$async$mult_$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49271 = f__47916__auto__();
(statearr_49271[(6)] = c__47915__auto___50545);

return statearr_49271;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__49273 = arguments.length;
switch (G__49273) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
}));

(cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
}));

(cljs.core.async.tap.cljs$lang$maxFixedArity = 3);

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

var cljs$core$async$Mix$admix_STAR_$dyn_50631 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.admix_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
});
cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$admix_STAR_$dyn_50631(m,ch);
}
});

var cljs$core$async$Mix$unmix_STAR_$dyn_50632 = (function (m,ch){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4522__auto__.call(null,m,ch));
} else {
var m__4519__auto__ = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4519__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
});
cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
return cljs$core$async$Mix$unmix_STAR_$dyn_50632(m,ch);
}
});

var cljs$core$async$Mix$unmix_all_STAR_$dyn_50633 = (function (m){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4522__auto__.call(null,m));
} else {
var m__4519__auto__ = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4519__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
});
cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
return cljs$core$async$Mix$unmix_all_STAR_$dyn_50633(m);
}
});

var cljs$core$async$Mix$toggle_STAR_$dyn_50634 = (function (m,state_map){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4522__auto__.call(null,m,state_map));
} else {
var m__4519__auto__ = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4519__auto__.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
});
cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
return cljs$core$async$Mix$toggle_STAR_$dyn_50634(m,state_map);
}
});

var cljs$core$async$Mix$solo_mode_STAR_$dyn_50635 = (function (m,mode){
var x__4521__auto__ = (((m == null))?null:m);
var m__4522__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4522__auto__.call(null,m,mode));
} else {
var m__4519__auto__ = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4519__auto__.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
});
cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
return cljs$core$async$Mix$solo_mode_STAR_$dyn_50635(m,mode);
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4835__auto__ = [];
var len__4829__auto___50636 = arguments.length;
var i__4830__auto___50637 = (0);
while(true){
if((i__4830__auto___50637 < len__4829__auto___50636)){
args__4835__auto__.push((arguments[i__4830__auto___50637]));

var G__50639 = (i__4830__auto___50637 + (1));
i__4830__auto___50637 = G__50639;
continue;
} else {
}
break;
}

var argseq__4836__auto__ = ((((3) < args__4835__auto__.length))?(new cljs.core.IndexedSeq(args__4835__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4836__auto__);
});

(cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__49278){
var map__49279 = p__49278;
var map__49279__$1 = cljs.core.__destructure_map(map__49279);
var opts = map__49279__$1;
var statearr_49280_50641 = state;
(statearr_49280_50641[(1)] = cont_block);


var temp__5753__auto__ = cljs.core.async.do_alts((function (val){
var statearr_49281_50642 = state;
(statearr_49281_50642[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
}),ports,opts);
if(cljs.core.truth_(temp__5753__auto__)){
var cb = temp__5753__auto__;
var statearr_49282_50643 = state;
(statearr_49282_50643[(2)] = cljs.core.deref(cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}));

(cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3));

/** @this {Function} */
(cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq49274){
var G__49275 = cljs.core.first(seq49274);
var seq49274__$1 = cljs.core.next(seq49274);
var G__49276 = cljs.core.first(seq49274__$1);
var seq49274__$2 = cljs.core.next(seq49274__$1);
var G__49277 = cljs.core.first(seq49274__$2);
var seq49274__$3 = cljs.core.next(seq49274__$2);
var self__4816__auto__ = this;
return self__4816__auto__.cljs$core$IFn$_invoke$arity$variadic(G__49275,G__49276,G__49277,seq49274__$3);
}));

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.async.sliding_buffer((1)));
var changed = (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});
var pick = (function (attr,chs){
return cljs.core.reduce_kv((function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
}),cljs.core.PersistentHashSet.EMPTY,chs);
});
var calc_state = (function (){
var chs = cljs.core.deref(cs);
var mode = cljs.core.deref(solo_mode);
var solos = pick(new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick(new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick(new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.cljs$core$IFn$_invoke$arity$2(((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && ((!(cljs.core.empty_QMARK_(solos))))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49292 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49292 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta49293){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta49293 = meta49293;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49294,meta49293__$1){
var self__ = this;
var _49294__$1 = this;
return (new cljs.core.async.t_cljs$core$async49292(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta49293__$1));
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49294){
var self__ = this;
var _49294__$1 = this;
return self__.meta49293;
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async49292.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error(["Assert failed: ",["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join(''),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_(self__.solo_mode,mode);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
}));

(cljs.core.async.t_cljs$core$async49292.getBasis = (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta49293","meta49293",1109989784,null)], null);
}));

(cljs.core.async.t_cljs$core$async49292.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49292.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49292");

(cljs.core.async.t_cljs$core$async49292.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49292");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49292.
 */
cljs.core.async.__GT_t_cljs$core$async49292 = (function cljs$core$async$mix_$___GT_t_cljs$core$async49292(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta49293){
return (new cljs.core.async.t_cljs$core$async49292(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta49293));
});

}

return (new cljs.core.async.t_cljs$core$async49292(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__47915__auto___50648 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49362){
var state_val_49363 = (state_49362[(1)]);
if((state_val_49363 === (7))){
var inst_49322 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
if(cljs.core.truth_(inst_49322)){
var statearr_49364_50649 = state_49362__$1;
(statearr_49364_50649[(1)] = (8));

} else {
var statearr_49365_50650 = state_49362__$1;
(statearr_49365_50650[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (20))){
var inst_49315 = (state_49362[(7)]);
var state_49362__$1 = state_49362;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49362__$1,(23),out,inst_49315);
} else {
if((state_val_49363 === (1))){
var inst_49298 = calc_state();
var inst_49299 = cljs.core.__destructure_map(inst_49298);
var inst_49300 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49299,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_49301 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49299,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_49302 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49299,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_49303 = inst_49298;
var state_49362__$1 = (function (){var statearr_49372 = state_49362;
(statearr_49372[(8)] = inst_49301);

(statearr_49372[(9)] = inst_49302);

(statearr_49372[(10)] = inst_49300);

(statearr_49372[(11)] = inst_49303);

return statearr_49372;
})();
var statearr_49373_50651 = state_49362__$1;
(statearr_49373_50651[(2)] = null);

(statearr_49373_50651[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (24))){
var inst_49306 = (state_49362[(12)]);
var inst_49303 = inst_49306;
var state_49362__$1 = (function (){var statearr_49374 = state_49362;
(statearr_49374[(11)] = inst_49303);

return statearr_49374;
})();
var statearr_49375_50652 = state_49362__$1;
(statearr_49375_50652[(2)] = null);

(statearr_49375_50652[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (4))){
var inst_49315 = (state_49362[(7)]);
var inst_49317 = (state_49362[(13)]);
var inst_49314 = (state_49362[(2)]);
var inst_49315__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49314,(0),null);
var inst_49316 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49314,(1),null);
var inst_49317__$1 = (inst_49315__$1 == null);
var state_49362__$1 = (function (){var statearr_49376 = state_49362;
(statearr_49376[(7)] = inst_49315__$1);

(statearr_49376[(14)] = inst_49316);

(statearr_49376[(13)] = inst_49317__$1);

return statearr_49376;
})();
if(cljs.core.truth_(inst_49317__$1)){
var statearr_49377_50655 = state_49362__$1;
(statearr_49377_50655[(1)] = (5));

} else {
var statearr_49378_50656 = state_49362__$1;
(statearr_49378_50656[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (15))){
var inst_49307 = (state_49362[(15)]);
var inst_49336 = (state_49362[(16)]);
var inst_49336__$1 = cljs.core.empty_QMARK_(inst_49307);
var state_49362__$1 = (function (){var statearr_49380 = state_49362;
(statearr_49380[(16)] = inst_49336__$1);

return statearr_49380;
})();
if(inst_49336__$1){
var statearr_49384_50657 = state_49362__$1;
(statearr_49384_50657[(1)] = (17));

} else {
var statearr_49385_50658 = state_49362__$1;
(statearr_49385_50658[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (21))){
var inst_49306 = (state_49362[(12)]);
var inst_49303 = inst_49306;
var state_49362__$1 = (function (){var statearr_49386 = state_49362;
(statearr_49386[(11)] = inst_49303);

return statearr_49386;
})();
var statearr_49387_50659 = state_49362__$1;
(statearr_49387_50659[(2)] = null);

(statearr_49387_50659[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (13))){
var inst_49329 = (state_49362[(2)]);
var inst_49330 = calc_state();
var inst_49303 = inst_49330;
var state_49362__$1 = (function (){var statearr_49388 = state_49362;
(statearr_49388[(17)] = inst_49329);

(statearr_49388[(11)] = inst_49303);

return statearr_49388;
})();
var statearr_49389_50660 = state_49362__$1;
(statearr_49389_50660[(2)] = null);

(statearr_49389_50660[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (22))){
var inst_49356 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
var statearr_49390_50661 = state_49362__$1;
(statearr_49390_50661[(2)] = inst_49356);

(statearr_49390_50661[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (6))){
var inst_49316 = (state_49362[(14)]);
var inst_49320 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_49316,change);
var state_49362__$1 = state_49362;
var statearr_49391_50662 = state_49362__$1;
(statearr_49391_50662[(2)] = inst_49320);

(statearr_49391_50662[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (25))){
var state_49362__$1 = state_49362;
var statearr_49396_50663 = state_49362__$1;
(statearr_49396_50663[(2)] = null);

(statearr_49396_50663[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (17))){
var inst_49316 = (state_49362[(14)]);
var inst_49308 = (state_49362[(18)]);
var inst_49338 = (inst_49308.cljs$core$IFn$_invoke$arity$1 ? inst_49308.cljs$core$IFn$_invoke$arity$1(inst_49316) : inst_49308.call(null,inst_49316));
var inst_49339 = cljs.core.not(inst_49338);
var state_49362__$1 = state_49362;
var statearr_49397_50664 = state_49362__$1;
(statearr_49397_50664[(2)] = inst_49339);

(statearr_49397_50664[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (3))){
var inst_49360 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49362__$1,inst_49360);
} else {
if((state_val_49363 === (12))){
var state_49362__$1 = state_49362;
var statearr_49398_50665 = state_49362__$1;
(statearr_49398_50665[(2)] = null);

(statearr_49398_50665[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (2))){
var inst_49306 = (state_49362[(12)]);
var inst_49303 = (state_49362[(11)]);
var inst_49306__$1 = cljs.core.__destructure_map(inst_49303);
var inst_49307 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49306__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_49308 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49306__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_49309 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49306__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_49362__$1 = (function (){var statearr_49399 = state_49362;
(statearr_49399[(12)] = inst_49306__$1);

(statearr_49399[(15)] = inst_49307);

(statearr_49399[(18)] = inst_49308);

return statearr_49399;
})();
return cljs.core.async.ioc_alts_BANG_(state_49362__$1,(4),inst_49309);
} else {
if((state_val_49363 === (23))){
var inst_49347 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
if(cljs.core.truth_(inst_49347)){
var statearr_49400_50666 = state_49362__$1;
(statearr_49400_50666[(1)] = (24));

} else {
var statearr_49401_50667 = state_49362__$1;
(statearr_49401_50667[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (19))){
var inst_49342 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
var statearr_49402_50668 = state_49362__$1;
(statearr_49402_50668[(2)] = inst_49342);

(statearr_49402_50668[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (11))){
var inst_49316 = (state_49362[(14)]);
var inst_49326 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_49316);
var state_49362__$1 = state_49362;
var statearr_49404_50669 = state_49362__$1;
(statearr_49404_50669[(2)] = inst_49326);

(statearr_49404_50669[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (9))){
var inst_49333 = (state_49362[(19)]);
var inst_49316 = (state_49362[(14)]);
var inst_49307 = (state_49362[(15)]);
var inst_49333__$1 = (inst_49307.cljs$core$IFn$_invoke$arity$1 ? inst_49307.cljs$core$IFn$_invoke$arity$1(inst_49316) : inst_49307.call(null,inst_49316));
var state_49362__$1 = (function (){var statearr_49408 = state_49362;
(statearr_49408[(19)] = inst_49333__$1);

return statearr_49408;
})();
if(cljs.core.truth_(inst_49333__$1)){
var statearr_49409_50671 = state_49362__$1;
(statearr_49409_50671[(1)] = (14));

} else {
var statearr_49410_50672 = state_49362__$1;
(statearr_49410_50672[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (5))){
var inst_49317 = (state_49362[(13)]);
var state_49362__$1 = state_49362;
var statearr_49411_50673 = state_49362__$1;
(statearr_49411_50673[(2)] = inst_49317);

(statearr_49411_50673[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (14))){
var inst_49333 = (state_49362[(19)]);
var state_49362__$1 = state_49362;
var statearr_49412_50674 = state_49362__$1;
(statearr_49412_50674[(2)] = inst_49333);

(statearr_49412_50674[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (26))){
var inst_49352 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
var statearr_49447_50675 = state_49362__$1;
(statearr_49447_50675[(2)] = inst_49352);

(statearr_49447_50675[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (16))){
var inst_49344 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
if(cljs.core.truth_(inst_49344)){
var statearr_49448_50676 = state_49362__$1;
(statearr_49448_50676[(1)] = (20));

} else {
var statearr_49449_50677 = state_49362__$1;
(statearr_49449_50677[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (10))){
var inst_49358 = (state_49362[(2)]);
var state_49362__$1 = state_49362;
var statearr_49450_50678 = state_49362__$1;
(statearr_49450_50678[(2)] = inst_49358);

(statearr_49450_50678[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (18))){
var inst_49336 = (state_49362[(16)]);
var state_49362__$1 = state_49362;
var statearr_49451_50679 = state_49362__$1;
(statearr_49451_50679[(2)] = inst_49336);

(statearr_49451_50679[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49363 === (8))){
var inst_49315 = (state_49362[(7)]);
var inst_49324 = (inst_49315 == null);
var state_49362__$1 = state_49362;
if(cljs.core.truth_(inst_49324)){
var statearr_49452_50680 = state_49362__$1;
(statearr_49452_50680[(1)] = (11));

} else {
var statearr_49453_50681 = state_49362__$1;
(statearr_49453_50681[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mix_$_state_machine__47852__auto__ = null;
var cljs$core$async$mix_$_state_machine__47852__auto____0 = (function (){
var statearr_49454 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_49454[(0)] = cljs$core$async$mix_$_state_machine__47852__auto__);

(statearr_49454[(1)] = (1));

return statearr_49454;
});
var cljs$core$async$mix_$_state_machine__47852__auto____1 = (function (state_49362){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49362);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49455){var ex__47855__auto__ = e49455;
var statearr_49456_50682 = state_49362;
(statearr_49456_50682[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49362[(4)]))){
var statearr_49457_50683 = state_49362;
(statearr_49457_50683[(1)] = cljs.core.first((state_49362[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50684 = state_49362;
state_49362 = G__50684;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__47852__auto__ = function(state_49362){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__47852__auto____1.call(this,state_49362);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__47852__auto____0;
cljs$core$async$mix_$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__47852__auto____1;
return cljs$core$async$mix_$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49458 = f__47916__auto__();
(statearr_49458[(6)] = c__47915__auto___50648);

return statearr_49458;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

var cljs$core$async$Pub$sub_STAR_$dyn_50685 = (function (p,v,ch,close_QMARK_){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4522__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__4519__auto__ = (cljs.core.async.sub_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4519__auto__.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
});
cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
return cljs$core$async$Pub$sub_STAR_$dyn_50685(p,v,ch,close_QMARK_);
}
});

var cljs$core$async$Pub$unsub_STAR_$dyn_50686 = (function (p,v,ch){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4522__auto__.call(null,p,v,ch));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4519__auto__.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
});
cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
return cljs$core$async$Pub$unsub_STAR_$dyn_50686(p,v,ch);
}
});

var cljs$core$async$Pub$unsub_all_STAR_$dyn_50687 = (function() {
var G__50688 = null;
var G__50688__1 = (function (p){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4522__auto__.call(null,p));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4519__auto__.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
var G__50688__2 = (function (p,v){
var x__4521__auto__ = (((p == null))?null:p);
var m__4522__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4521__auto__)]);
if((!((m__4522__auto__ == null)))){
return (m__4522__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4522__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4522__auto__.call(null,p,v));
} else {
var m__4519__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4519__auto__ == null)))){
return (m__4519__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4519__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4519__auto__.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
});
G__50688 = function(p,v){
switch(arguments.length){
case 1:
return G__50688__1.call(this,p);
case 2:
return G__50688__2.call(this,p,v);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__50688.cljs$core$IFn$_invoke$arity$1 = G__50688__1;
G__50688.cljs$core$IFn$_invoke$arity$2 = G__50688__2;
return G__50688;
})()
;
cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__49473 = arguments.length;
switch (G__49473) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_50687(p);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
return cljs$core$async$Pub$unsub_all_STAR_$dyn_50687(p,v);
}
}));

(cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2);


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__49482 = arguments.length;
switch (G__49482) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
}));

(cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = (function (topic){
var or__4223__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(mults),topic);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,(function (p1__49476_SHARP_){
if(cljs.core.truth_((p1__49476_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__49476_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__49476_SHARP_.call(null,topic)))){
return p1__49476_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__49476_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
})),topic);
}
});
var p = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49485 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49485 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta49486){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta49486 = meta49486;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49487,meta49486__$1){
var self__ = this;
var _49487__$1 = this;
return (new cljs.core.async.t_cljs$core$async49485(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta49486__$1));
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49487){
var self__ = this;
var _49487__$1 = this;
return self__.meta49486;
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5753__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self__.mults),topic);
if(cljs.core.truth_(temp__5753__auto__)){
var m = temp__5753__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_(self__.mults,cljs.core.PersistentArrayMap.EMPTY);
}));

(cljs.core.async.t_cljs$core$async49485.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
}));

(cljs.core.async.t_cljs$core$async49485.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta49486","meta49486",1055703296,null)], null);
}));

(cljs.core.async.t_cljs$core$async49485.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49485.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49485");

(cljs.core.async.t_cljs$core$async49485.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49485");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49485.
 */
cljs.core.async.__GT_t_cljs$core$async49485 = (function cljs$core$async$__GT_t_cljs$core$async49485(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta49486){
return (new cljs.core.async.t_cljs$core$async49485(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta49486));
});

}

return (new cljs.core.async.t_cljs$core$async49485(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__47915__auto___50691 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49568){
var state_val_49569 = (state_49568[(1)]);
if((state_val_49569 === (7))){
var inst_49563 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49570_50692 = state_49568__$1;
(statearr_49570_50692[(2)] = inst_49563);

(statearr_49570_50692[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (20))){
var state_49568__$1 = state_49568;
var statearr_49571_50693 = state_49568__$1;
(statearr_49571_50693[(2)] = null);

(statearr_49571_50693[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (1))){
var state_49568__$1 = state_49568;
var statearr_49576_50694 = state_49568__$1;
(statearr_49576_50694[(2)] = null);

(statearr_49576_50694[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (24))){
var inst_49546 = (state_49568[(7)]);
var inst_49555 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_49546);
var state_49568__$1 = state_49568;
var statearr_49578_50695 = state_49568__$1;
(statearr_49578_50695[(2)] = inst_49555);

(statearr_49578_50695[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (4))){
var inst_49498 = (state_49568[(8)]);
var inst_49498__$1 = (state_49568[(2)]);
var inst_49499 = (inst_49498__$1 == null);
var state_49568__$1 = (function (){var statearr_49579 = state_49568;
(statearr_49579[(8)] = inst_49498__$1);

return statearr_49579;
})();
if(cljs.core.truth_(inst_49499)){
var statearr_49580_50696 = state_49568__$1;
(statearr_49580_50696[(1)] = (5));

} else {
var statearr_49581_50697 = state_49568__$1;
(statearr_49581_50697[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (15))){
var inst_49540 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49582_50698 = state_49568__$1;
(statearr_49582_50698[(2)] = inst_49540);

(statearr_49582_50698[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (21))){
var inst_49560 = (state_49568[(2)]);
var state_49568__$1 = (function (){var statearr_49583 = state_49568;
(statearr_49583[(9)] = inst_49560);

return statearr_49583;
})();
var statearr_49584_50699 = state_49568__$1;
(statearr_49584_50699[(2)] = null);

(statearr_49584_50699[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (13))){
var inst_49522 = (state_49568[(10)]);
var inst_49524 = cljs.core.chunked_seq_QMARK_(inst_49522);
var state_49568__$1 = state_49568;
if(inst_49524){
var statearr_49585_50700 = state_49568__$1;
(statearr_49585_50700[(1)] = (16));

} else {
var statearr_49586_50701 = state_49568__$1;
(statearr_49586_50701[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (22))){
var inst_49552 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
if(cljs.core.truth_(inst_49552)){
var statearr_49587_50702 = state_49568__$1;
(statearr_49587_50702[(1)] = (23));

} else {
var statearr_49588_50703 = state_49568__$1;
(statearr_49588_50703[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (6))){
var inst_49498 = (state_49568[(8)]);
var inst_49548 = (state_49568[(11)]);
var inst_49546 = (state_49568[(7)]);
var inst_49546__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_49498) : topic_fn.call(null,inst_49498));
var inst_49547 = cljs.core.deref(mults);
var inst_49548__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_49547,inst_49546__$1);
var state_49568__$1 = (function (){var statearr_49593 = state_49568;
(statearr_49593[(11)] = inst_49548__$1);

(statearr_49593[(7)] = inst_49546__$1);

return statearr_49593;
})();
if(cljs.core.truth_(inst_49548__$1)){
var statearr_49594_50704 = state_49568__$1;
(statearr_49594_50704[(1)] = (19));

} else {
var statearr_49595_50705 = state_49568__$1;
(statearr_49595_50705[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (25))){
var inst_49557 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49596_50706 = state_49568__$1;
(statearr_49596_50706[(2)] = inst_49557);

(statearr_49596_50706[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (17))){
var inst_49522 = (state_49568[(10)]);
var inst_49531 = cljs.core.first(inst_49522);
var inst_49532 = cljs.core.async.muxch_STAR_(inst_49531);
var inst_49533 = cljs.core.async.close_BANG_(inst_49532);
var inst_49534 = cljs.core.next(inst_49522);
var inst_49508 = inst_49534;
var inst_49509 = null;
var inst_49510 = (0);
var inst_49511 = (0);
var state_49568__$1 = (function (){var statearr_49598 = state_49568;
(statearr_49598[(12)] = inst_49510);

(statearr_49598[(13)] = inst_49508);

(statearr_49598[(14)] = inst_49509);

(statearr_49598[(15)] = inst_49511);

(statearr_49598[(16)] = inst_49533);

return statearr_49598;
})();
var statearr_49602_50707 = state_49568__$1;
(statearr_49602_50707[(2)] = null);

(statearr_49602_50707[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (3))){
var inst_49565 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49568__$1,inst_49565);
} else {
if((state_val_49569 === (12))){
var inst_49542 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49603_50708 = state_49568__$1;
(statearr_49603_50708[(2)] = inst_49542);

(statearr_49603_50708[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (2))){
var state_49568__$1 = state_49568;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49568__$1,(4),ch);
} else {
if((state_val_49569 === (23))){
var state_49568__$1 = state_49568;
var statearr_49604_50709 = state_49568__$1;
(statearr_49604_50709[(2)] = null);

(statearr_49604_50709[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (19))){
var inst_49498 = (state_49568[(8)]);
var inst_49548 = (state_49568[(11)]);
var inst_49550 = cljs.core.async.muxch_STAR_(inst_49548);
var state_49568__$1 = state_49568;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49568__$1,(22),inst_49550,inst_49498);
} else {
if((state_val_49569 === (11))){
var inst_49508 = (state_49568[(13)]);
var inst_49522 = (state_49568[(10)]);
var inst_49522__$1 = cljs.core.seq(inst_49508);
var state_49568__$1 = (function (){var statearr_49605 = state_49568;
(statearr_49605[(10)] = inst_49522__$1);

return statearr_49605;
})();
if(inst_49522__$1){
var statearr_49606_50710 = state_49568__$1;
(statearr_49606_50710[(1)] = (13));

} else {
var statearr_49607_50711 = state_49568__$1;
(statearr_49607_50711[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (9))){
var inst_49544 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49608_50712 = state_49568__$1;
(statearr_49608_50712[(2)] = inst_49544);

(statearr_49608_50712[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (5))){
var inst_49505 = cljs.core.deref(mults);
var inst_49506 = cljs.core.vals(inst_49505);
var inst_49507 = cljs.core.seq(inst_49506);
var inst_49508 = inst_49507;
var inst_49509 = null;
var inst_49510 = (0);
var inst_49511 = (0);
var state_49568__$1 = (function (){var statearr_49609 = state_49568;
(statearr_49609[(12)] = inst_49510);

(statearr_49609[(13)] = inst_49508);

(statearr_49609[(14)] = inst_49509);

(statearr_49609[(15)] = inst_49511);

return statearr_49609;
})();
var statearr_49610_50713 = state_49568__$1;
(statearr_49610_50713[(2)] = null);

(statearr_49610_50713[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (14))){
var state_49568__$1 = state_49568;
var statearr_49614_50714 = state_49568__$1;
(statearr_49614_50714[(2)] = null);

(statearr_49614_50714[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (16))){
var inst_49522 = (state_49568[(10)]);
var inst_49526 = cljs.core.chunk_first(inst_49522);
var inst_49527 = cljs.core.chunk_rest(inst_49522);
var inst_49528 = cljs.core.count(inst_49526);
var inst_49508 = inst_49527;
var inst_49509 = inst_49526;
var inst_49510 = inst_49528;
var inst_49511 = (0);
var state_49568__$1 = (function (){var statearr_49615 = state_49568;
(statearr_49615[(12)] = inst_49510);

(statearr_49615[(13)] = inst_49508);

(statearr_49615[(14)] = inst_49509);

(statearr_49615[(15)] = inst_49511);

return statearr_49615;
})();
var statearr_49616_50715 = state_49568__$1;
(statearr_49616_50715[(2)] = null);

(statearr_49616_50715[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (10))){
var inst_49510 = (state_49568[(12)]);
var inst_49508 = (state_49568[(13)]);
var inst_49509 = (state_49568[(14)]);
var inst_49511 = (state_49568[(15)]);
var inst_49516 = cljs.core._nth(inst_49509,inst_49511);
var inst_49517 = cljs.core.async.muxch_STAR_(inst_49516);
var inst_49518 = cljs.core.async.close_BANG_(inst_49517);
var inst_49519 = (inst_49511 + (1));
var tmp49611 = inst_49510;
var tmp49612 = inst_49508;
var tmp49613 = inst_49509;
var inst_49508__$1 = tmp49612;
var inst_49509__$1 = tmp49613;
var inst_49510__$1 = tmp49611;
var inst_49511__$1 = inst_49519;
var state_49568__$1 = (function (){var statearr_49617 = state_49568;
(statearr_49617[(12)] = inst_49510__$1);

(statearr_49617[(13)] = inst_49508__$1);

(statearr_49617[(14)] = inst_49509__$1);

(statearr_49617[(15)] = inst_49511__$1);

(statearr_49617[(17)] = inst_49518);

return statearr_49617;
})();
var statearr_49618_50716 = state_49568__$1;
(statearr_49618_50716[(2)] = null);

(statearr_49618_50716[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (18))){
var inst_49537 = (state_49568[(2)]);
var state_49568__$1 = state_49568;
var statearr_49619_50717 = state_49568__$1;
(statearr_49619_50717[(2)] = inst_49537);

(statearr_49619_50717[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49569 === (8))){
var inst_49510 = (state_49568[(12)]);
var inst_49511 = (state_49568[(15)]);
var inst_49513 = (inst_49511 < inst_49510);
var inst_49514 = inst_49513;
var state_49568__$1 = state_49568;
if(cljs.core.truth_(inst_49514)){
var statearr_49620_50718 = state_49568__$1;
(statearr_49620_50718[(1)] = (10));

} else {
var statearr_49621_50719 = state_49568__$1;
(statearr_49621_50719[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_49622 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_49622[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_49622[(1)] = (1));

return statearr_49622;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_49568){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49568);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49623){var ex__47855__auto__ = e49623;
var statearr_49624_50720 = state_49568;
(statearr_49624_50720[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49568[(4)]))){
var statearr_49625_50721 = state_49568;
(statearr_49625_50721[(1)] = cljs.core.first((state_49568[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50722 = state_49568;
state_49568 = G__50722;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_49568){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_49568);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49626 = f__47916__auto__();
(statearr_49626[(6)] = c__47915__auto___50691);

return statearr_49626;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return p;
}));

(cljs.core.async.pub.cljs$lang$maxFixedArity = 3);

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__49628 = arguments.length;
switch (G__49628) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
}));

(cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
}));

(cljs.core.async.sub.cljs$lang$maxFixedArity = 4);

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__49636 = arguments.length;
switch (G__49636) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_(p);
}));

(cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_(p,topic);
}));

(cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2);

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__49642 = arguments.length;
switch (G__49642) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
}));

(cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (i){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
}),cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__47915__auto___50726 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49685){
var state_val_49686 = (state_49685[(1)]);
if((state_val_49686 === (7))){
var state_49685__$1 = state_49685;
var statearr_49687_50727 = state_49685__$1;
(statearr_49687_50727[(2)] = null);

(statearr_49687_50727[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (1))){
var state_49685__$1 = state_49685;
var statearr_49688_50728 = state_49685__$1;
(statearr_49688_50728[(2)] = null);

(statearr_49688_50728[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (4))){
var inst_49645 = (state_49685[(7)]);
var inst_49646 = (state_49685[(8)]);
var inst_49648 = (inst_49646 < inst_49645);
var state_49685__$1 = state_49685;
if(cljs.core.truth_(inst_49648)){
var statearr_49689_50729 = state_49685__$1;
(statearr_49689_50729[(1)] = (6));

} else {
var statearr_49690_50730 = state_49685__$1;
(statearr_49690_50730[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (15))){
var inst_49671 = (state_49685[(9)]);
var inst_49676 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_49671);
var state_49685__$1 = state_49685;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49685__$1,(17),out,inst_49676);
} else {
if((state_val_49686 === (13))){
var inst_49671 = (state_49685[(9)]);
var inst_49671__$1 = (state_49685[(2)]);
var inst_49672 = cljs.core.some(cljs.core.nil_QMARK_,inst_49671__$1);
var state_49685__$1 = (function (){var statearr_49691 = state_49685;
(statearr_49691[(9)] = inst_49671__$1);

return statearr_49691;
})();
if(cljs.core.truth_(inst_49672)){
var statearr_49692_50731 = state_49685__$1;
(statearr_49692_50731[(1)] = (14));

} else {
var statearr_49693_50732 = state_49685__$1;
(statearr_49693_50732[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (6))){
var state_49685__$1 = state_49685;
var statearr_49694_50733 = state_49685__$1;
(statearr_49694_50733[(2)] = null);

(statearr_49694_50733[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (17))){
var inst_49678 = (state_49685[(2)]);
var state_49685__$1 = (function (){var statearr_49696 = state_49685;
(statearr_49696[(10)] = inst_49678);

return statearr_49696;
})();
var statearr_49697_50734 = state_49685__$1;
(statearr_49697_50734[(2)] = null);

(statearr_49697_50734[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (3))){
var inst_49683 = (state_49685[(2)]);
var state_49685__$1 = state_49685;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49685__$1,inst_49683);
} else {
if((state_val_49686 === (12))){
var _ = (function (){var statearr_49698 = state_49685;
(statearr_49698[(4)] = cljs.core.rest((state_49685[(4)])));

return statearr_49698;
})();
var state_49685__$1 = state_49685;
var ex49695 = (state_49685__$1[(2)]);
var statearr_49699_50735 = state_49685__$1;
(statearr_49699_50735[(5)] = ex49695);


if((ex49695 instanceof Object)){
var statearr_49700_50736 = state_49685__$1;
(statearr_49700_50736[(1)] = (11));

(statearr_49700_50736[(5)] = null);

} else {
throw ex49695;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (2))){
var inst_49644 = cljs.core.reset_BANG_(dctr,cnt);
var inst_49645 = cnt;
var inst_49646 = (0);
var state_49685__$1 = (function (){var statearr_49701 = state_49685;
(statearr_49701[(7)] = inst_49645);

(statearr_49701[(11)] = inst_49644);

(statearr_49701[(8)] = inst_49646);

return statearr_49701;
})();
var statearr_49702_50737 = state_49685__$1;
(statearr_49702_50737[(2)] = null);

(statearr_49702_50737[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (11))){
var inst_49650 = (state_49685[(2)]);
var inst_49651 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_49685__$1 = (function (){var statearr_49703 = state_49685;
(statearr_49703[(12)] = inst_49650);

return statearr_49703;
})();
var statearr_49704_50738 = state_49685__$1;
(statearr_49704_50738[(2)] = inst_49651);

(statearr_49704_50738[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (9))){
var inst_49646 = (state_49685[(8)]);
var _ = (function (){var statearr_49705 = state_49685;
(statearr_49705[(4)] = cljs.core.cons((12),(state_49685[(4)])));

return statearr_49705;
})();
var inst_49657 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_49646) : chs__$1.call(null,inst_49646));
var inst_49658 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_49646) : done.call(null,inst_49646));
var inst_49659 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_49657,inst_49658);
var ___$1 = (function (){var statearr_49706 = state_49685;
(statearr_49706[(4)] = cljs.core.rest((state_49685[(4)])));

return statearr_49706;
})();
var state_49685__$1 = state_49685;
var statearr_49707_50739 = state_49685__$1;
(statearr_49707_50739[(2)] = inst_49659);

(statearr_49707_50739[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (5))){
var inst_49669 = (state_49685[(2)]);
var state_49685__$1 = (function (){var statearr_49708 = state_49685;
(statearr_49708[(13)] = inst_49669);

return statearr_49708;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49685__$1,(13),dchan);
} else {
if((state_val_49686 === (14))){
var inst_49674 = cljs.core.async.close_BANG_(out);
var state_49685__$1 = state_49685;
var statearr_49709_50740 = state_49685__$1;
(statearr_49709_50740[(2)] = inst_49674);

(statearr_49709_50740[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (16))){
var inst_49681 = (state_49685[(2)]);
var state_49685__$1 = state_49685;
var statearr_49710_50741 = state_49685__$1;
(statearr_49710_50741[(2)] = inst_49681);

(statearr_49710_50741[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (10))){
var inst_49646 = (state_49685[(8)]);
var inst_49662 = (state_49685[(2)]);
var inst_49663 = (inst_49646 + (1));
var inst_49646__$1 = inst_49663;
var state_49685__$1 = (function (){var statearr_49711 = state_49685;
(statearr_49711[(8)] = inst_49646__$1);

(statearr_49711[(14)] = inst_49662);

return statearr_49711;
})();
var statearr_49712_50742 = state_49685__$1;
(statearr_49712_50742[(2)] = null);

(statearr_49712_50742[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49686 === (8))){
var inst_49667 = (state_49685[(2)]);
var state_49685__$1 = state_49685;
var statearr_49713_50743 = state_49685__$1;
(statearr_49713_50743[(2)] = inst_49667);

(statearr_49713_50743[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_49714 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_49714[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_49714[(1)] = (1));

return statearr_49714;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_49685){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49685);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49715){var ex__47855__auto__ = e49715;
var statearr_49716_50744 = state_49685;
(statearr_49716_50744[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49685[(4)]))){
var statearr_49721_50745 = state_49685;
(statearr_49721_50745[(1)] = cljs.core.first((state_49685[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50746 = state_49685;
state_49685 = G__50746;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_49685){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_49685);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49723 = f__47916__auto__();
(statearr_49723[(6)] = c__47915__auto___50726);

return statearr_49723;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.map.cljs$lang$maxFixedArity = 3);

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__49726 = arguments.length;
switch (G__49726) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
}));

(cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50748 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49759){
var state_val_49760 = (state_49759[(1)]);
if((state_val_49760 === (7))){
var inst_49739 = (state_49759[(7)]);
var inst_49738 = (state_49759[(8)]);
var inst_49738__$1 = (state_49759[(2)]);
var inst_49739__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49738__$1,(0),null);
var inst_49740 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_49738__$1,(1),null);
var inst_49741 = (inst_49739__$1 == null);
var state_49759__$1 = (function (){var statearr_49768 = state_49759;
(statearr_49768[(7)] = inst_49739__$1);

(statearr_49768[(9)] = inst_49740);

(statearr_49768[(8)] = inst_49738__$1);

return statearr_49768;
})();
if(cljs.core.truth_(inst_49741)){
var statearr_49769_50749 = state_49759__$1;
(statearr_49769_50749[(1)] = (8));

} else {
var statearr_49774_50750 = state_49759__$1;
(statearr_49774_50750[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (1))){
var inst_49728 = cljs.core.vec(chs);
var inst_49729 = inst_49728;
var state_49759__$1 = (function (){var statearr_49775 = state_49759;
(statearr_49775[(10)] = inst_49729);

return statearr_49775;
})();
var statearr_49776_50751 = state_49759__$1;
(statearr_49776_50751[(2)] = null);

(statearr_49776_50751[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (4))){
var inst_49729 = (state_49759[(10)]);
var state_49759__$1 = state_49759;
return cljs.core.async.ioc_alts_BANG_(state_49759__$1,(7),inst_49729);
} else {
if((state_val_49760 === (6))){
var inst_49755 = (state_49759[(2)]);
var state_49759__$1 = state_49759;
var statearr_49777_50752 = state_49759__$1;
(statearr_49777_50752[(2)] = inst_49755);

(statearr_49777_50752[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (3))){
var inst_49757 = (state_49759[(2)]);
var state_49759__$1 = state_49759;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49759__$1,inst_49757);
} else {
if((state_val_49760 === (2))){
var inst_49729 = (state_49759[(10)]);
var inst_49731 = cljs.core.count(inst_49729);
var inst_49732 = (inst_49731 > (0));
var state_49759__$1 = state_49759;
if(cljs.core.truth_(inst_49732)){
var statearr_49779_50753 = state_49759__$1;
(statearr_49779_50753[(1)] = (4));

} else {
var statearr_49780_50754 = state_49759__$1;
(statearr_49780_50754[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (11))){
var inst_49729 = (state_49759[(10)]);
var inst_49748 = (state_49759[(2)]);
var tmp49778 = inst_49729;
var inst_49729__$1 = tmp49778;
var state_49759__$1 = (function (){var statearr_49781 = state_49759;
(statearr_49781[(11)] = inst_49748);

(statearr_49781[(10)] = inst_49729__$1);

return statearr_49781;
})();
var statearr_49782_50755 = state_49759__$1;
(statearr_49782_50755[(2)] = null);

(statearr_49782_50755[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (9))){
var inst_49739 = (state_49759[(7)]);
var state_49759__$1 = state_49759;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49759__$1,(11),out,inst_49739);
} else {
if((state_val_49760 === (5))){
var inst_49753 = cljs.core.async.close_BANG_(out);
var state_49759__$1 = state_49759;
var statearr_49790_50756 = state_49759__$1;
(statearr_49790_50756[(2)] = inst_49753);

(statearr_49790_50756[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (10))){
var inst_49751 = (state_49759[(2)]);
var state_49759__$1 = state_49759;
var statearr_49794_50757 = state_49759__$1;
(statearr_49794_50757[(2)] = inst_49751);

(statearr_49794_50757[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49760 === (8))){
var inst_49739 = (state_49759[(7)]);
var inst_49740 = (state_49759[(9)]);
var inst_49738 = (state_49759[(8)]);
var inst_49729 = (state_49759[(10)]);
var inst_49743 = (function (){var cs = inst_49729;
var vec__49734 = inst_49738;
var v = inst_49739;
var c = inst_49740;
return (function (p1__49724_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__49724_SHARP_);
});
})();
var inst_49744 = cljs.core.filterv(inst_49743,inst_49729);
var inst_49729__$1 = inst_49744;
var state_49759__$1 = (function (){var statearr_49795 = state_49759;
(statearr_49795[(10)] = inst_49729__$1);

return statearr_49795;
})();
var statearr_49796_50758 = state_49759__$1;
(statearr_49796_50758[(2)] = null);

(statearr_49796_50758[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_49797 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_49797[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_49797[(1)] = (1));

return statearr_49797;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_49759){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49759);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49798){var ex__47855__auto__ = e49798;
var statearr_49799_50759 = state_49759;
(statearr_49799_50759[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49759[(4)]))){
var statearr_49800_50760 = state_49759;
(statearr_49800_50760[(1)] = cljs.core.first((state_49759[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50761 = state_49759;
state_49759 = G__50761;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_49759){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_49759);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49801 = f__47916__auto__();
(statearr_49801[(6)] = c__47915__auto___50748);

return statearr_49801;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.merge.cljs$lang$maxFixedArity = 2);

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__49803 = arguments.length;
switch (G__49803) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50763 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49827){
var state_val_49828 = (state_49827[(1)]);
if((state_val_49828 === (7))){
var inst_49809 = (state_49827[(7)]);
var inst_49809__$1 = (state_49827[(2)]);
var inst_49810 = (inst_49809__$1 == null);
var inst_49811 = cljs.core.not(inst_49810);
var state_49827__$1 = (function (){var statearr_49829 = state_49827;
(statearr_49829[(7)] = inst_49809__$1);

return statearr_49829;
})();
if(inst_49811){
var statearr_49830_50764 = state_49827__$1;
(statearr_49830_50764[(1)] = (8));

} else {
var statearr_49831_50768 = state_49827__$1;
(statearr_49831_50768[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (1))){
var inst_49804 = (0);
var state_49827__$1 = (function (){var statearr_49832 = state_49827;
(statearr_49832[(8)] = inst_49804);

return statearr_49832;
})();
var statearr_49833_50769 = state_49827__$1;
(statearr_49833_50769[(2)] = null);

(statearr_49833_50769[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (4))){
var state_49827__$1 = state_49827;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49827__$1,(7),ch);
} else {
if((state_val_49828 === (6))){
var inst_49822 = (state_49827[(2)]);
var state_49827__$1 = state_49827;
var statearr_49847_50770 = state_49827__$1;
(statearr_49847_50770[(2)] = inst_49822);

(statearr_49847_50770[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (3))){
var inst_49824 = (state_49827[(2)]);
var inst_49825 = cljs.core.async.close_BANG_(out);
var state_49827__$1 = (function (){var statearr_49848 = state_49827;
(statearr_49848[(9)] = inst_49824);

return statearr_49848;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_49827__$1,inst_49825);
} else {
if((state_val_49828 === (2))){
var inst_49804 = (state_49827[(8)]);
var inst_49806 = (inst_49804 < n);
var state_49827__$1 = state_49827;
if(cljs.core.truth_(inst_49806)){
var statearr_49849_50771 = state_49827__$1;
(statearr_49849_50771[(1)] = (4));

} else {
var statearr_49850_50772 = state_49827__$1;
(statearr_49850_50772[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (11))){
var inst_49804 = (state_49827[(8)]);
var inst_49814 = (state_49827[(2)]);
var inst_49815 = (inst_49804 + (1));
var inst_49804__$1 = inst_49815;
var state_49827__$1 = (function (){var statearr_49851 = state_49827;
(statearr_49851[(10)] = inst_49814);

(statearr_49851[(8)] = inst_49804__$1);

return statearr_49851;
})();
var statearr_49852_50773 = state_49827__$1;
(statearr_49852_50773[(2)] = null);

(statearr_49852_50773[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (9))){
var state_49827__$1 = state_49827;
var statearr_49853_50778 = state_49827__$1;
(statearr_49853_50778[(2)] = null);

(statearr_49853_50778[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (5))){
var state_49827__$1 = state_49827;
var statearr_49854_50779 = state_49827__$1;
(statearr_49854_50779[(2)] = null);

(statearr_49854_50779[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (10))){
var inst_49819 = (state_49827[(2)]);
var state_49827__$1 = state_49827;
var statearr_49855_50783 = state_49827__$1;
(statearr_49855_50783[(2)] = inst_49819);

(statearr_49855_50783[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49828 === (8))){
var inst_49809 = (state_49827[(7)]);
var state_49827__$1 = state_49827;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49827__$1,(11),out,inst_49809);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_49856 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_49856[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_49856[(1)] = (1));

return statearr_49856;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_49827){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49827);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e49857){var ex__47855__auto__ = e49857;
var statearr_49858_50784 = state_49827;
(statearr_49858_50784[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49827[(4)]))){
var statearr_49859_50785 = state_49827;
(statearr_49859_50785[(1)] = cljs.core.first((state_49827[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50786 = state_49827;
state_49827 = G__50786;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_49827){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_49827);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_49860 = f__47916__auto__();
(statearr_49860[(6)] = c__47915__auto___50763);

return statearr_49860;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.take.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49862 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49862 = (function (f,ch,meta49863){
this.f = f;
this.ch = ch;
this.meta49863 = meta49863;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49864,meta49863__$1){
var self__ = this;
var _49864__$1 = this;
return (new cljs.core.async.t_cljs$core$async49862(self__.f,self__.ch,meta49863__$1));
}));

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49864){
var self__ = this;
var _49864__$1 = this;
return self__.meta49863;
}));

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49878 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49878 = (function (f,ch,meta49863,_,fn1,meta49879){
this.f = f;
this.ch = ch;
this.meta49863 = meta49863;
this._ = _;
this.fn1 = fn1;
this.meta49879 = meta49879;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49880,meta49879__$1){
var self__ = this;
var _49880__$1 = this;
return (new cljs.core.async.t_cljs$core$async49878(self__.f,self__.ch,self__.meta49863,self__._,self__.fn1,meta49879__$1));
}));

(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49880){
var self__ = this;
var _49880__$1 = this;
return self__.meta49879;
}));

(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
}));

(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
}));

(cljs.core.async.t_cljs$core$async49878.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return (function (p1__49861_SHARP_){
var G__49894 = (((p1__49861_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__49861_SHARP_) : self__.f.call(null,p1__49861_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__49894) : f1.call(null,G__49894));
});
}));

(cljs.core.async.t_cljs$core$async49878.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta49863","meta49863",-1793965866,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async49862","cljs.core.async/t_cljs$core$async49862",-1402362378,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta49879","meta49879",1142047786,null)], null);
}));

(cljs.core.async.t_cljs$core$async49878.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49878.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49878");

(cljs.core.async.t_cljs$core$async49878.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49878");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49878.
 */
cljs.core.async.__GT_t_cljs$core$async49878 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async49878(f__$1,ch__$1,meta49863__$1,___$2,fn1__$1,meta49879){
return (new cljs.core.async.t_cljs$core$async49878(f__$1,ch__$1,meta49863__$1,___$2,fn1__$1,meta49879));
});

}

return (new cljs.core.async.t_cljs$core$async49878(self__.f,self__.ch,self__.meta49863,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4221__auto__ = ret;
if(cljs.core.truth_(and__4221__auto__)){
return (!((cljs.core.deref(ret) == null)));
} else {
return and__4221__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__49895 = cljs.core.deref(ret);
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__49895) : self__.f.call(null,G__49895));
})());
} else {
return ret;
}
}));

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49862.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
}));

(cljs.core.async.t_cljs$core$async49862.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta49863","meta49863",-1793965866,null)], null);
}));

(cljs.core.async.t_cljs$core$async49862.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49862.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49862");

(cljs.core.async.t_cljs$core$async49862.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49862");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49862.
 */
cljs.core.async.__GT_t_cljs$core$async49862 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async49862(f__$1,ch__$1,meta49863){
return (new cljs.core.async.t_cljs$core$async49862(f__$1,ch__$1,meta49863));
});

}

return (new cljs.core.async.t_cljs$core$async49862(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49905 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49905 = (function (f,ch,meta49906){
this.f = f;
this.ch = ch;
this.meta49906 = meta49906;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49907,meta49906__$1){
var self__ = this;
var _49907__$1 = this;
return (new cljs.core.async.t_cljs$core$async49905(self__.f,self__.ch,meta49906__$1));
}));

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49907){
var self__ = this;
var _49907__$1 = this;
return self__.meta49906;
}));

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49905.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
}));

(cljs.core.async.t_cljs$core$async49905.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta49906","meta49906",1476480118,null)], null);
}));

(cljs.core.async.t_cljs$core$async49905.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49905.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49905");

(cljs.core.async.t_cljs$core$async49905.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49905");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49905.
 */
cljs.core.async.__GT_t_cljs$core$async49905 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async49905(f__$1,ch__$1,meta49906){
return (new cljs.core.async.t_cljs$core$async49905(f__$1,ch__$1,meta49906));
});

}

return (new cljs.core.async.t_cljs$core$async49905(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async49947 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async49947 = (function (p,ch,meta49948){
this.p = p;
this.ch = ch;
this.meta49948 = meta49948;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_49949,meta49948__$1){
var self__ = this;
var _49949__$1 = this;
return (new cljs.core.async.t_cljs$core$async49947(self__.p,self__.ch,meta49948__$1));
}));

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_49949){
var self__ = this;
var _49949__$1 = this;
return self__.meta49948;
}));

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
}));

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
}));

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL);

(cljs.core.async.t_cljs$core$async49947.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
}));

(cljs.core.async.t_cljs$core$async49947.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta49948","meta49948",-1886636565,null)], null);
}));

(cljs.core.async.t_cljs$core$async49947.cljs$lang$type = true);

(cljs.core.async.t_cljs$core$async49947.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async49947");

(cljs.core.async.t_cljs$core$async49947.cljs$lang$ctorPrWriter = (function (this__4461__auto__,writer__4462__auto__,opt__4463__auto__){
return cljs.core._write(writer__4462__auto__,"cljs.core.async/t_cljs$core$async49947");
}));

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async49947.
 */
cljs.core.async.__GT_t_cljs$core$async49947 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async49947(p__$1,ch__$1,meta49948){
return (new cljs.core.async.t_cljs$core$async49947(p__$1,ch__$1,meta49948));
});

}

return (new cljs.core.async.t_cljs$core$async49947(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__49968 = arguments.length;
switch (G__49968) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50798 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_49989){
var state_val_49990 = (state_49989[(1)]);
if((state_val_49990 === (7))){
var inst_49985 = (state_49989[(2)]);
var state_49989__$1 = state_49989;
var statearr_49991_50799 = state_49989__$1;
(statearr_49991_50799[(2)] = inst_49985);

(statearr_49991_50799[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (1))){
var state_49989__$1 = state_49989;
var statearr_49992_50800 = state_49989__$1;
(statearr_49992_50800[(2)] = null);

(statearr_49992_50800[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (4))){
var inst_49971 = (state_49989[(7)]);
var inst_49971__$1 = (state_49989[(2)]);
var inst_49972 = (inst_49971__$1 == null);
var state_49989__$1 = (function (){var statearr_49993 = state_49989;
(statearr_49993[(7)] = inst_49971__$1);

return statearr_49993;
})();
if(cljs.core.truth_(inst_49972)){
var statearr_49994_50801 = state_49989__$1;
(statearr_49994_50801[(1)] = (5));

} else {
var statearr_49995_50802 = state_49989__$1;
(statearr_49995_50802[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (6))){
var inst_49971 = (state_49989[(7)]);
var inst_49976 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_49971) : p.call(null,inst_49971));
var state_49989__$1 = state_49989;
if(cljs.core.truth_(inst_49976)){
var statearr_49996_50803 = state_49989__$1;
(statearr_49996_50803[(1)] = (8));

} else {
var statearr_49997_50804 = state_49989__$1;
(statearr_49997_50804[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (3))){
var inst_49987 = (state_49989[(2)]);
var state_49989__$1 = state_49989;
return cljs.core.async.impl.ioc_helpers.return_chan(state_49989__$1,inst_49987);
} else {
if((state_val_49990 === (2))){
var state_49989__$1 = state_49989;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_49989__$1,(4),ch);
} else {
if((state_val_49990 === (11))){
var inst_49979 = (state_49989[(2)]);
var state_49989__$1 = state_49989;
var statearr_49998_50805 = state_49989__$1;
(statearr_49998_50805[(2)] = inst_49979);

(statearr_49998_50805[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (9))){
var state_49989__$1 = state_49989;
var statearr_49999_50806 = state_49989__$1;
(statearr_49999_50806[(2)] = null);

(statearr_49999_50806[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (5))){
var inst_49974 = cljs.core.async.close_BANG_(out);
var state_49989__$1 = state_49989;
var statearr_50000_50807 = state_49989__$1;
(statearr_50000_50807[(2)] = inst_49974);

(statearr_50000_50807[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (10))){
var inst_49982 = (state_49989[(2)]);
var state_49989__$1 = (function (){var statearr_50001 = state_49989;
(statearr_50001[(8)] = inst_49982);

return statearr_50001;
})();
var statearr_50002_50808 = state_49989__$1;
(statearr_50002_50808[(2)] = null);

(statearr_50002_50808[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_49990 === (8))){
var inst_49971 = (state_49989[(7)]);
var state_49989__$1 = state_49989;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_49989__$1,(11),out,inst_49971);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_50003 = [null,null,null,null,null,null,null,null,null];
(statearr_50003[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_50003[(1)] = (1));

return statearr_50003;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_49989){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_49989);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e50004){var ex__47855__auto__ = e50004;
var statearr_50005_50809 = state_49989;
(statearr_50005_50809[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_49989[(4)]))){
var statearr_50006_50810 = state_49989;
(statearr_50006_50810[(1)] = cljs.core.first((state_49989[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50811 = state_49989;
state_49989 = G__50811;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_49989){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_49989);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_50007 = f__47916__auto__();
(statearr_50007[(6)] = c__47915__auto___50798);

return statearr_50007;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__50009 = arguments.length;
switch (G__50009) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
}));

(cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
}));

(cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3);

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__47915__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_50071){
var state_val_50072 = (state_50071[(1)]);
if((state_val_50072 === (7))){
var inst_50067 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
var statearr_50073_50813 = state_50071__$1;
(statearr_50073_50813[(2)] = inst_50067);

(statearr_50073_50813[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (20))){
var inst_50037 = (state_50071[(7)]);
var inst_50048 = (state_50071[(2)]);
var inst_50049 = cljs.core.next(inst_50037);
var inst_50023 = inst_50049;
var inst_50024 = null;
var inst_50025 = (0);
var inst_50026 = (0);
var state_50071__$1 = (function (){var statearr_50074 = state_50071;
(statearr_50074[(8)] = inst_50025);

(statearr_50074[(9)] = inst_50024);

(statearr_50074[(10)] = inst_50023);

(statearr_50074[(11)] = inst_50026);

(statearr_50074[(12)] = inst_50048);

return statearr_50074;
})();
var statearr_50075_50814 = state_50071__$1;
(statearr_50075_50814[(2)] = null);

(statearr_50075_50814[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (1))){
var state_50071__$1 = state_50071;
var statearr_50076_50815 = state_50071__$1;
(statearr_50076_50815[(2)] = null);

(statearr_50076_50815[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (4))){
var inst_50012 = (state_50071[(13)]);
var inst_50012__$1 = (state_50071[(2)]);
var inst_50013 = (inst_50012__$1 == null);
var state_50071__$1 = (function (){var statearr_50077 = state_50071;
(statearr_50077[(13)] = inst_50012__$1);

return statearr_50077;
})();
if(cljs.core.truth_(inst_50013)){
var statearr_50078_50816 = state_50071__$1;
(statearr_50078_50816[(1)] = (5));

} else {
var statearr_50079_50817 = state_50071__$1;
(statearr_50079_50817[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (15))){
var state_50071__$1 = state_50071;
var statearr_50083_50818 = state_50071__$1;
(statearr_50083_50818[(2)] = null);

(statearr_50083_50818[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (21))){
var state_50071__$1 = state_50071;
var statearr_50084_50819 = state_50071__$1;
(statearr_50084_50819[(2)] = null);

(statearr_50084_50819[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (13))){
var inst_50025 = (state_50071[(8)]);
var inst_50024 = (state_50071[(9)]);
var inst_50023 = (state_50071[(10)]);
var inst_50026 = (state_50071[(11)]);
var inst_50033 = (state_50071[(2)]);
var inst_50034 = (inst_50026 + (1));
var tmp50080 = inst_50025;
var tmp50081 = inst_50024;
var tmp50082 = inst_50023;
var inst_50023__$1 = tmp50082;
var inst_50024__$1 = tmp50081;
var inst_50025__$1 = tmp50080;
var inst_50026__$1 = inst_50034;
var state_50071__$1 = (function (){var statearr_50085 = state_50071;
(statearr_50085[(8)] = inst_50025__$1);

(statearr_50085[(14)] = inst_50033);

(statearr_50085[(9)] = inst_50024__$1);

(statearr_50085[(10)] = inst_50023__$1);

(statearr_50085[(11)] = inst_50026__$1);

return statearr_50085;
})();
var statearr_50086_50820 = state_50071__$1;
(statearr_50086_50820[(2)] = null);

(statearr_50086_50820[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (22))){
var state_50071__$1 = state_50071;
var statearr_50087_50821 = state_50071__$1;
(statearr_50087_50821[(2)] = null);

(statearr_50087_50821[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (6))){
var inst_50012 = (state_50071[(13)]);
var inst_50021 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_50012) : f.call(null,inst_50012));
var inst_50022 = cljs.core.seq(inst_50021);
var inst_50023 = inst_50022;
var inst_50024 = null;
var inst_50025 = (0);
var inst_50026 = (0);
var state_50071__$1 = (function (){var statearr_50088 = state_50071;
(statearr_50088[(8)] = inst_50025);

(statearr_50088[(9)] = inst_50024);

(statearr_50088[(10)] = inst_50023);

(statearr_50088[(11)] = inst_50026);

return statearr_50088;
})();
var statearr_50089_50822 = state_50071__$1;
(statearr_50089_50822[(2)] = null);

(statearr_50089_50822[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (17))){
var inst_50037 = (state_50071[(7)]);
var inst_50041 = cljs.core.chunk_first(inst_50037);
var inst_50042 = cljs.core.chunk_rest(inst_50037);
var inst_50043 = cljs.core.count(inst_50041);
var inst_50023 = inst_50042;
var inst_50024 = inst_50041;
var inst_50025 = inst_50043;
var inst_50026 = (0);
var state_50071__$1 = (function (){var statearr_50090 = state_50071;
(statearr_50090[(8)] = inst_50025);

(statearr_50090[(9)] = inst_50024);

(statearr_50090[(10)] = inst_50023);

(statearr_50090[(11)] = inst_50026);

return statearr_50090;
})();
var statearr_50091_50823 = state_50071__$1;
(statearr_50091_50823[(2)] = null);

(statearr_50091_50823[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (3))){
var inst_50069 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
return cljs.core.async.impl.ioc_helpers.return_chan(state_50071__$1,inst_50069);
} else {
if((state_val_50072 === (12))){
var inst_50057 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
var statearr_50092_50824 = state_50071__$1;
(statearr_50092_50824[(2)] = inst_50057);

(statearr_50092_50824[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (2))){
var state_50071__$1 = state_50071;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_50071__$1,(4),in$);
} else {
if((state_val_50072 === (23))){
var inst_50065 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
var statearr_50093_50825 = state_50071__$1;
(statearr_50093_50825[(2)] = inst_50065);

(statearr_50093_50825[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (19))){
var inst_50052 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
var statearr_50094_50826 = state_50071__$1;
(statearr_50094_50826[(2)] = inst_50052);

(statearr_50094_50826[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (11))){
var inst_50037 = (state_50071[(7)]);
var inst_50023 = (state_50071[(10)]);
var inst_50037__$1 = cljs.core.seq(inst_50023);
var state_50071__$1 = (function (){var statearr_50095 = state_50071;
(statearr_50095[(7)] = inst_50037__$1);

return statearr_50095;
})();
if(inst_50037__$1){
var statearr_50096_50827 = state_50071__$1;
(statearr_50096_50827[(1)] = (14));

} else {
var statearr_50097_50828 = state_50071__$1;
(statearr_50097_50828[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (9))){
var inst_50059 = (state_50071[(2)]);
var inst_50060 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_50071__$1 = (function (){var statearr_50098 = state_50071;
(statearr_50098[(15)] = inst_50059);

return statearr_50098;
})();
if(cljs.core.truth_(inst_50060)){
var statearr_50099_50829 = state_50071__$1;
(statearr_50099_50829[(1)] = (21));

} else {
var statearr_50100_50830 = state_50071__$1;
(statearr_50100_50830[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (5))){
var inst_50015 = cljs.core.async.close_BANG_(out);
var state_50071__$1 = state_50071;
var statearr_50101_50831 = state_50071__$1;
(statearr_50101_50831[(2)] = inst_50015);

(statearr_50101_50831[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (14))){
var inst_50037 = (state_50071[(7)]);
var inst_50039 = cljs.core.chunked_seq_QMARK_(inst_50037);
var state_50071__$1 = state_50071;
if(inst_50039){
var statearr_50102_50832 = state_50071__$1;
(statearr_50102_50832[(1)] = (17));

} else {
var statearr_50103_50833 = state_50071__$1;
(statearr_50103_50833[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (16))){
var inst_50055 = (state_50071[(2)]);
var state_50071__$1 = state_50071;
var statearr_50104_50834 = state_50071__$1;
(statearr_50104_50834[(2)] = inst_50055);

(statearr_50104_50834[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50072 === (10))){
var inst_50024 = (state_50071[(9)]);
var inst_50026 = (state_50071[(11)]);
var inst_50031 = cljs.core._nth(inst_50024,inst_50026);
var state_50071__$1 = state_50071;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50071__$1,(13),out,inst_50031);
} else {
if((state_val_50072 === (18))){
var inst_50037 = (state_50071[(7)]);
var inst_50046 = cljs.core.first(inst_50037);
var state_50071__$1 = state_50071;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50071__$1,(20),out,inst_50046);
} else {
if((state_val_50072 === (8))){
var inst_50025 = (state_50071[(8)]);
var inst_50026 = (state_50071[(11)]);
var inst_50028 = (inst_50026 < inst_50025);
var inst_50029 = inst_50028;
var state_50071__$1 = state_50071;
if(cljs.core.truth_(inst_50029)){
var statearr_50105_50835 = state_50071__$1;
(statearr_50105_50835[(1)] = (10));

} else {
var statearr_50106_50836 = state_50071__$1;
(statearr_50106_50836[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____0 = (function (){
var statearr_50107 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_50107[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__);

(statearr_50107[(1)] = (1));

return statearr_50107;
});
var cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____1 = (function (state_50071){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_50071);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e50108){var ex__47855__auto__ = e50108;
var statearr_50109_50837 = state_50071;
(statearr_50109_50837[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_50071[(4)]))){
var statearr_50110_50838 = state_50071;
(statearr_50110_50838[(1)] = cljs.core.first((state_50071[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50839 = state_50071;
state_50071 = G__50839;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__ = function(state_50071){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____1.call(this,state_50071);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__47852__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_50111 = f__47916__auto__();
(statearr_50111[(6)] = c__47915__auto__);

return statearr_50111;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));

return c__47915__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__50113 = arguments.length;
switch (G__50113) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
}));

(cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
}));

(cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__50115 = arguments.length;
switch (G__50115) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
}));

(cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
}));

(cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__50117 = arguments.length;
switch (G__50117) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
}));

(cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50843 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_50141){
var state_val_50142 = (state_50141[(1)]);
if((state_val_50142 === (7))){
var inst_50136 = (state_50141[(2)]);
var state_50141__$1 = state_50141;
var statearr_50143_50844 = state_50141__$1;
(statearr_50143_50844[(2)] = inst_50136);

(statearr_50143_50844[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (1))){
var inst_50118 = null;
var state_50141__$1 = (function (){var statearr_50144 = state_50141;
(statearr_50144[(7)] = inst_50118);

return statearr_50144;
})();
var statearr_50145_50845 = state_50141__$1;
(statearr_50145_50845[(2)] = null);

(statearr_50145_50845[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (4))){
var inst_50121 = (state_50141[(8)]);
var inst_50121__$1 = (state_50141[(2)]);
var inst_50122 = (inst_50121__$1 == null);
var inst_50123 = cljs.core.not(inst_50122);
var state_50141__$1 = (function (){var statearr_50146 = state_50141;
(statearr_50146[(8)] = inst_50121__$1);

return statearr_50146;
})();
if(inst_50123){
var statearr_50147_50846 = state_50141__$1;
(statearr_50147_50846[(1)] = (5));

} else {
var statearr_50148_50847 = state_50141__$1;
(statearr_50148_50847[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (6))){
var state_50141__$1 = state_50141;
var statearr_50149_50848 = state_50141__$1;
(statearr_50149_50848[(2)] = null);

(statearr_50149_50848[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (3))){
var inst_50138 = (state_50141[(2)]);
var inst_50139 = cljs.core.async.close_BANG_(out);
var state_50141__$1 = (function (){var statearr_50150 = state_50141;
(statearr_50150[(9)] = inst_50138);

return statearr_50150;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_50141__$1,inst_50139);
} else {
if((state_val_50142 === (2))){
var state_50141__$1 = state_50141;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_50141__$1,(4),ch);
} else {
if((state_val_50142 === (11))){
var inst_50121 = (state_50141[(8)]);
var inst_50130 = (state_50141[(2)]);
var inst_50118 = inst_50121;
var state_50141__$1 = (function (){var statearr_50151 = state_50141;
(statearr_50151[(10)] = inst_50130);

(statearr_50151[(7)] = inst_50118);

return statearr_50151;
})();
var statearr_50152_50849 = state_50141__$1;
(statearr_50152_50849[(2)] = null);

(statearr_50152_50849[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (9))){
var inst_50121 = (state_50141[(8)]);
var state_50141__$1 = state_50141;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50141__$1,(11),out,inst_50121);
} else {
if((state_val_50142 === (5))){
var inst_50121 = (state_50141[(8)]);
var inst_50118 = (state_50141[(7)]);
var inst_50125 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_50121,inst_50118);
var state_50141__$1 = state_50141;
if(inst_50125){
var statearr_50154_50850 = state_50141__$1;
(statearr_50154_50850[(1)] = (8));

} else {
var statearr_50155_50851 = state_50141__$1;
(statearr_50155_50851[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (10))){
var inst_50133 = (state_50141[(2)]);
var state_50141__$1 = state_50141;
var statearr_50156_50852 = state_50141__$1;
(statearr_50156_50852[(2)] = inst_50133);

(statearr_50156_50852[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50142 === (8))){
var inst_50118 = (state_50141[(7)]);
var tmp50153 = inst_50118;
var inst_50118__$1 = tmp50153;
var state_50141__$1 = (function (){var statearr_50157 = state_50141;
(statearr_50157[(7)] = inst_50118__$1);

return statearr_50157;
})();
var statearr_50158_50853 = state_50141__$1;
(statearr_50158_50853[(2)] = null);

(statearr_50158_50853[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_50159 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_50159[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_50159[(1)] = (1));

return statearr_50159;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_50141){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_50141);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e50160){var ex__47855__auto__ = e50160;
var statearr_50161_50854 = state_50141;
(statearr_50161_50854[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_50141[(4)]))){
var statearr_50162_50855 = state_50141;
(statearr_50162_50855[(1)] = cljs.core.first((state_50141[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50856 = state_50141;
state_50141 = G__50856;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_50141){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_50141);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_50163 = f__47916__auto__();
(statearr_50163[(6)] = c__47915__auto___50843);

return statearr_50163;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.unique.cljs$lang$maxFixedArity = 2);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__50165 = arguments.length;
switch (G__50165) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
}));

(cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50858 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_50203){
var state_val_50204 = (state_50203[(1)]);
if((state_val_50204 === (7))){
var inst_50199 = (state_50203[(2)]);
var state_50203__$1 = state_50203;
var statearr_50205_50859 = state_50203__$1;
(statearr_50205_50859[(2)] = inst_50199);

(statearr_50205_50859[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (1))){
var inst_50166 = (new Array(n));
var inst_50167 = inst_50166;
var inst_50168 = (0);
var state_50203__$1 = (function (){var statearr_50206 = state_50203;
(statearr_50206[(7)] = inst_50167);

(statearr_50206[(8)] = inst_50168);

return statearr_50206;
})();
var statearr_50207_50860 = state_50203__$1;
(statearr_50207_50860[(2)] = null);

(statearr_50207_50860[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (4))){
var inst_50171 = (state_50203[(9)]);
var inst_50171__$1 = (state_50203[(2)]);
var inst_50172 = (inst_50171__$1 == null);
var inst_50173 = cljs.core.not(inst_50172);
var state_50203__$1 = (function (){var statearr_50208 = state_50203;
(statearr_50208[(9)] = inst_50171__$1);

return statearr_50208;
})();
if(inst_50173){
var statearr_50209_50861 = state_50203__$1;
(statearr_50209_50861[(1)] = (5));

} else {
var statearr_50210_50862 = state_50203__$1;
(statearr_50210_50862[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (15))){
var inst_50193 = (state_50203[(2)]);
var state_50203__$1 = state_50203;
var statearr_50211_50863 = state_50203__$1;
(statearr_50211_50863[(2)] = inst_50193);

(statearr_50211_50863[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (13))){
var state_50203__$1 = state_50203;
var statearr_50212_50864 = state_50203__$1;
(statearr_50212_50864[(2)] = null);

(statearr_50212_50864[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (6))){
var inst_50168 = (state_50203[(8)]);
var inst_50189 = (inst_50168 > (0));
var state_50203__$1 = state_50203;
if(cljs.core.truth_(inst_50189)){
var statearr_50213_50866 = state_50203__$1;
(statearr_50213_50866[(1)] = (12));

} else {
var statearr_50214_50867 = state_50203__$1;
(statearr_50214_50867[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (3))){
var inst_50201 = (state_50203[(2)]);
var state_50203__$1 = state_50203;
return cljs.core.async.impl.ioc_helpers.return_chan(state_50203__$1,inst_50201);
} else {
if((state_val_50204 === (12))){
var inst_50167 = (state_50203[(7)]);
var inst_50191 = cljs.core.vec(inst_50167);
var state_50203__$1 = state_50203;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50203__$1,(15),out,inst_50191);
} else {
if((state_val_50204 === (2))){
var state_50203__$1 = state_50203;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_50203__$1,(4),ch);
} else {
if((state_val_50204 === (11))){
var inst_50183 = (state_50203[(2)]);
var inst_50184 = (new Array(n));
var inst_50167 = inst_50184;
var inst_50168 = (0);
var state_50203__$1 = (function (){var statearr_50217 = state_50203;
(statearr_50217[(7)] = inst_50167);

(statearr_50217[(10)] = inst_50183);

(statearr_50217[(8)] = inst_50168);

return statearr_50217;
})();
var statearr_50224_50868 = state_50203__$1;
(statearr_50224_50868[(2)] = null);

(statearr_50224_50868[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (9))){
var inst_50167 = (state_50203[(7)]);
var inst_50181 = cljs.core.vec(inst_50167);
var state_50203__$1 = state_50203;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50203__$1,(11),out,inst_50181);
} else {
if((state_val_50204 === (5))){
var inst_50167 = (state_50203[(7)]);
var inst_50171 = (state_50203[(9)]);
var inst_50168 = (state_50203[(8)]);
var inst_50176 = (state_50203[(11)]);
var inst_50175 = (inst_50167[inst_50168] = inst_50171);
var inst_50176__$1 = (inst_50168 + (1));
var inst_50177 = (inst_50176__$1 < n);
var state_50203__$1 = (function (){var statearr_50226 = state_50203;
(statearr_50226[(12)] = inst_50175);

(statearr_50226[(11)] = inst_50176__$1);

return statearr_50226;
})();
if(cljs.core.truth_(inst_50177)){
var statearr_50227_50869 = state_50203__$1;
(statearr_50227_50869[(1)] = (8));

} else {
var statearr_50228_50870 = state_50203__$1;
(statearr_50228_50870[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (14))){
var inst_50196 = (state_50203[(2)]);
var inst_50197 = cljs.core.async.close_BANG_(out);
var state_50203__$1 = (function (){var statearr_50230 = state_50203;
(statearr_50230[(13)] = inst_50196);

return statearr_50230;
})();
var statearr_50231_50872 = state_50203__$1;
(statearr_50231_50872[(2)] = inst_50197);

(statearr_50231_50872[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (10))){
var inst_50187 = (state_50203[(2)]);
var state_50203__$1 = state_50203;
var statearr_50232_50873 = state_50203__$1;
(statearr_50232_50873[(2)] = inst_50187);

(statearr_50232_50873[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50204 === (8))){
var inst_50167 = (state_50203[(7)]);
var inst_50176 = (state_50203[(11)]);
var tmp50229 = inst_50167;
var inst_50167__$1 = tmp50229;
var inst_50168 = inst_50176;
var state_50203__$1 = (function (){var statearr_50233 = state_50203;
(statearr_50233[(7)] = inst_50167__$1);

(statearr_50233[(8)] = inst_50168);

return statearr_50233;
})();
var statearr_50234_50875 = state_50203__$1;
(statearr_50234_50875[(2)] = null);

(statearr_50234_50875[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_50235 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_50235[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_50235[(1)] = (1));

return statearr_50235;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_50203){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_50203);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e50236){var ex__47855__auto__ = e50236;
var statearr_50237_50876 = state_50203;
(statearr_50237_50876[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_50203[(4)]))){
var statearr_50238_50877 = state_50203;
(statearr_50238_50877[(1)] = cljs.core.first((state_50203[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50878 = state_50203;
state_50203 = G__50878;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_50203){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_50203);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_50239 = f__47916__auto__();
(statearr_50239[(6)] = c__47915__auto___50858);

return statearr_50239;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.partition.cljs$lang$maxFixedArity = 3);

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__50241 = arguments.length;
switch (G__50241) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
}));

(cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__47915__auto___50882 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__47916__auto__ = (function (){var switch__47851__auto__ = (function (state_50287){
var state_val_50288 = (state_50287[(1)]);
if((state_val_50288 === (7))){
var inst_50283 = (state_50287[(2)]);
var state_50287__$1 = state_50287;
var statearr_50289_50883 = state_50287__$1;
(statearr_50289_50883[(2)] = inst_50283);

(statearr_50289_50883[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (1))){
var inst_50242 = [];
var inst_50243 = inst_50242;
var inst_50244 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_50287__$1 = (function (){var statearr_50290 = state_50287;
(statearr_50290[(7)] = inst_50243);

(statearr_50290[(8)] = inst_50244);

return statearr_50290;
})();
var statearr_50291_50884 = state_50287__$1;
(statearr_50291_50884[(2)] = null);

(statearr_50291_50884[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (4))){
var inst_50247 = (state_50287[(9)]);
var inst_50247__$1 = (state_50287[(2)]);
var inst_50248 = (inst_50247__$1 == null);
var inst_50249 = cljs.core.not(inst_50248);
var state_50287__$1 = (function (){var statearr_50292 = state_50287;
(statearr_50292[(9)] = inst_50247__$1);

return statearr_50292;
})();
if(inst_50249){
var statearr_50293_50885 = state_50287__$1;
(statearr_50293_50885[(1)] = (5));

} else {
var statearr_50294_50886 = state_50287__$1;
(statearr_50294_50886[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (15))){
var inst_50243 = (state_50287[(7)]);
var inst_50275 = cljs.core.vec(inst_50243);
var state_50287__$1 = state_50287;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50287__$1,(18),out,inst_50275);
} else {
if((state_val_50288 === (13))){
var inst_50270 = (state_50287[(2)]);
var state_50287__$1 = state_50287;
var statearr_50295_50887 = state_50287__$1;
(statearr_50295_50887[(2)] = inst_50270);

(statearr_50295_50887[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (6))){
var inst_50243 = (state_50287[(7)]);
var inst_50272 = inst_50243.length;
var inst_50273 = (inst_50272 > (0));
var state_50287__$1 = state_50287;
if(cljs.core.truth_(inst_50273)){
var statearr_50296_50889 = state_50287__$1;
(statearr_50296_50889[(1)] = (15));

} else {
var statearr_50297_50890 = state_50287__$1;
(statearr_50297_50890[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (17))){
var inst_50280 = (state_50287[(2)]);
var inst_50281 = cljs.core.async.close_BANG_(out);
var state_50287__$1 = (function (){var statearr_50298 = state_50287;
(statearr_50298[(10)] = inst_50280);

return statearr_50298;
})();
var statearr_50299_50892 = state_50287__$1;
(statearr_50299_50892[(2)] = inst_50281);

(statearr_50299_50892[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (3))){
var inst_50285 = (state_50287[(2)]);
var state_50287__$1 = state_50287;
return cljs.core.async.impl.ioc_helpers.return_chan(state_50287__$1,inst_50285);
} else {
if((state_val_50288 === (12))){
var inst_50243 = (state_50287[(7)]);
var inst_50263 = cljs.core.vec(inst_50243);
var state_50287__$1 = state_50287;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_50287__$1,(14),out,inst_50263);
} else {
if((state_val_50288 === (2))){
var state_50287__$1 = state_50287;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_50287__$1,(4),ch);
} else {
if((state_val_50288 === (11))){
var inst_50247 = (state_50287[(9)]);
var inst_50243 = (state_50287[(7)]);
var inst_50252 = (state_50287[(11)]);
var inst_50260 = inst_50243.push(inst_50247);
var tmp50300 = inst_50243;
var inst_50243__$1 = tmp50300;
var inst_50244 = inst_50252;
var state_50287__$1 = (function (){var statearr_50301 = state_50287;
(statearr_50301[(7)] = inst_50243__$1);

(statearr_50301[(8)] = inst_50244);

(statearr_50301[(12)] = inst_50260);

return statearr_50301;
})();
var statearr_50302_50895 = state_50287__$1;
(statearr_50302_50895[(2)] = null);

(statearr_50302_50895[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (9))){
var inst_50244 = (state_50287[(8)]);
var inst_50256 = cljs.core.keyword_identical_QMARK_(inst_50244,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var state_50287__$1 = state_50287;
var statearr_50306_50896 = state_50287__$1;
(statearr_50306_50896[(2)] = inst_50256);

(statearr_50306_50896[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (5))){
var inst_50247 = (state_50287[(9)]);
var inst_50253 = (state_50287[(13)]);
var inst_50244 = (state_50287[(8)]);
var inst_50252 = (state_50287[(11)]);
var inst_50252__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_50247) : f.call(null,inst_50247));
var inst_50253__$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_50252__$1,inst_50244);
var state_50287__$1 = (function (){var statearr_50310 = state_50287;
(statearr_50310[(13)] = inst_50253__$1);

(statearr_50310[(11)] = inst_50252__$1);

return statearr_50310;
})();
if(inst_50253__$1){
var statearr_50311_50897 = state_50287__$1;
(statearr_50311_50897[(1)] = (8));

} else {
var statearr_50312_50898 = state_50287__$1;
(statearr_50312_50898[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (14))){
var inst_50247 = (state_50287[(9)]);
var inst_50252 = (state_50287[(11)]);
var inst_50265 = (state_50287[(2)]);
var inst_50266 = [];
var inst_50267 = inst_50266.push(inst_50247);
var inst_50243 = inst_50266;
var inst_50244 = inst_50252;
var state_50287__$1 = (function (){var statearr_50315 = state_50287;
(statearr_50315[(14)] = inst_50265);

(statearr_50315[(7)] = inst_50243);

(statearr_50315[(8)] = inst_50244);

(statearr_50315[(15)] = inst_50267);

return statearr_50315;
})();
var statearr_50317_50899 = state_50287__$1;
(statearr_50317_50899[(2)] = null);

(statearr_50317_50899[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (16))){
var state_50287__$1 = state_50287;
var statearr_50320_50900 = state_50287__$1;
(statearr_50320_50900[(2)] = null);

(statearr_50320_50900[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (10))){
var inst_50258 = (state_50287[(2)]);
var state_50287__$1 = state_50287;
if(cljs.core.truth_(inst_50258)){
var statearr_50322_50901 = state_50287__$1;
(statearr_50322_50901[(1)] = (11));

} else {
var statearr_50323_50902 = state_50287__$1;
(statearr_50323_50902[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (18))){
var inst_50277 = (state_50287[(2)]);
var state_50287__$1 = state_50287;
var statearr_50324_50903 = state_50287__$1;
(statearr_50324_50903[(2)] = inst_50277);

(statearr_50324_50903[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_50288 === (8))){
var inst_50253 = (state_50287[(13)]);
var state_50287__$1 = state_50287;
var statearr_50325_50904 = state_50287__$1;
(statearr_50325_50904[(2)] = inst_50253);

(statearr_50325_50904[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var cljs$core$async$state_machine__47852__auto__ = null;
var cljs$core$async$state_machine__47852__auto____0 = (function (){
var statearr_50331 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_50331[(0)] = cljs$core$async$state_machine__47852__auto__);

(statearr_50331[(1)] = (1));

return statearr_50331;
});
var cljs$core$async$state_machine__47852__auto____1 = (function (state_50287){
while(true){
var ret_value__47853__auto__ = (function (){try{while(true){
var result__47854__auto__ = switch__47851__auto__(state_50287);
if(cljs.core.keyword_identical_QMARK_(result__47854__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__47854__auto__;
}
break;
}
}catch (e50334){var ex__47855__auto__ = e50334;
var statearr_50335_50905 = state_50287;
(statearr_50335_50905[(2)] = ex__47855__auto__);


if(cljs.core.seq((state_50287[(4)]))){
var statearr_50336_50906 = state_50287;
(statearr_50336_50906[(1)] = cljs.core.first((state_50287[(4)])));

} else {
throw ex__47855__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__47853__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__50907 = state_50287;
state_50287 = G__50907;
continue;
} else {
return ret_value__47853__auto__;
}
break;
}
});
cljs$core$async$state_machine__47852__auto__ = function(state_50287){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__47852__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__47852__auto____1.call(this,state_50287);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__47852__auto____0;
cljs$core$async$state_machine__47852__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__47852__auto____1;
return cljs$core$async$state_machine__47852__auto__;
})()
})();
var state__47917__auto__ = (function (){var statearr_50337 = f__47916__auto__();
(statearr_50337[(6)] = c__47915__auto___50882);

return statearr_50337;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__47917__auto__);
}));


return out;
}));

(cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3);


//# sourceMappingURL=cljs.core.async.js.map
